      SUBROUTINE ABCD
     1   (RRMAX,RTMAX,RZMAX,ERMAX,ETMAX,EZMAX,XACC,YACC,ZACC,NF,
     2   SUM1,SUM2,SUM3,SUM4,SUM5,SUM6,SUM7,SUM8,SUM9,
     2   SUM10,SUM11,SUM12,SUM13,SUM14,SUM15,SUM16,SUM17,SUM18,
     2   SUM19,SUM20,SUM21,SUM22,SUM23,SUM24,
     3   KMIN2,KMAX2,
     4   SINTOL,SRB,STHETAB,SZB,RZB,THETAZB,ZZB,ROTB,
     5   IMAXB,JMAXB,KMAXB,SUMDBZ,
     6   SUMWTSAVE,XWSAVE,YWSAVE,ZWSAVE,IGUESS,
     7   IREADABCD,OLAT,OLON,
     9   SLOPE1,CENTIME,TSTART,TEND,
     1   SMOTIONU,SMOTIONV,FLIGHTID,DBZTEST,RRRR,
     1   UGUESS,VGUESS,WGUESS,IREVERSE,IRAMSFILES,
     1   DISTXYZ,PIMAX,IJTEST,IVSPEED,VSPEED0,VFACTOR,TATF,IGRAPHICS,
     1   ZLOW,ZHIGH,HB2,DPB2,
     1   ISTORMLEVEL,IPLANE,IREALTIME,IVARIATIONAL,ISX,IAFTFORE,ISIGMET,
     1   ROLLTOL,NSKIP,IDBZADD,IDBZMASK,G4P3RADMIN,GROUNDADJUST,
     1   IATTEN,RADRAT,RADMASK,IAPPLYMASK,IUNDERONLY,
     1   JTRAKAZMMIN,JTRAKAZMMAX)
C
C **LEGACY REMOVE** IT LOOKS LIKE UGUESS, VGUESS, AND WGUESS ARE NEVER READ
C IN ANYWHERE, EVEN BEHIND A CONDITIONAL READ.  THEY SHOULD PROBABLY BE 
C REMOVED AS WELL AS ALL REFERENCES TO THEM, AT LEAST IN THE TRANSITION
C VERSION.  REMOVAL WILL ALSO NEED TO BE FROM PARAMETER LIST IN CALL TO
C ABCD **END LEGACY REMOVE**
C
C
C DEFINITIONS AND DESCRIPTIONS OF SUM1 TO SUM24 ARE FOUND BELOW WHEN THEY 
C             ARE SET IN THE CODE
C
C XWSAVE, YWSAVE AND ZWSAVE DEFINED BELOW
C
C RRMAX RADIAL RADIUS OF INFLUENCE FOR INTERPOLATION IN KM
C RTMAX AZIMUTHAL RADIUS OF INFLUENCE FOR INTERPOLATION IN DEG
C RZMAX VERTICAL RADIUS OF INFLUENCE FOR INTERPOLATION IN KM
C ERMAX RADIAL EFOLDING DISTANCE OF GAUSSIAN INTERPOLATER IN KM
C ETMAX AZIMUTHAL EFOLDING DISTANCE OF GAUSSIAN INTERPOLATER IN DEG
C EZMAX VERTICAL EFOLDING DISTANCE OF GAUSSIAN INTERPOLATER IN KM
C
C IGUESS         USE A GUESS WIND FIELD <(0)> NO (1) YES
C
C SINTOL MAXIMUM VALUE OF ABSOLUTE VALUE OF SINE OF ELEVATION ANGLE FOR
C DOPPLER RADIALS TO BE USED IN INTERPOLATION
C
C     SUMDBZ               - WEIGHTED AVG. REFLECTIVITY AT GRIDPOINT (I,J,K,L) 
C                          - during interpolation SUMDBZ is an accumulator
C     SUMWTSAVE            - ACCUMULATED WEIGHT AT GRIDPOINT (I,J,K) FOR FORE 
C                            OR AFT SCAN
C SRB, STHETAB, AND SZB ARE THE RADIAL (KM), AZIMUTHAL (DEG), AND VERTICAL (KM)
C      RESOLUTIONS OF THE ANALYSIS, RESPECTIVELY, OF GRIDDED FILES
C
C RZB, THETAZB, ZZB ARE THE MINIMUM RADIUS (KM), AZIMUTH (DEG) AND VERTICAL (KM)
C      RESPECTIVELY OF GRIDDED FILES
C ROTB AZIMUTH OF (NAVIGATION 0-NORTH) OF Y AXIS HAS NOT BEEN ANYTHING BUT 
C      ZERO FOR A LONG TIME
C IMAXB = NUMBER OF RADIAL BINS IN ANALYIS RESULTING FROM THIS INTERPOLATION
C JMAXB = NUMBER OF AZIMUTHAL BINS IN ANALYSIS RESULTING FROM THIS INTERPOLATION
C KMAXB = NUMBER OF VERTICAL BINS IN ANALYSIS RESULTING FROM THIS INTERPOLATION
C KMIN2 AND KMAX2 ARE HOLDOVERS WHERE THE LOWEST AND HIGHEST LEVELS OF
C       INTERPOLATION MAY NOT BE 1 AND KMAXB
C IDBZADD INTEGER VALUE OF DBZ TO ADD TO INPUT REFLECTIVITY (BIAS)
C IDBZMASK) IS HOW MUCH THE REFLECTIVITY AT A GIVEN RADIUS AND HAS TO EXCEEED 
C THE MASK TO INTERPOLATE THE REFLECTIVITY AND VELOCITY DATA
C XACC, YACC, ZACC NO LONGER USED IN INTERPOLATION PROGRAMS
C XACC, YACC, ZACC **LEGACY REMOVE**
C
C ALPHAI = DIRECTION COSINE IN RADIAL DIRECTION
C BETAI = DIRECTION COSINE IN AZIMUTHAL DIRECTION (COUNTER-CLOCKWISE)
C
C NF IS A HOLDOVER FOR WHEN MORE THAN ONE RADAR SOURCE WAS USED IN A SINGLE
C    INTERPOLATION RUN **LEGACY REMOVE**
C
C    IGUESS         USE A GUESS WIND FIELD <(0)> NO (1) YES--SINCE MORE
C        THAN ONE ROUTINE CALLS SWEEPIN IGUESS MUST BE SET, ALTHOUGH FOR
C        THIS UVW0 VERSION, THE IGUESS SHOULD BE SET TO ZERO
C
C IREADABCD (Y(1)/N(0)) IS A VARIABLE DETERMINING WHETHER SUMFILES HAVE BEEN 
C   READ--THIS WILL GENERALLY BE ZERO AND IS SET THAT WAY **LEGACY REMOVE**
C
C     OLAT,OLON - LAT,LON OF GRID ORIGIN (STORM CENTER) 
C          OLON DEFINED NEGATIVE FOR WEST LONGITUDE
C
C     SLOPE1 - REFLECTIVITY SLOPE CORRECTION FACTOR SET TO ONE
C     CENTIME - ANALYSIS TIME (S)
C     TSTART,TEND - SEE STIME,ETIME
C
C     SMOTIONU,SMOTIONV    - STORM MOTION (M/S)
C     FLIGHTID              - FLIGHT NAME
C     DBZTEST              - MIN DBZ TO INCLUDE
C     UGUESS,VGUESS,WGUESS - GUESS RADIAL, TANGENTIAL, AND VERTICAL WIND 
C                            (ZERO, M/S)
C     DISTXYZ - DISTANCE OF THE CLOSEST OBS THAT WAS INTERP. 
C               TO GRID POINT (I,J,K)
C     PIMAX                - MAX AZI ANGLE FOR OBS TO BE INCLUDED IN WT AVG
C
C DBZTEST MINIMUM REFLECTIVITY TO BE INCLUDED AT A RADIUS OF RRRR KM
C RRRR USED TO MODIFY DBZTEST AS A FUNCTION OF RANGE
C **LEGACY REMOVE**
C
C IREVERSE WHETHER POSITIVE DOPPLER VELOCITY IS DEFINED OUTWARD (0) 
C
C          IRAMSFILES     USE RAMSFILE <(0)> NO (1) YES
C RAMS FILES WERE USED IN THE PAST TO MODIFY THE POSITION OR VELOCITY
C      VALUES ON THE RADAR TAPE.  THEY HAVE NOT BEEN USED FOR YEARS AND
C      DEFINITELY NOT IN REAL TIME **LEGACY REMOVE**
C
C PIMAX NOT USED IN WAVENUMBER 0 PLUS MEAN INTERPOLATION
C PIMAX **LEGACY REMOVE**
C
C IVSPEED (Y(1)/N(0)) WHETHER TANGENTIAL ADVECTION SPEED SHOULD BE USED
C IVSPEED IS PRESENTLY LEGACY AND IS SET TO 0 **LEGACY REMOVE**
C VSPEED0 CONSTANT AZIMUTHAL SPEED TO ADVECT TARGETS IN M/S
C VFACTOR ALLOWS ONE TO KEEP VSPEED0 AT A GIVEN VELOCITY AND MULTIPLY
C VSPEED0 TO MODIFY ADVECTION **LEGACY REMOVE**
C
C TATF IDENTIFIES WHETHER A GIVEN INPUT FILE IS FORE OR AFT OR TRACK NORMAL
C ONLY USE AT THE MOMENT IS IF THE VALUE IN THIS PROGRAM WAS SET TO INDICATE
C
C SMOTIONU/SMOTIONV EASTWARD/NORTHWARD MOTION OF COORDINATE SYSTEM THAT
C DATA ARE INTERPOLATED TO IN M/S--USUALLY AN ESTIMATE OF STORM MOTION
C
C IGRAPHICS ORIGINALLY SET IN MAIN ROUTINE CALLING THIS ONE. IF THE VALUE IS
C    1 THEN THE SWEEPS GRAPHICS ARE SHOWN
C
C HB2 HEIGHT OF MELTING BAND (HALFWAY VERTICALLY BETWEEN BOTTOM AND TOP)
C DPB2 THICKNESS OF MELTING BAND  HB2 AND DPB2 ARE NOMINAL VALUES WHICH
C ARE SOMETIMES CHANGED BY SOFTWARE
C ALL PRECIPITATION BELOW THE BOTTOM OF MELTING BAND CONSIDERED TO BE RAIN
C PRECIPITATION IS CONSIDERED TO BE ALL SNOW ABOVE TOP OF MELTING BAND
C IF DBZ < ZLOW
C PRECIPITATION IS CONSIDERED TO BE ALL RAIN ABOVE TOP OF MELTING BAND
C IF DBZ > ZHIGH
C THESE FOUR VARIABLES ARE USED TO COMPUTE PRECIPITATION FALL SPEED
C
C ISTORMLEVEL = 1 INDICATES THAT THE STORM IS CHARACTERIZED AS MAJOR HURRICANE
C AND MEANS THAT THERE CANNOT BE A GREATER THAN 1-KM GAP BEFORE DATA BEYOND
C ARE FLAGGED SINCE BARGEN-BROWN DE-ALIASING IS CONSIDERED UNRELIABLE.
C RADIAL GRADIENTS ARE CONSIDERED TOO HIGH TO USE A WIDER RADIUS OF INFLUENCE
C ACTUALLY THE ROUTINE IN THIS MODULE IS NOT RUN FOR MAJOR HURRICANES
C IN THIS ROUTINE ISTORMLEVEL IS THE MAXIMUM ALLOWABLE GAP, EVEN FOR 
C WEAKER SYSTEMS, WHERE ISTORMLEVEL IS GENERALLY HIGHER
C
C ... IPLANE = 1 INDICATES P3, IPLANE = 2  INDICATES G-IV
C
C ... IREALTIME DETERMINES WHETHER THIS IS RESEARCH OR OPERATIONAL
C     FOR NOW THIS PARAMETER MAKES NO DIFFERENCE.  IT IS A PLACEHOLDER.  
C     IREALTIME = 0 FOR REAL TIME AND 1 FOR RESEARCH
C
C IVARIATIONAL = 1 MEANS VARIATIONAL UNFOLDING IS USED
C
C IVARIATIONAL = 0 MEANS VARIATIONAL UNFOLDING IS NOT USED
C
C ISX=1 MEANS A MAJOR HURRICANE AND ISX = 0 MEANS NOT
C
C IF IAFTFORE EQUALS 1 OR 2 THEN ONLY FORE OR AFT DATA ARE INTERPOLATED,
C     RESPECTIVELY, IN THIS ROUTINE
C IF IAFTFORE EQUALS 3 THEN THERE WAS ONLY ONE ANTENNA AND FORE AND AFT
C     DATA FROM THAT ANTENNA ARE ACCUMULATED SEPARATELY BUT SIMULTANEOUSLY 
C     IN THIS ROUTINE
C
C ISIGMET TELLS THE ROUTINE WHETHER THE DATA ARE FROM RVP5 (ISIGMET=5)
C OR RVP8 OR LATER (ISIGMET=8)
C
C  IROLLTOL IS INTEGER VALUE OF MAXIMUM AIRCRAFT ROLL (DEG) ALLOWED FOR DATA
C           TO BE INCLUDED IN INTERPOLATION
C
C NSKIP MEANS EVERY NSKIPTH SWEEP IS INTERPOLATED SO NSKIP=1 MEANS
C EVERY SWEEP IS INTERPOLATED AND NSKIP=2 IS EVERY OTHER SWEEP, ETC
C THIS DIFFERS FROM nskip IN THE BIN SUBDIRECTORIES WHERE THE NUMBER
C IS ACTUALLY JUST THE SWEEPS THAT ARE SKIPPED BETWEEN EACH SWEEP INTERPOLATED
C
C G4P3RADMIN VALUE IN KM OF THE RADIUS FROM THE AIRCRAFT WITHIN WHICH
C          ALL DATA ARE FLAGGED
C GROUNDADJUST A SINGLE CONSTANT VALUE IN METERS, OF THE EARTH'S SURFACE
C   FOR THE PURPOSE OF SURFACE REMOVAL OVER A FLAT LAND SURFACE
C   OBVIOUSLY GENERALLY AN APPROXIMATION
C
C IATTEN FLAGS WHETHER TO CORRECT FOR INTERVENING ATTENUATION
C APPLYMASKYESNO FLAGS WHETHER TO APPLY REFLECTIVITY MASK
C RADMASK IS A DISTANCE OUT IN KM TO USE MASK
C RADRAT IS A RATIO OF THE MAXIMUM DISTANCE TO APPLY MASK OVER THE 
C        AIRCRAFT ALTITUDE
C LARGER OF RADMASK OR RADRAT (WHEN CONVERTED TO KM) IS USED 
C
C IAPPLYMASK WHETHER REFLECTIVITY MUST BE GREATER THAN A MASK VALUE FOR THE
C   REFLECTIVITY AND DOPPLER RADIAL WIND TO BE INTERPOLATED YES=1 NO=0
C   DEFAULT IS NO FOR RVP5 AND YES FOR RVP8 OR LATER--MAY NOT BE NEED FOR 
C   2017 AND 2018
C
C
C IUNDERONLY MEANS ONLY APPLYING A MASK BELOW THE AIRCRAFT YES(1)/NO(0)
C
C IAPPLYMASK = 1 IF MASK WILL BE APPLIED AND 0 IF NOT
C
C IF IUNDERONLY =1 THEN JTRAKAZMMIN IS THE MINIMUM ROTATION (CLOCKWISE
C    FROM ZENITH) AND JTRAKAZMMAX IS THE MAXIMUM ROTATION TO APPLY MASK
C
C THIS ROUTINE CALLS THE DATA-READING AND QUALITY-CONTROL ROUTINE SWEEPIN
C AND THEN INTERPOLATES THE REQUIRED PRODUCTS OF RADIAL VELOCITY WITH 
C DIRECTION COSINE AS WELL AS THE PRODUCTS OF SEPARATE DIRECTION COSINES
C AND FINALLY SUMS OF RADAR REFLECTIVITY.  ALL BUT THE RADAR REFLECTIVITY
C SUMS ARE USED IN THE SYNTHESIS METHOD THAT USES A VARIATION LEAST-SQUARES
C SOLUTION OF THE WIND FIELD
C
C Begin variables that are for the graphics-producing version of this
C routine
C
C INCLUDE A VERSION OF PETER DODGE'S INCLUDE FILES THAT DECLARES A LOT OF 
C VARIABLES AND COMMONS
C
      include "hrd_radar_settings.f"
C
C I BELIEVE MAX_X AND MAXY_Y ARE THE NUMBER OF GRID POINTS IN THE X-WINDOWS
C GRAPHICS SWEEP DISPLAYS
C
      PARAMETER(MAX_X=750,MAX_Y=250)
C
C DECLARING VARIABLES NEEDED FOR XWINDOWS WINDOWS LABELING
C
      LOGICAL SHORTPULSEADDEXISTS
      REAL SHORTPULSEADDDB,SHORTPULSEADDRADIUS
      CHARACTER DISPLAY_LABEL*32,WINDOW_LABEL*28
      CHARACTER DISPLAY_LABELZ*32,WINDOW_LABELZ*18
      INTEGER RAW_WINDOW(100),RAWZ_WINDOW(100)
C
C DBZ_INT IS THE VARIABLE THAT WILL BE PLOTTED IN THE WINDOW AND WHICH THE
C SWEEPS ARE INTERPOLATED TO
C
      INTEGER*2 DBZ_INT(MAX_X,MAX_Y)
C
C End graphics variables
C
C OLAT AND OLON ARE PASSED FROM MAIN AND ARE FOR THE OUTPUT SUMFILE
C OLATG AND OLONG ARE FROM THE GUESS FILE THAT IS USED BY THE SWEEP READER
C
      CHARACTER FLIGHTID*8,IATTEN*1
      REAL GTLENGTH(MAX_HRD_DIM)
C
C U (UG), V (VG) , AND W (WG) WINDS FOR FIRST GUESS FIELD, 
C         WHICH IS NOT USED IN THIS ABCD
C
      REAL UG(1600000),VG(1600000),WG(1600000)
      REAL SUMVR(90,2,3),SUMNVR(90,2,3),VRTOT(2,3),VRTOTN(2,3)
      REAL VRTOTSUM(2,3),VRTOTSUMN(2,3),VRINTERIM(2,3)
      REAL SUMVRSHOW(90,2,3)
      REAL RX(200),RY(200),RZ(200),RHOVRVR(200),RYDIST(200)
      REAL SUMWTSAVE(IMAXB,JMAXB,KMAXB,2)
      REAL XWSAVE(IMAXB,JMAXB,KMAXB,2)
      REAL YWSAVE(IMAXB,JMAXB,KMAXB,2),ZWSAVE(IMAXB,JMAXB,KMAXB,2)
      REAL UMEAN(600,360),VMEAN(600,360),WMEAN(600,360)
      REAL SUMDBZ(IMAXB,JMAXB,KMAXB,2)
      REAL VR(MAX_HRD_DIM),RANGE(MAX_HRD_DIM),DBZ(MAX_HRD_DIM)
      REAL XR(MAX_HRD_DIM),YR(MAX_HRD_DIM),ZR(MAX_HRD_DIM)
C
C RDWD (WIND DIR), RDWS (WIND SPEED), RDVWS (VERTICAL WIND SPEED) FROM
C RADAR FILE INPUT
C
      REAL RDWD(800),RDWS(800),RDVWS(800)
C
C RAD IS THE RADIUS FROM THE STORM CENTER OF POINTS ALONG DOPPLER RADIAL
C THETA IS THE AZIMUTH FROM STORM CENTER OF POINTS ALONG DOPPLER RADIAL
C       DEFINED COUNTER CLOCKWISE FROM EASTWARD (EASTWARD =0, NORTHWARD =90)
C
      REAL RAD(MAX_HRD_DIM),THETA(MAX_HRD_DIM)
C
C The following sum variables represent the summations of products that
C are accumlated during the interpolation process
C
      REAL SUM1(IMAXB,JMAXB,KMAXB,2),SUM2(IMAXB,JMAXB,KMAXB,2)
      REAL SUM3(IMAXB,JMAXB,KMAXB,2),SUM4(IMAXB,JMAXB,KMAXB,2)
      REAL SUM5(IMAXB,JMAXB,KMAXB,2),SUM6(IMAXB,JMAXB,KMAXB,2)
      REAL SUM7(IMAXB,JMAXB,KMAXB,2),SUM8(IMAXB,JMAXB,KMAXB,2)
      REAL SUM9(IMAXB,JMAXB,KMAXB,2),SUM10(IMAXB,JMAXB,KMAXB,2)
      REAL SUM11(IMAXB,JMAXB,KMAXB,2),SUM12(IMAXB,JMAXB,KMAXB,2)
      REAL SUM13(IMAXB,JMAXB,KMAXB,2),SUM14(IMAXB,JMAXB,KMAXB,2)
      REAL SUM15(IMAXB,JMAXB,KMAXB,2),SUM16(IMAXB,JMAXB,KMAXB,2)
      REAL SUM17(IMAXB,JMAXB,KMAXB,2),SUM18(IMAXB,JMAXB,KMAXB,2)
      REAL SUM19(IMAXB,JMAXB,KMAXB,2),SUM20(IMAXB,JMAXB,KMAXB,2)
      REAL SUM21(IMAXB,JMAXB,KMAXB,2),SUM22(IMAXB,JMAXB,KMAXB,2)
      REAL SUM23(IMAXB,JMAXB,KMAXB,2),SUM24(IMAXB,JMAXB,KMAXB,2)
      REAL UGUESS(IMAXB,JMAXB,KMAXB),VGUESS(IMAXB,JMAXB,KMAXB)
      REAL WGUESS(IMAXB,JMAXB,KMAXB),RHOK(100)
      REAL DISTXYZ(IMAXB,JMAXB,KMAXB,2,2,2,2)
C
C VRSWP AND REFSWP ARE THE RADIAL-VELOCITY AND DBZ VALUES OF POINTS 
C       ALONG EACH DOPPLER RADIAL
C
      REAL VRSWP(MAX_HRD_DIM,800),REFSWP(MAX_HRD_DIM,800)
C
C VRSWP1 AND REFSWP1 HAVE RINGS OF VALUES EQUAL TO RED FOR PLOTTING
C RANGE RINGS ALONG WITH DATA
C
      REAL VRSWP1(MAX_HRD_DIM,800),REFSWP1(MAX_HRD_DIM,800)
      REAL VRRAD(MAX_HRD_DIM,800)
C
C RDTAI ARE THE VALUES OF RADIUS (KM) FROM AIRCRAFT RETURNED FROM SWEEPIN
C
C AZ_EL--TWO DIMENSIONAL ARRAY (2,MAX_RAYS) WHEN I=1 AZ_EL IS THE AZIMUTH,
C        OR IN THIS CASE THE ROTATION ANGLE IN THE COORDINATE SYSTEM OF THE
C        AIRCRAFT TRACK (0/360 IS UP)  WHEN I=2 AZ_EL IS THE TRACK-RELATIVE
C        ELEVATION,OR TILT, THAT IS THE ANGLE WITH THE PLANE NORMAL TO THE
C        FLIGHT TRACK, WITH POSITIVE BEING FORWARD
C        ICALLSWEEPIN = 0 THE FIRST TIME SWEEPIN IS CALLED, AFTER THAT = 1
C
C EAZM IS EARTH-RELATIVE AZIMUTH POINT DIRECTION OF RADIAL, DEFINED POSITIVE
C      FROM EAST
C EEV IS EARTH-RELATIVE ELEVATION DEFINED POSITIE UPWARD FROM HORIZONTAL
C
      REAL RDTAI(MAX_HRD_DIM),AZ_EL(2,800),EAZM(800),EEV(800)
C
C I HAVE NO IDEA WHY VNYQ IS A MATRIX, IT IS THE DOPPLER UNAMBIGUOUS VELOCITY
C
C PELEV IS THE ANGLE OF THE ANTENNA RELATIVE TO THE PLANE NORMAL TO THE 
C     FUSELAGE, DEFINED POSITIVELY FORWARD 
C
      REAL VNYQ(MAX_HRD_DIM,800),PELEV(800)
      INTEGER DATA_TYPE
      REAL SWEEPSAVE(MAX_HRD_DIM,800)
      REAL TMSWEEP(800),RRLAT(800),RRLON(800),RRA(800)
      CHARACTER*6 CHARTIME,CHARTIMEMIN,CHARTIMEMAX
      CHARACTER*5 CHARAFTFORE
      CHARACTER*2 TATF(80),TAF
      REAL SUMMER(600,400,50,2)
      INTEGER WINDOWERROR
      FLAG=-1.0E+10
      WRITE(6,*)'ENTERED ABCD'
      IWAVE=0
      NCOUNT=-1
c      OPEN(68,FILE='sweeps.txt')
c      OPEN(67,FILE='swidth.txt')
      display_label='01234567890123456789012345678901'
      display_labelz='01234567890123456789012345678901'
      IF(IGRAPHICS.EQ.1)THEN
C 
C TWO X-WINDOWS WILL BE OPENED WITH THE TITLES:  "cleaned up radial velocities"
C AND "reflectivity"
C SET THE TITLES
C
       WINDOW_LABEL='cleaned up radial velocities'
       WINDOW_LABELZ='reflectivity (dBZ)'
C
C LOGICAL UNIT NUMBER FOR THE SOLO_CONVT IS 6
C
       ILOG_LU=6
       lablen=28
C
C OPEN THE WINDOWS AS X-WINDOWS
C
       CALL RASX_OPEN_WINDOW(RAW_WINDOW,WINDOWERROR,
     +  WINDOW_LABEL,LABLEN)
       LABLEN=18
       CALL RASX_OPEN_WINDOW(RAWZ_WINDOW,WINDOWERROR,
     +  WINDOW_LABELZ,LABLEN)
      ENDIF
      SHORTPULSEADDDB=-1.
      SHORTPULSEADDRADIUS=-1.
      INQUIRE(FILE='short_pulse_add',EXIST=SHORTPULSEADDEXISTS)
      IF(SHORTPULSEADDEXISTS)THEN
         OPEN(88,FILE='short_pulse_add')
         READ(88,*)SHORTPULSEADDDB
         WRITE(6,*)'SHORTPULSEADDDB = ',SHORTPULSEADDDB
         READ(88,*)SHORTPULSEADDRADIUS
         WRITE(6,*)'SHORTPULSEADDRADIUS = ',SHORTPULSEADDRADIUS
         CLOSE(88)
      ENDIF
C
C IUSEWIND WILL USUALLY BE 0 FOR THIS ROUTINE, SINCE IT IS USED TO DO THE
C INITIAL INTERPOLATION BEFORE THERE IS A GUESS WIND FIELD
C
c      WRITE(6,*)'IGUESS = ',IGUESS
c      PAUSE
C
C IGUESS WILL BE SET TO ZERO FOR THIS FIRST-GUESS RUN SO FIRST GUESS WIND
C FIELD IS NOT NEEDED AND IS NOT READ
C
      IUSEWIND=IGUESS
      IF(IUSEWIND.EQ.1)THEN
       IJKMAX=400000
       CALL READWIND(UG,VG,WG,IMXG,JMXG,KMXG,SXG,SYG,SZG,
     + OLATG,OLONG,XZG,YZG,ZZG,IJKMAX,ZLOW,ZHIGH,HB2,DPB2)
      ELSE
C
C SET THE GUESS RESOLUTION TO THE FIRST-PASS ANALYSIS RESOLUTION
C     ALTHOUGH I THINK IT IS NEVER USED IF IUSEWIND.NE.1
C
       SXG=SRB
       SYG=SRB
       SZG=SZB
      ENDIF
C
C ISCANMAX IS THE RADIAL DIMENSION OF THE SWEEP DATA (MAX POSSIBLE SIZE)
C MAX_HRD_DIM IS SET IN THE INCLUDE FILE ABOVE
C
      ISCANMAX=MAX_HRD_DIM
C
C MAX_GATES is Maximum number of gates stored for each radial
C
      MAX_GATES=MAX_HRD_DIM
C
C MAX_RAYS is Maximum number of radials expected in a full sweep
C THE USUAL NUMBER IS ~300-360 RAYS
C
      MAX_RAYS=800
C
C MDIM is total number of grid points in SUMMATION output fields
C
      MDIM=IMAXB*JMAXB*KMAXB
      WRITE(6,*)'MDIM = IMAXB*JMAXB*KMAXB = ',MDIM
C
C Determine pi to full real-variable resolution
C
      PI=2.*ASIN(1.)
      PI2=2.*PI
      NELAZOLD=0
C
C ELMIN AND ELMAX ARE SENT TO SOLO_CONVT BUT IT DOES NOT APPEAR THEY ARE
C       USED IN THAT PROGRAM  **LEGACY REMOVE--BE CAREFUL--USED MANY PLACES**
C
      ELMIN=-180.
      ELMAX=180.
C
C DTR = DEGREES TO RADIANS
C
      DTR=PI/180.
      ISCANDIM=MAX_HRD_DIM
C
C LOOKS LIKE IBINS, JBINS, SXB2,SYB2, AND SZB2 ARE NOT USED
C *LEGACY REMOVE
C
      IBINS=7
      SXB2=.5*SXB*SXB
      SYB2=.5*SYB*SYB
      SZB2=.5*SZB*SZB
      JBINS=3*IBINS+1
C
C **END LEGACY REMOVE**
C
C
C MAXIMUM AND MINIMUM RADII WHERE A DATUM COULD POSSIBLE BE INTERPOLATED
C
      RHIGH=200.
      RLOW=.1
      DO L=1,2
       DO LL=1,3
C
C SETTING SOME OF THE SUMS THAT MIGHT BE USED TO COMPUTE MEANS FOR DETERMINING
C A TILT CORRECTION
C
        VRTOTSUM(L,LL)=0.
        VRTOTSUMN(L,LL)=0.
       ENDDO
       DO K=1,KMAXB
C
C HEIGHT IN KM
C
        HEIGHT=ZZB+(K-1)*SZB
C
C RHO IS REALLY AN APPROXIMATION TO THE RATIO OF THE DENSITY TO THE SURFACE
C     DENSITY
C
        RHO=EXP(-HEIGHT*.10437052)
        RHOK(K)=RHO
        DO J=1,JMAXB
         DO I=1,IMAXB
          DO KK=1,2
           DO JJ=1,2
            DO II=1,2
C
C DISTXYZ IS USED FOR DOING A BI-LINEAR INTERPOLATION.  IT GIVES THE DISTANCE
C OF THE THE CLOSEST OBSERVATION THAT WAS INTERPOLATED TO THAT GRID POINT
C IF DISTXYZ FOR II JJ AND KK EQUAL 1 OR 2 IS 1000 FOR ANY OF THEM, THEN IT
C MEANS THE GRID POINT WAS NOT SURROUNDED BY INTERPOLATED DATA.  IT IS 
C USUALLY GOOD TO FLAG SUCH A DATA POINT
C THE FOLLOWING LINE RESETS ALL THE POINTS TO NO DATA FLAG OR 1000
C
C NOTE:  DISTXYZ CHECK IS PRESENTLY TURNED OFF AND IT COULD BE REMOVED
C
C
             DISTXYZ(I,J,K,L,II,JJ,KK)=1000.
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
C
C I HAVE NO IDEA WHAT THE PURPOSE OF THIS IS
C
      DO I=1,256
       A=I
       RANGE(I)=A
       VR(I)=-A
       DBZ(I)=A*2.
      ENDDO
      write(6,*)'entered abcd'
C
C MDIM2 IS THE NUMBER OF GRID POINTS IN SUMMATIONS AT EACH HEIGHT
C
      MDIM2=IMAXB*JMAXB
C
C DEBUG STATEMENTS TO KEEP TRACK OF WHERE THE PROGRAM GOT TO
C
      WRITE(6,*)'IMAXB,JMAXB,KMAXB,SXB,SYB,SZB,ROTB'
      WRITE(6,*)IMAXB,JMAXB,KMAXB,SXB,SYB,SZB,ROTB
      WRITE(6,*)'Entered ABCD'
C
C THE ACTUAL GAUSSIAN WEIGHTS USED IN THE INTERPOLATION TO GET 1/e at ERMAX, 
C ETMAX AND EZMAX ARE EXP(-RRWEIGHT), EXP(-RTWEIGHT), AND EXP*-RZWEIGHT)
C'
      RRWEIGHT=ERMAX*ERMAX
      RTWEIGHT=ETMAX*ETMAX
      RZWEIGHT=EZMAX*EZMAX
      WRITE(6,*)'EHMAX,EZMAX,RXMAX,RYMAX,RZMAX'
      WRITE(6,*)EHMAX,EZMAX,RXMAX,RYMAX,RZMAX    
      WRITE(6,*)'XACC = ',XACC
      WRITE(6,*)'YACC = ',YACC
      WRITE(6,*)'ZACC = ',ZACC
C
C Determine R-Z mean values of tangential (v), radial (u) 
C and vertical (w) wind in the guess file which could be 
C used for advecting observations to common composite time
C
      DO K=1,KMAXB
       DO I=1,IMAXB
        SUMV=0.
        SUMU=0.
        SUMW=0.
        DO J=1,JMAXB
         SUMV=SUMV+VGUESS(I,J,K)
         SUMU=SUMU+UGUESS(I,J,K)
         SUMW=SUMW+WGUESS(I,J,K)
        ENDDO
        VMEAN(I,K)=SUMV/JMAXB
        UMEAN(I,K)=SUMU/JMAXB
        WMEAN(I,K)=SUMW/JMAXB
       ENDDO
      ENDDO
      DO L=1,2
       IF(IREADABCD.NE.1)THEN
        DO KK=KMIN2,KMAX2
         DO JJ=1,JMAXB
          DO II=1,IMAXB
C
C First call to ABCD:  zero all angle-projection and 
C       doppler-projection summations and reflectivity summations
C
           SUMDBZ(II,JJ,KK,L)=0
           SUMWTSAVE(II,JJ,KK,L)=0
           SUM1(II,JJ,KK,L)=0
           SUM2(II,JJ,KK,L)=0
           SUM3(II,JJ,KK,L)=0
           SUM4(II,JJ,KK,L)=0
           SUM5(II,JJ,KK,L)=0
           SUM6(II,JJ,KK,L)=0
           SUM7(II,JJ,KK,L)=0
           SUM8(II,JJ,KK,L)=0
           SUM9(II,JJ,KK,L)=0
           SUM10(II,JJ,KK,L)=0
           SUM11(II,JJ,KK,L)=0
           SUM12(II,JJ,KK,L)=0
           SUM13(II,JJ,KK,L)=0
           SUM14(II,JJ,KK,L)=0
           SUM15(II,JJ,KK,L)=0
           SUM16(II,JJ,KK,L)=0
           SUM17(II,JJ,KK,L)=0
           SUM18(II,JJ,KK,L)=0
           SUM19(II,JJ,KK,L)=0
           SUM20(II,JJ,KK,L)=0
           SUM21(II,JJ,KK,L)=0
           SUM22(II,JJ,KK,L)=0
           SUM23(II,JJ,KK,L)=0
           SUM24(II,JJ,KK,L)=0
           XWSAVE(II,JJ,KK,L)=0
           YWSAVE(II,JJ,KK,L)=0
           ZWSAVE(II,JJ,KK,L)=0
           SUMMER(II,JJ,KK,L)=0
          ENDDO
         ENDDO
        ENDDO
       ENDIF
      ENDDO
      IBEGIN=0
      TIMES=0.
      NRECORD=1
C
C SET WHETHER SWEEPIN HAS BEEN CALLED YET ICLSWP
C
      ICLSWP=0
      WRITE(6,*)'IN ABCD IAPPLYMASK = ',IAPPLYMASK
      IF(IREADABCD.EQ.1)GO TO 72735
92923 TAF=TATF(1)
C
C SETTING VR DBZ TO FLAGS BEFORE CALLING SWEEPING
C
      DO I=1,MAX_HRD_DIM
       VR(I)=FLAG
       DBZ(I)=FLAG
      ENDDO
c      write(6,*)'calling sweepin iusewind = ',iusewind
c      pause
C
C SWEEPIN READS DATA FROM A DATA SOURCE.  FOR RVP5 DATA THIS IS A SINGLE FILE
C THAT IS AN IMAGE THE ORIGINAL DATA TAPE.  FOR RVP8 AND LATER, DATA ARE IN
C A SERIOUS OF INDIVIDUAL SWEEP FILES ALL PLACED IN A SINGLE DIRECTORY.
C SWEEPIN CLEANS UP THE DATA, REMOVES THE SURFACE,
C REMOVES SPECKLES, AND AUTOMATICALLY DE-ALIASES THE DATA IN BOTH A SINGLE-
C RADIAL AND AN AZIMUTHAL MODE
C
C NCOUNT IS A COUNT OF THE NUMBER OF TIMES SWEEPIN HAS BEEN CALLED AND
C SWEEPIN HANDLES A SINGLE SWEEP OF DATA
C
      NCOUNT=NCOUNT+1
C
C NDO DETERMINES WHETHER NCOUNT IS A MULTIPLE OF NSKIP.  IF NOT SWEEP IS
C NOT INTERPOLATED AND ANOTHER SWEEP IS READ.  NDO ALSO SIGNALS SWEEPIN
C WHETHER TO DO A COMPLETE PROCESSING OF A SWEEP OR A MINIMAL READ-THROUGH
C TO GET TO THE NEXT SWEEP
C
      NDO=NCOUNT-NSKIP*(NCOUNT/NSKIP)
      WRITE(6,*)'NCOUNT,NDO = ',NCOUNT,NDO
c      PAUSE
      WRITE(6,*)'ABCD SHORTPULSEADDDB,SHORTPULSEADDRADIUS = ',
     +           SHORTPULSEADDDB,SHORTPULSEADDRADIUS
      CALL SWEEPIN(VRSWP,REFSWP,MAX_RAYS,MAX_GATES,NUM_RAYS,RDTAI,
     + AZ_EL,ICLSWP,NRECORD,VRRAD,
     + VNYQ,ILATERSWEEP,SWEEPSAVE,UG,VG,WG,
     + IMXG,JMXG,KMXG,SXG,SYG,SZG,OLATG,OLONG,XZG,YZG,ZZG,
     + IUSEWIND,EAZM,EEV,TMSWEEP,RRLAT,RRLON,RRA,
     + SMOTIONU,SMOTIONV,CENTIME,PELEV,NTASWEEP,
     + RDWS,RDWD,RDVWS,NBINS,OLAT,OLON,TIMES,
     + IWAVE,ISTORMLEVEL,IPLANE,IREALTIME,IVARATIONAL,ISX,IAFTFORE,
     + ISIGMET,ROLLTOL,NDO,IDBZADD,IDBZMASK,G4P3RADMIN,GROUNDADJUST,
     + IATTEN,RADRAT,RADMASK,IAPPLYMASK,IUNDERONLY,
     + JTRAKAZMMIN,JTRAKAZMMAX,SHORTPULSEADDDB,SHORTPULSEADDRADIUS)
       IF(NDO.NE.0)GO TO 92923
C
C NBINMAX DETERMINE THE ACTUAL MAXIMUM RADIAL ARRAY ELEMENT THAT COULD 
C CONTAIN DATA
C
       NBINMAX=1
      IF(NUM_RAYS.LE.1.AND.TIMES.LT.TEND)THEN
       GO TO 92923
      ENDIF
c      DO I=1,NBINS
c       VRSWP(I,1)=-888.88
c       REFSWP(I,1)=60.
c      ENDDO
C
C TMSWEEPMIN AND TMSWEEPMAX ARE TIMES IN SECONDS PAST MIDNIGHT
C THEY ARE UPDATED AS THE SWEEP IS PROCESSED AND THEN THEY ARE USED
C TO LABEL THE TIME IN THE SWEEPS GRAPHICS
C SET THEM TO MAKE SURE THEY WILL SHOW THE ACTUAL MIN AND MAX
C
      TMSWEEPMIN=300000.
      TMSWEEPMAX=0.
C
C PELEVSUM IS USED TO DETERMINE THE MEAN AIRCRAFT RELATIVE TILT TO DETERMINE
C WHETHER TO PUT FORE OR AFT IN THE SWEEP DISPLAY
C
      PELEVSUM=0.
      DO J=1,NUM_RAYS
       PELEVSUM=PELEVSUM+PELEV(J)
       IF(TMSWEEP(J).GT.TMSWEEPMAX)TMSWEEPMAX=TMSWEEP(J)
       IF(TMSWEEP(J).LT.TMSWEEPMIN)TMSWEEPMIN=TMSWEEP(J)
       DO I=1,NBINS
        RANGE(I)=RDTAI(I)
        GTLENGTH(I)=RDTAI(I)
        IF(RANGE(I).GT.0..AND.RANGE(I).LT.RHIGH.AND.
     1    I.GT.NBINMAX)NBINMAX=I
       ENDDO
      ENDDO
      PELEVSUM=PELEVSUM/NUM_RAYS
C
C ICLSWP = 0 BEFORE SWEEPIN IS EVER CALLED AND = 1 IF SWEEPIN HAS BEEN CALLED
C
      ICLSWP=1
      NR=1
c      write(6,*)'NBINS = ',NBINS
c      write(6,*)'rdtai = ',rdtai
c      WRITE(6,*)'NR,NBINMAX = ',NR,NBINMAX
c      PAUSE
C
      DO I=1,MAX_HRD_DIM
       IF(RANGE(I).GT.RHIGH)RANGE(I)=RHIGH+.01
      ENDDO
C
C IGRAPHICS ORIGINALLY SET IN MAIN ROUTINE CALLING THIS ONE. IF THE VALUE IS
C    1 THEN THE SWEEPS GRAPHICS ARE SHOWN
C
      IF(IGRAPHICS.EQ.1)THEN
C
C BEGIN VARIABLES FOR SCAN GRAPHICS
C
c      WRITE(6,*)NBINS,RDTAI
C
C RMX WILL BE THE MAXIMUM RADIUS WHERE DATA WERE COLLECTED
C
       RMX=gtlength(nbinmax)
c       RMX=50.
c       WRITE(6,*)'NBINMAX,RMX = ',NBINMAX,RMX
c       pause
C
C TOTAL X DIMENSION OF GRAPHICS WILL BE MAX_X*SX
C TOTAL Y DIMENSION OF GRAPHICS WILL BE MAX_Y*SY
C XDIS AND YDIS ARE THE LOCATION OF THE ORIGIN (RADAR POSITION) WITHIN THAT
C TOTAL GRAPHICS DOMAIN.  THESE VALUES ARE USED IN CALLS TO SOLO_CONVT
C
C WITH PRESENT SETTINGS BELOW THE GRAPHICS BOX IS 150 KM WIDE WITH AIRCRAFT
C      IN THE CENTER AND AIRCRAFT 20 KM ABOVE BOTTOM OF BOX WITH TOP 30 KM
C      ABOVE THE AIRCRAFT/RADAR
C
C
       XDIS=75.
       YDIS=20.
       SWEEPSX=.20
       SWEEPSY=.20
       IMAXSWEEP=MAX_X
       JMAXSWEEP=MAX_Y
C
C THE NEXT TWO VARIABLES ARE USED IN CALLS TO SOLO_CONVT, BUT DO NOT APPEAR
C TO ACTUALLY BE USED.
C
       RDEL=0.
       RDEL_Z=0.
C
C NMOSM IS A LEGACY VARIABLE THAT IS NOT USED ANYMORE
C
       NMOSM=0
C
C BAD_VAL AND BAD_VALZ ARE FLAGS IN SOLO_CONVT FOR RADIAL VELOCITY AND DBZ
C
       BAD_VAL=-888.8
       BAD_VALZ=-100.0
C
C MAXIMUM AND MINUMUM RADIAL VELOCITIES FOR DOPPLER CONTOURING IN X DISPLAY
C SINCE THIS ROUTINE IS NOT CALLED IN MAJOR HURRICANES 50 M/S ARE THE LOWER
C AND UPPER RADIAL VELOCITY BOUNDS
C
       DOPMIN=-50.
       DOPMAX=50.
C
C AMBIGUOUS AND TOO_NOISY ARE USED IN SHOW_IZ
C
       TOO_NOISY=-200.
       AMBIGUOUS=-100.
C
C MINIMUM AND MAXIMUM REFLECTIVITY CONTOURS FOR X-WINDOW DISPLAY
C
       DBZMIN=-40.
       DBZMAX=80.
C
C DATA_TYPE IS USED IN BOTH SOLO_CONVT AND SHOW_IZ AND EQUALS 1 FOR DBZ
C AND 2 FOR DOPPLER--SOLO_CONVT AND SHOW_IZ ARE CALLED FIRST FOR DOPPLER
C
       DATA_TYPE=2
C
C I THINK IXL AND IYB MOVE THE ANALYSIS AREA FROM THE LOWER RIGHT CORNER
C
       IXL=20
       IYB=20
C
C END VARIABLES FOR SCAN GRAPHICS
C
       DO J1=1,NUM_RAYS
        IRANGERTEST=0
        DO I1=1,MAX_HRD_DIM
C
C VRSWP1 AND REFSWP1 ARE COPIES OF THE VRSWP AND REFSWP DATA WHERE SOME OF
C THE RADIAL BINS ARE FILLED WITH A VALUE EQUAL TO THE COLOR TO SHOW 
C RANGE RINGS
C
         VRSWP1(I1,J1)=VRSWP(I1,J1)
         REFSWP1(I1,J1)=REFSWP(I1,J1)
         IRANGER=INT((RANGE(I1)+.001)/10.)
         REMRANGER=RANGE(I1)-IRANGER*10.
         IF(IRANGER.GT.IRANGERTEST.AND.RANGE(I1).LT.RHIGH)THEN
          IF(REMRANGER.LT.1.21)THEN
C
C DOPMAX-1 AND DBZMAX-1 WILL BE SHOWN AS RED IN PRESENT SETUP SO RANGE
C      RINGS WILL BE RED
C
           VRSWP1(I1,J1)=DOPMAX-1.
           REFSWP1(I1,J1)=DBZMAX-1.
           IRANGERTEST=IRANGER
          ENDIF
         ENDIF
        ENDDO
8642   FORMAT(10F8.1)
       ENDDO
C
C TAKE THE SECONDS FROM THE BEGINNING AND ENDING OF THE SWEEP AND WRITE THEM
C TO CHARACTER STRINGS THAT WILL BE WRITTEN ON THE SWEEPS GRAPHICS-CHARTIMEMIN
C FIRST FOR THE TIME OF THE BEGINNING OF THE SWEEP
C
       IHOURSMIN=TMSWEEPMIN/3600.
       SECLEFT=TMSWEEPMIN-IHOURSMIN*3600.
       IMINSMIN=SECLEFT/60.
       ISECSMIN=TMSWEEPMIN-IHOURSMIN*3600.-IMINSMIN*60.
       ITHHMMSS=IHOURSMIN*10000+IMINSMIN*100+ISECSMIN
       WRITE(CHARTIMEMIN,'(3I2.2)')IHOURSMIN,IMINSMIN,ISECSMIN
C
C PELEV IS THE ANGLE OF THE ANTENNA WITH THE PLANE NORMAL TO THE FUSELAGE
C DETERMINE THE AVERAGE VALUE OF PELEV TO DETERMINE WHETHER THE SWEEP 
C SHOULD BE DESCRIBED AS FORE OR AFT
C
       IF(PELEVSUM.GT.0.)THEN
        WRITE(CHARAFTFORE,'(A5)')' FORE'
       ELSE
        WRITE(CHARAFTFORE,'(A5)')'  AFT'
       ENDIF
C
C NOW WRITE THE TIME OF THE END OF THE SWEEP ON THE SWEEP GRAPHICS-CHARTIMEMAX
C
       IHOURSMAX=TMSWEEPMAX/3600.
       SECLEFT=TMSWEEPMAX-IHOURSMAX*3600.
       IMINSMAX=SECLEFT/60.
       ISECSMAX=TMSWEEPMAX-IHOURSMAX*3600.-IMINSMAX*60.
       ITHHMMSS=IHOURSMAX*10000+IMINSMAX*100+ISECSMAX
       WRITE(CHARTIMEMAX,'(3I2.2)')IHOURSMAX,IMINSMAX,ISECSMAX       
       ISCANMAX=NBINMAX
       IF(ISCANMAX.GT.960)ISCANMAX=960
C
C NOW CALL THE CONTOURING PROGRAM SOLO_CONVT WITH DOPPLER DATA
C
C IERSM IS AN OUTPUT SIGNALER WHICH DOESN'T APPEAR TO BE USED IN THIS PROGRAM
C RLATDUM AND RLONDUM ARE NOT USED IN SOLO_CONVT (MAYBE **LEGACY REMOVE**)
C SLATDUM AND SLONDUM ARE NOT USED IN SOLO_CONVT (MAYBE **LEGACY REMOVE**)
C ITFLG HAD SOME FUNCTION NOT NEEDED FOR THIS PURPOSE
C
       CALL SOLO_CONVT(DATA_TYPE,ELMIN,ELMAX,
     +  DBZ_INT,MAX_X,MAX_Y,ILOG_LU,
     +  AZ_EL,VRSWP1,MAX_GATES,ISCANMAX,NUM_RAYS,IERSM,
     +  IMAXSWEEP,JMAXSWEEP,SWEEPSX,SWEEPSY,XDIS,YDIS,RLATDUM,
     +  RLONDUM,SLATDUM,SLONDUM,RMX,RDEL_Z,TIMES,NMOSM,ITFLG,
     +  GTLENGTH,BAD_VAL)
C
C PLOT THE OUTPUT OF SOLO_CONVT ON THE SCREEN WITH SHOW_IZ
C EVERY THING IN THIS CALL HAS A USE
C
       CALL SHOW_IZ(IXL,IYB,DBZ_INT,MAX_X,MAX_Y,IMAXSWEEP,JMAXSWEEP,
     +  DOPMIN,DOPMAX,DATA_TYPE,TOO_NOISY,AMBIGUOUS,
     +  RAW_WINDOW,DISPLAY_LABEL,CHARTIMEMIN,CHARTIMEMAX,CHARAFTFORE)
C
C SWITCH INPUT DATA TYPE FOR SOLO_CONVT AND SHOW_IZ TO 1 (DBZ)
C
       DATA_TYPE=1
C
C NOW CALL THE CONTOURING PROGRAM SOLO_CONVT WITH REFLECTIVITY DATA
C
       CALL SOLO_CONVT(DATA_TYPE,ELMIN,ELMAX,
     +  DBZ_INT,MAX_X,MAX_Y,ILOG_LU,
     +  AZ_EL,REFSWP1,MAX_GATES,ISCANMAX,NUM_RAYS,IERSM,
     +  IMAXSWEEP,JMAXSWEEP,SWEEPSX,SWEEPSY,XDIS,YDIS,RLATDUM,
     +  RLONDUM,SLATDUM,SLONDUM,RMX,RDEL_Z,TIMES,NMOSM,ITFLG,
     +  GTLENGTH,BAD_VALZ)
C
C PLOT THE OUTPUT OF SOLO_CONVT ON THE SCREEN WITH SHOW_IZ
C
       CALL SHOW_IZ(IXL,IYB,DBZ_INT,MAX_X,MAX_Y,IMAXSWEEP,JMAXSWEEP,
     +  DBZMIN,DBZMAX,DATA_TYPE,TOO_NOISY,AMBIGUOUS,
     +  RAWZ_WINDOW,DISPLAY_LABELZ,CHARTIMEMIN,CHARTIMEMAX,CHARAFTFORE)
      ENDIF
C
C THE NEXT SECTION OF CODE WAS DESIGNED WITH THE PURPOSE OF COMPUTING ANGLE
C CORRECTIONS IN REAL-TIME, WHICH WAS USED YEARS AGO.  IT IS LEGACY CODE
C **LEGACY REMOVE UNTIL WE SEE END LEGACY REMOVE**
C
C NELAZ KEEPS TRACK OF WHETHER A PARTICULAR RADIAL IS IN A FORE OR AFT SCAN
C THIS HELPS TO DEAL WITH THE ERRORS IN SEPARATING SWEEPS WHEN THE FRENCH
C ANTENNA IS USED
C
      IF(PELEV(2).GE.0.)THEN
       NELAZ=2
      ELSE
       NELAZ=1
      ENDIF
C
C NEW SWEEP
C
      IF(NELAZ.NE.NELAZOLD)THEN
       DO LMN=1,90
        DO MNO=1,2
         DO KNO=1,3
          SUMVR(LMN,MNO,KNO)=0.
          SUMNVR(LMN,MNO,KNO)=0.
         ENDDO
        ENDDO
       ENDDO
       NELAZOLD=NELAZ
      ENDIF
C
C NR IS THE NUMBER OF THE RADIAL WITHIN THE SWEEP (J IN MANY ROUTINES)
C
92924 DO WHILE(NR.LE.NUM_RAYS)
C
C ELEVTEST AND ELAZ WILL BE USED TO DETERMINE IF NELAZ SHOULD BE 1 (AFT)
C OR 2 (FORE) BASED UPON SIGN OF PELEV WHICH IS ANGLE RELATIVE TO THE PLANE
C NORMAL TO THE FUSELAGE
C
       ELEVTEST=PELEV(NR)
       AZEL=AZ_EL(1,NR)+2.
       ELAZ=PELEV(NR)
       NELAZ=1
       IF(ELAZ.GE.0.)NELAZ=2
C
C THIS BEGINS THE SECTION OF CODE WHERE DOPPLER VELOCITIES ARE COMPARED TO
C      FLIGHT LEVEL WINDS TO DETERMINE A TILT CORRECTION FROM THE MEAN
C      DIFFERENCE.  THIS IS NO LONGER USED IN REAL TIME OR REGULARLY IN
C      RESEARCH AND COULD BE REMOVED
C
       IF(AZEL.LT.0.)AZEL=AZEL+360.
       IF(AZEL.GT.360.)AZEL=AZEL-360.
       NVRADD=1+INT(AZEL/4.)
C NVRADD ALLOWS A LOOK AT HOW THE "ERROR" IN RADIAL VELOCITY COMPARES
C TO FLIGHT-LEVEL PROJECTION AS A FUNCTION OF ROTATION ANGLE (4 DEG BINS)
C
C UU, VV, WW ARE WIND COMPONENTS FROM THE FLIGHT-LEVEL DATA ON RADAR FILE
C
       VV=-RDWS(NR)*COS(RDWD(NR)*3.14159/180.)
       UU=-RDWS(NR)*SIN(RDWD(NR)*3.14159/180.)
       WW=RDVWS(NR)
C
C REEV AND REAZM ARE RADIAN VALUES OF EARTH-RELATIVE ELEVATION AND AZIMUTH
C
       REEV=3.14159/180.*EEV(NR)
       REAZM=3.14159/180.*EAZM(NR)
C
C COSINE AND SINE OF EARTH-RELATIVE AZIMUTH
C
       CREAZM=COS(REAZM)
       SREAZM=SIN(REAZM)
C
C COSINE AND SINE OF EARTH-RELATIVE ELEVATION
C
       CREEV=COS(REEV)
       SREEV=SIN(REEV)
C
C FOR THE FIRST THREE BINS OF EACH DOPPLER RADIAL (IT SEEMS LIKE IT MIGHT
C     NOT BE ENOUGH)
C
       DO KNO=1,3
C
C IF VRSWP IS NOT A FLAGGED VALUE, THEN...
C
        IF(VRSWP(KNO,NR).GT.-800.)THEN
C
C VRTEST WILL BE THE PROJECTION OF THE FLIGHT-LEVEL WIND ON DOPPLER DIRECTION
C
        VRTEST=UU*CREAZM*CREEV
     +  +VV*SREAZM*CREEV+WW*SREEV
C
C VRCHECK IS THE DIFFERENCE BETWEEN DOPPLER OBSERVATION AND THE PROJECTION
C OF FLIGHT-LEVEL WIND
C
        VRCHECK=VRSWP(KNO,NR)-VRTEST
C
C SUMVR IS THE SUM OF ALL THE DIFFERENCES OF DOPPLER FROM FLIGHT-LEVEL
C
        SUMVR(NVRADD,NELAZ,KNO)=SUMVR(NVRADD,NELAZ,KNO)+VRCHECK
C
C THE TOTAL NUMBER OF SAMPLES TO AVERAGE IS SUMNVR
C
        SUMNVR(NVRADD,NELAZ,KNO)=SUMNVR(NVRADD,NELAZ,KNO)+1
        ENDIF
       ENDDO
C
C **END LEGACY REMOVE**
C
C L2 AND NF ARE SET TO 1 OR 2 DEPENDING ON WHETHER THE ANTENNA IS IN AN AFT (1),
C NORMAL (1), OR FORE (2) SWEEP
C
       TAF=TATF(1)
       IF(ELEVTEST.LE.0.OR.'TAF'.EQ.'TN')THEN
        L2=1
        NF=1
       ELSE
        L2=2
        NF=2
       ENDIF
C
C RLATBEFORE **LEGACY REMOVE?**
C
       RLATBEFORE=RLAT
C
C TIMES IS SET TO TIME IN SECS PAST MIDNIGHT OF CURRENT DOPPLER RADIAL
C
       TIMES=TMSWEEP(NR)
C
C AZIM IS THE EARTH RELATIVE AZIMUTH OF DOPPLER DIRECTION (MATH ANGLES)
C MATH ANGLES MEANS EAST IS 0 DEG AND NORTH IS 90 DEG
C
       AZIM=EAZM(NR)
C
C Sweepin uses math angles but VRLOCATE was based upon using the
C UF file reader which reports back in navigational coordinates
C Thus do a reflection and check
C
       AZIM=90-AZIM
       IF(AZIM.LT.0.)AZIM=AZIM+360.  
       IF(AZIM.GT.360.)AZIM=AZIM-360.
C
C RALT AND ELEV ARE RADAR ALTITUDE (M) AND EARTH-RELATIVE ELEVATION ANGLE (DEG),
C RESPECTIVELY
C
       RALT=RRA(NR)   
       ELEV=EEV(NR)
C
C RLAT, RLON, RLATR, RLONR ARE THE LATITUDE AND LONGITUDE OF RADAR (AIRCRAFT)
C AT TIME OF THIS OBSERVATION
C
       RLAT=RRLAT(NR)
       RLON=RRLON(NR)
       RLATR=RLAT
       RLONR=RLON
       IHOURS=TIMES/3600.
       SECLEFT=TIMES-IHOURS*3600.
       IMINS=SECLEFT/60.
       ISECS=TIMES-IHOURS*3600.-IMINS*60.
C
C ITHHMMSS IS THE INTEGER VALUE OF TIME IN HHMMSS
C
       ITHHMMSS=IHOURS*10000+IMINS*100+ISECS
C
C EXTRACT THE VELOCITIES AND REFLECTIVITY FROM CURRENT RADIAL
C
       DO I=1,NBINS
        VR(I)=VRSWP(I,NR)
        DBZ(I)=REFSWP(I,NR)
       ENDDO
C
C NEXT (LEGACY) SECTION IS FOR READING IN RESEARCH-LEVEL FLIGHT-LEVEL 
C NAVIGATIONAL DATA TO REPLACE WHAT ARE IN THE RADAR FILES
C **LEGACY REMOVE**
C
       IF(IRAMSFILES.EQ.1)THEN
        CALL READRAMFILE(TIMES,TIME_RAM,RLAT,RLON,DM1,DM2,DM3,
     *                      DM4,DM5,DM6,DM7,IOS)
        IF(IERR.EQ.0.AND.IOS.EQ.0)THEN
         RLATDIFF=RLAT-RLATR
         RLONDIFF=RLON-RLONR
        WRITE(6,*)'RLAT,RLATR,RLATDIFF,RLON,RLONR,RLONDIFF = ',
     +              RLAT,RLATR,RLATDIFF,RLON,RLONR,RLONDIFF
        ELSEIF(IOS.NE.0)THEN
         RLAT=RLATR+RLATDIFF
         RLON=RLONR+RLONDIFF
        WRITE(6,*)'IOS,RLAT,RLATR,RLATDIFF,RLON,RLONR,RLONDIFF = ',
     +              IOS,RLAT,RLATR,RLATDIFF,RLON,RLONR,RLONDIFF
        ELSE
         IHOURS=TIMES/3600.
         SECLEFT=TIMES-IHOURS*3600.
         IMINS=SECLEFT/60.
         ISECS=TIMES-IHOURS*3600.-IMINS*60.
         IHHMMSS=IHOURS*10000+IMINS*100+ISECS
         WRITE(6,*)'TIME,IOS,IERR = ',IHHMMSS,IOS,IERR
         IF(IERR.EQ.-2.OR.IERR.EQ.-3)THEN
          WRITE(6,*)'Are you giving rams coordinates to the '
          WRITE(6,*)'NEXRAD radar i.e. moving the radar?'
         ENDIF
         IF(IERR.LE.-4)GO TO 92923
        ENDIF
       ENDIF
C
C END OF RAMSFILES SECTION (LEGACY) **LEGACY REMOVE**
C
       IF(IBEGIN.EQ.1.AND.TIMES.LT.TSTART)TIMES=TIMES+86400.
C
C I BELIEVE IERR SHOULD NOT BE USED HERE IN CASE IT SHOULD HAPPEN TO BE
C     RANDOMLY SET TO -1 AND THE PROGRAM END INCORRECTLY
C       IF(TIMES.GT.TEND.OR.IERR.EQ.-1)GO TO 92929
       IF(TIMES.GT.TEND)GO TO 92929
C
       IF(TIMES.GT.TIMEOLD)THEN
        ITIMES=NINT(TIMES)
        ITIMEHH=ITIMES/3600
        IREMAIN=ITIMES-3600*ITIMEHH
        ITIMEMM=IREMAIN/60
        ITIMESS=IREMAIN-ITIMEMM*60
10103    FORMAT('TIME = ',3I2)
       ENDIF
        TIMEOLD=TIMES
C
C IREADABCD SHOULD PROBABLY ALWAYS BE ZERO NOW AND **LEGACY REMOVED**
C
       IF(IREADABCD.NE.1.AND.TIMES.GE.TSTART.AND.TIMES.LE.TEND)THEN
C
C IT LOOKS LIKE THIS RDEL CORRECTION WAS FOR SOME EARLIER GENERATION OF THE
C    SOFTWARE, SINCE RDEL IS SET TO EXACTLY ZERO ABOVE
C
        IF(RDEL.GT.0.)THEN
         JJJSTART=1
        ELSE
C
C .15 SHOULD PROBABLY BE CHANGED TO RANGE(40)-RANGE(39)
C TEST BEFORE CHANGING
C
         JJJSTART=2-(RDEL/.15)
         ENDIF
        IF(RDEL.LT.0)THEN
         DO JJJ=JJJSTART,ISCANDIM
          RANGE(JJJ)=RANGE(JJJ)+RDEL
          IF(IREVERSE.EQ.1)THEN
           VR(JJJ)=-VR(JJJ)
          ENDIF
         ENDDO
        ENDIF
C
C GET THE TIME IN HHMMSS TO BE IN THE GRAPHICS
C
        IHOURS=TIMES/3600.
        SECLEFT=TIMES-IHOURS*3600.
        IMINS=SECLEFT/60.
        ISECS=TIMES-IHOURS*3600.-IMINS*60.
        ITHHMMSS=IHOURS*10000+IMINS*100+ISECS
C
C Angle projection summing follows.  
C
C IBEGIN CHANGING TO 1 MEANS INTERPOLATION HAS ALREADY BEGUN
C
        IBEGIN=1
C
C XWEIGHT, YWEIGHT, AND ZWEIGHT APPEAR TO NEVER BE USED
C **LEGACY REMOVE**
C
        XWEIGHT=0
        YWEIGHT=0
        ZWEIGHT=0
C
C **END LEGACY REMOVE**
C
        SUMWEIGHT=0
        XSHFT=0.
        YSHFT=0.
C
C CALL THE ROUTINE TO DETERMINE GATE LOCATION WITHIN INTERPOLATION GRID
C FOR ALL POINTS ALONG A RAY
C THEY ARE REPORTED BACK IN XR, YR, AND ZR VECTORS
C
        CALL VRLOCATE(OLAT,OLON,TIMES,
     + RLAT,RLON,RALT,ELEV,AZIM,RANGE,XR,YR,ZR,
     + SMOTIONU,SMOTIONV,ISCANDIM,CENTIME,XSHFT,YSHFT,RAD,THETA,
     + ISCANMAX)
C
C ROTB ALLOWS AN ANALYSIS TO HAVE THE X AND Y AXES ROTATED FROM EAST AND NORTH
C TURNING THIS ON SHOULD BE USED WITH CARE SINCE IT HAS NOT BEEN USED OR 
C SUPPORTED FOR YEARS
C
        AZIMM=AZIM-ROTB
C
C ALPHA, BETA, AND GAMMA ARE THE DIRECTION COSINES FOR X, Y, AND Z DIRECTIONS
C
        GAMMA=SIN(ELEV*DTR)
        ALPHA=SIN(AZIMM*DTR)*COS(ELEV*DTR)
        BETA=COS(AZIMM*DTR)*COS(ELEV*DTR)
C
C ALPHA0 AND BETA0 ARE FOR THE EXTRA 11 SUMS THAT ARE NEEDED TO INCLUDE
C THE MEAN WIND FLOW ACROSS THE STORM AT EACH LEVEL
C
        ALPHA0=SIN(AZIMM*DTR)
        BETA0=COS(AZIMM*DTR)
C
C BEGIN THE INTERPOLATION OF RADIAL DATA TO GRID
C
        DO I=JJJSTART,NBINS
C
C DBZTEST MINIMUM REFLECTIVITY TO BE INCLUDED AT A RADIUS OF RRRR KM
C RRRR USED TO MODIFY DBZTEST AS A FUNCTION OF RANGE
C
         DBZCHK=DBZTEST+20.*ALOG10(RANGE(I)/RRRR)
C
C SUMMATIONS ARE DONE IN AIR DENSITY TIME VELOCITY
C
         RHO=EXP(-ZR(I)*.10437052)
C
C I'M NOT SURE HOW ZRCHECK WAS DETERMINED, BUT IT IS NOT USED
C    **LEGACY REMOVED**
C
         ZRCHECK=RANGE(I)/57.*.95*COS(ELEV*DTR)
         VRVR=VR(I)
         IF((VR(I).GT.-800..OR.DBZ(I).GT.-30.).AND.
     +     RANGE(I).GT.RLOW.AND.RANGE(I).LT.RHIGH)THEN
C
C THIS ALLOWS FOR NOT INCLUDING RADIALS THAT ARE NEARLY VERTICAL, ALTHOUGH
C THIS FEATURE HAS BEEN TURNED OFF FOR SOME TIME
C
          IF(ABS(GAMMA).LE.SINTOL)THEN
C
C Determine actual distance from location of datum in data file
C to the point being evaluated in output file 
C
C
C Determine actual distance from location of datum in data file
C to the point being evaluated in output file 
C
C IMIDDLE, JMIDDLE, AND KMIDDLE WILL BE USED AS CENTER OF SEARCH BOX
C FOR DETERMINING WHICH GRID POINTS WILL USE A GIVEN OBSERVATION FOR
C INTERPOLATION
C
           IMIDDLE=NINT((RAD(I)-RZB)/SRB+1.)
           JMIDDLE=NINT((THETA(I)-THETAZB)/STHETAB+1.)
           KMIDDLE=NINT((ZR(I)-ZZB)/SZB+1.)
C
C DETERMINE THE TIME DIFFERENCE IN SECONDS BETWEEN OBSERVATION AND 
C CENTER TIME OF OUTPUT GRID, I.E. THE TIME THE ORIGIN OF ANALYSIS WAS
C LOCATED AT OLAT, OLON
C
           TIMEDIFF=TIMES-CENTIME
C
C MAKE SURE THE DETERMINATION OF THE FINAL "MIDDLE POINT" DOES NOT GO
C OUTSIDE ARRAY.  IMID, JMID, AND KMID ARE THE FINAL VALUES FOR MIDDLE POINT
C LOCATIONS IN 3D ARRAY
C
           IF(IMIDDLE.GT.IMAXB)THEN
            IMID=IMAXB
           ELSEIF(IMIDDLE.LE.0)THEN
            IMID=1
           ELSE
            IMID=IMIDDLE
           ENDIF
           IF(KMIDDLE.GT.KMAX2)THEN
            KMID=KMAX2
           ELSEIF(KMIDDLE.LE.0)THEN
            KMID=1
           ELSE
            KMID=KMIDDLE
           ENDIF
C
C THIS ASSUMES THAT IACROSS IS EQUAL TO 1, OR PERHAPS THERE WILL BE PROBLEMS
C      AND IACROSS IS ALWAYS 1 FOR TC ANALYSES
C
           IF(JMIDDLE.GT.JMAXB)THEN
            JMID=JMAXB
           ELSEIF(JMIDDLE.LE.0)THEN
            JMID=1
           ELSE
            JMID=JMIDDLE
           ENDIF
C
C HKMID IS ACTUAL HEIGHT IN KM OF MIDDLE POINT
C
           HKMID=ZZB+(KMID-1)*SZB
C
C RHO HERE IS THE DENSITY AT THE MIDDLE POINT
C IF THIS SECTION IS KEPT UGUESS, VGUESS, WGUESS SHOULD PROBABLY BE REMOVED
C AND THIS SHOULD BE REPLACED BY VG.  VG HOWEVER DOES NOT NEED TO BE DIVIDED
C BY RHO, SINCE ROUTINES CALLED BY READWIND DO NOT MULTIPLY VELOCITY BY RHO
C
           RHO=EXP(-HKMID*.10437052)
           IF(VGUESS(IMID,JMID,KMID).GT.FLAG)THEN
            VSPEED=VGUESS(IMID,JMID,KMID)/RHO
C
C OR VSPEED=VG(IMID,JMID,KMID)
C
           ELSE
            VSPEED=FLAG
            DO IL=IMID-1,1,-1
             IF(VGUESS(IL,JMID,KMID).GT.FLAG)THEN
              VSPEED=VGUESS(IL,JMID,KMID)/RHO
              GO TO 9984
             ENDIF
            ENDDO
9984         IF(VSPEED.EQ.FLAG)THEN
             VSPEED=60.
            ENDIF
           ENDIF
           RSPEED=0.
           WSPEED=0.
           UM=0.
           VM=0.
           WM=0.
C
C AS IMPLEMENTED FOR THE AUTOMATED ANALYSIS FIRST PASS VSPEED IS SET TO ZERO
C SO ABOVE CODE IS NOT NEEDED **LEGACY REMOVE**
C
C
C MORE CODE BELOW COULD ALSO BE REMOVED **LEGACY REMOVE START**
C
           VSPEED=0.
           DELTHETA=-TIMEDIFF*VSPEED/RAD(I)/1000.*180./3.14159*VFACTOR
           DELRAD=-TIMEDIFF*RSPEED/1000.
           DELH=-TIMEDIFF*WSPEED/1000.
           THETA(I)=THETA(I)+DELTHETA
           RAD(I)=RAD(I)+DELRAD
           ZR(I)=ZR(I)+DELH
C
C **LEGACY REMOVE END**
C
           IF(THETA(I).GT.360.)THETA(I)=THETA(I)-360.
           IF(THETA(I).LT.0.)THETA(I)=THETA(I)+360.
C
C FINALLY FINDING THE ACTUAL POINT TO BE CONSIDERED THE MIDDLE POINT OF
C THE RADIUS OF INFLUENCE
C
           JMIDDLE=NINT((THETA(I)-THETAZB)/STHETAB+1.)
           IMIDDLE=NINT((RAD(I)-RZB)/SRB+1.)
           KMIDDLE=NINT((ZR(I)-ZZB)/SZB+1.)
C
C DETERMINE HOW MANY POINTS IN THREE DIMENSIONS ARE NEEDED 
C FOR RADIUS OF INFLUENCE
C
           IDELTA=INT(RRMAX/SRB)+1
           JDELTA=INT(RTMAX/STHETAB)+1
           KDELTA=INT(RZMAX/SZB)+1
C
C DETERMINE THE POINTS THAT A GIVEN OBSERVATION WILL AFFECT BY DETERMINING
C THE BEGINNING AND ENDING INDICES FOR DO LOOPS
C
           IXMIN=IMIDDLE-IDELTA
           IXMAX=IMIDDLE+IDELTA
           IYMIN=JMIDDLE-JDELTA
           IYMAX=JMIDDLE+JDELTA
           IZMIN=KMIDDLE-KDELTA
           IZMAX=KMIDDLE+KDELTA
C
C TEST FOR OUT OF RANGE IN RADIUS
C
           IF(IXMIN.LT.1)THEN
            IXMIN=1
           ELSEIF(IXMIN.GT.IMAXB)THEN
            IXMIN=999
           ENDIF
           IF(IXMAX.GT.IMAXB)THEN
            IXMAX=IMAXB
           ELSEIF(IXMAX.LT.1)THEN
            IXMAX=999
           ENDIF
C
C TEST FOR OUT OF RANGE IN HEIGHT
C
           IF(IZMIN.LT.KMIN2)THEN
            IZMIN=KMIN2
           ELSEIF(IZMIN.GT.KMAX2)THEN
            IZMIN=999
           ENDIF
           IF(IZMAX.LT.KMIN2)THEN
            IZMAX=999
           ELSEIF(IZMAX.GT.KMAX2)THEN
            IZMAX=KMAX2
           ENDIF
C
C THIS LOOK LIKE A DEBUG STATEMENT, BUT I'M NOT SURE WHAT THE DEAL IS
C      WITH RAD(I) BEING LT. -100
C
           if(rad(i).lt.-100.)then
            write(6,*)'i,rzb,srb,imiddle,idelta,ixmin,ixmax = ',
     +               i,rzb,srb,imiddle,idelta,ixmin,ixmax
          write(6,*)'i,thetazb,sthetab,jmiddle,jdelta,iymin,iymax = ',      
     +               i,thetazb,sthetab,jmiddle,jdelta,iymin,iymax
            write(6,*)'i,zzb,szb,kmiddle,kdelta,izmin,izmax = ',
     +               i,zzb,szb,kmiddle,kdelta,izmin,izmax
           endif
           IF(IXMIN.LT.999.AND.IXMAX.LT.999.AND.IYMIN.LT.999.AND.
     +       IYMAX.LT.999.AND.IZMIN.LT.999.AND.IZMAX.LT.999)THEN
C
C ROTATE TO DETERMINE DIRECTION COSINES IN RADIAL (ALPHAI) AND 
C        AZIMUTHAL DIRECTIONS (BETAI)
C
            ALPHAI=(ALPHA*XR(I)+BETA*YR(I))/RAD(I)
            BETAI=(-ALPHA*YR(I)+BETA*XR(I))/RAD(I)
C
C OUTERMOST DO LOOP IS FOR VERTICAL RADIUS OF INFLUENCE
C
            DO KK=IZMIN,IZMAX
             RHOVRVR(KK)=VRVR*RHOK(KK)
             HKK=ZZB+(KK-1)*SZB
             RHO=EXP(-HKK*.10437052)
             ZAN=(KK-1)*SZB+ZZB
C
C RZ(KK) IS DISTANCE IN VERTICAL DIRECTION FROM THE HEIGHT OF KK
C
             RZ(KK)=ZR(I)-ZAN
            ENDDO
C
C Enclosed was just moved
c
C
C FIRST LEVEL INNER DO LOOP IS FOR RADIAL RADIUS OF INFLUENCE
C
            DO II=IXMIN,IXMAX
             RAN=(II-1)*SRB+RZB
C
C RX(II) IS THE DISTANCE IN RADIAL DIRECTION FROM THE RADIUS OF II
C
             RX(II)=RAD(I)-RAN
c            RTFACT=(3.14159/180.*RAD(I))**2.
             RTFACT=1.
            ENDDO
C
C THE NEXT SECTION IF FOR COMPUTING RY.  RX AND RZ ARE EASIER TO COMPUTE
C
C INNER DO LOOP IS FOR THE AZIUMTHAL RADIUS OF INFLUENCE, WHICH CAN
C CROSS THE J=1/J=JMAX BOUNDARY
C
            DO JJTEST=IYMIN,IYMAX
C
C TAN IS THETA FOR THE GRID POINT THAT THE DATA WILL BE INTERPOLATED TO
C THETA(I) IS THETA FOR THE INDIVIDUAL DOPPLER/REFLECTIVITY OBSERVATION
C TDIFF IS THE ANGULAR DIFFERENCE BETWEEN TAN AND THETA(I)
C  
             TAN=(JJTEST-1)*STHETAB+THETAZB
             TDIFF=THETA(I)-TAN
C
C MAKE TDIFF THE SMALLEST POSSIBLE TO DEAL WITH THE NATURE OF THETA
C
             IF(TDIFF.GT.180.)TDIFF=TDIFF-360.
             IF(TDIFF.LT.-180.)TDIFF=TDIFF+360.
             RYY=TDIFF
C
C DEAL WITH THE FACT THAT THETA OF GRIP POINT JJ=JMAXB IS ADJACENT TO 
C THETA OF JJ=1
C
C IJTEST IS CALLED IACROSS IN THE MAIN PROGRAM AND DETERMINES WHETHER YOU 
C USE DATA THAT CROSSES THE 1/JMAXB BARRIER
C
             IF(JJTEST.LT.1)THEN
              IF(IJTEST.EQ.1)THEN
C
C JJ=1 AND JJ=JMAXB ARE ADJACENT WITH A DOMAIN THAT SCANS 360 DEGREES
C
               JJ=JJTEST+JMAXB
C
C YOU GET TO THIS PART WITH A DOMAIN THAT IS ONLY A WEDGE
C
              ELSEIF(ABS(RYY).LT.RTMAX)THEN
               JJ=JJTEST+NINT(360./STHETAB)
               IF(JJ.GT.JMAXB)JJ=-1
              ELSE
C
C YOU SHOULD NEVER GET HERE IF J=1 TO J=JMAX COVERS FULL 360 DEGREES
C
               JJ=-1
              ENDIF
             ELSEIF(JJTEST.GT.JMAXB)THEN
              IF(IJTEST.EQ.1)THEN
C
C JJ=1 AND JJ=JMAXB ARE ADJACENT WITH A DOMAIN THAT SCANS 360 DEGREES
C
               JJ=JJTEST-JMAXB
              ELSEIF(ABS(RYY).LT.RTMAX)THEN
               JJ=JJTEST-NINT(360./STHETAB)
               IF(JJ.LT.1)JJ=-1
              ELSE
C
C YOU SHOULD NEVER GET HERE IF J=1 TO J=JMAX COVERS FULL 360 DEGREES
C
               JJ=-1
              ENDIF
             ELSE
              JJ=JJTEST
             ENDIF
             IF(JJ.GE.1.OR.JJ.LE.JMAXB)THEN
C
C COMPUTE AZIMUTHAL DISTANCE IN KM BETWEEN OBSERVATION AND GRID POINT
C         FOR POINT jj
C
              RYDIST(JJ)=TDIFF*3.14159/180.*RAD(I)
C
C RY(JJ) IS THE AZITMUTHAL DISTANCE IN DEGREES 
C BETWEEN OBSERVATION AND GRID POINT JJ
C
              RY(JJ)=TDIFF
             ENDIF
            ENDDO
C
C THIS IS THE END OF THE J ONLY COMPUTATION
C
            DO KK=IZMIN,IZMAX
             DO II=IXMIN,IXMAX
              DO JJTEST=IYMIN,IYMAX
C
C IF JJTEST IS OUTSIDE OF RANGE OF 1 TO JMAX, MODIFY JJ TO BE WITHIN THAT
C RANGE OR SET IT TO -1
C  
               IF(JJTEST.LT.1)THEN
                IF(IJTEST.EQ.1)THEN
                 JJ=JJTEST+JMAXB
                ELSEIF(ABS(RYY).LT.RTMAX)THEN
                 JJ=JJTEST+NINT(360./STHETAB)
                ELSE
                 JJ=-1
                ENDIF
               ELSEIF(JJTEST.GT.JMAXB)THEN
                IF(IJTEST.EQ.1)THEN
                 JJ=JJTEST-JMAXB
                ELSEIF(ABS(RYY).LT.RTMAX)THEN
                 JJ=JJTEST-NINT(360./STHETAB)
                ELSE
                 JJ=-1
                ENDIF
               ELSE
                JJ=JJTEST
               ENDIF
C
C CHECK TO MAKE SURE JJ IS STILL WITHIN BOUNDS
C
               IF(JJ.LT.1.OR.JJ.GT.JMAXB)GO TO 6298
C
C MAKE SURE RADIAL OBSERVATION IS WITHIN THE RADIUS OF INFLUENCE
C
               IF(ABS(RX(II)).GT.RRMAX.OR.ABS(RY(JJ)).GT.RTMAX.OR.
     +           ABS(RZ(KK)).GT.RZMAX)GO TO 6298
C
C CHECK TO SEE IF THE GRID POINT IS SURROUNDED BY OBSERVATIONS CLOSE
C ENOUGH TO BE WITHIN THE RADIUS OF INFLUENCE
C
               IF(RX(II).LE.0)IA=1
               IF(RX(II).GT.0)IA=2
               IF(RY(JJ).LE.0)JA=1
               IF(RY(JJ).GT.0)JA=2
               IF(RZ(KK).LE.0)KA=1
               IF(RZ(KK).GT.0)KA=2
C
C DETERMINE THE DISTANCE BETWEEN OBSERVATION AND GRID POINT
C
               RR=SQRT(RX(II)*RX(II)+RTFACT*RYDIST(JJ)*RYDIST(JJ)
     +          +RZ(KK)*RZ(KK))
C
C INDICATE THIS DISTANCE IN THE CORRESPONDING SURROUNDING 8 GRID PINTS
C TO DETERMINE IF ONCE ALL THE DATA ARE INTERPOLATED THERE ARE SURROUNDING
C DATA FOR EACH GRID POINT.  NOTE, THIS IS NOT IMPLEMENTED AT THE MOMENT AND
C PROBABLY SHOULDN'T BE IN REAL TIME **LEGACY REMOVE** INCLUDING THE VERY
C LARGE ARRAY DISTXYZ
C
               IF(RR.LT.DISTXYZ(II,JJ,KK,L2,IA,JA,KA))THEN
                IF(VR(I).GT.-800.)THEN
                 DISTXYZ(II,JJ,KK,L2,IA,JA,KA)=RR
                ENDIF
               ENDIF
C
C NOW WE REALLY ARE GOING TO BEGIN THE INTERPOLATION
C GAUSSIAN WEIGHT IS EQUAL TO 1/E IF RX EQUALS ERMAX, OR RY EQUALS ETMAX,
C  OR RZ EQUALS EZMAX, BUT THE OTHER TWO EQUAL ZERO
C COMPUTE ARGUMENT FOR EXP
C
               ABC=RX(II)*RX(II)/RRWEIGHT+RY(JJ)*RY(JJ)/RTWEIGHT
     +            +RZ(KK)*RZ(KK)/RZWEIGHT
               WEIGHT=EXP(-ABC)
               P=WEIGHT
C
C Accumulate weighted sums of x, y, and z distances of input data
C
               SUMWEIGHT=P
C
C THIS IS WHERE THE SLOPE FOR DBZ, THAT IS AN INPUT FROM THE MAIN PROGRAM
C IS APPLIED
C
               IF(DBZ(I).GT.-100)THEN
                DBZZ=DBZ(I)*SLOPE1
                ELSE
                DBZZ=-200.
               ENDIF
C
C Perform DBZ weighted sum
C SUMDBZ WILL BE USED TO DETERMINE THE REFLECTIVITY AT EACH GRID POINT
C
               IF(DBZ(I).GT.-100.)THEN
C
C THE POWERS, ZE ARE WHAT ARE ACTUALLY SUMMED FOR EACH GRID POINT
C
                ZE=10.**(DBZZ/10.)
                SUMDBZ(II,JJ,KK,L2)=
     +          SUMDBZ(II,JJ,KK,L2)+P*ZE
C
C SUMMER IS THE SUM OF THE WEIGHTS FOR THE SUMDBZ VALUES
C PERMITTING THE WEIGHTED AVERAGE TO BE DETERMINED LATER
C
                SUMMER(II,JJ,KK,L2)=SUMMER(II,JJ,KK,L2)+P
               ENDIF
C
C Perform weighted sums of 9 direction cosine/Vr terms
C
               IF(VR(I).GT.-800.)THEN
C
C SUMS 1 THROUGH 9 ALLOW THE BEST WAY TO INTERPOLATE DOPPLER VECTORS THAT CAN
C VARY GREATLY IN DIRECTION WITHIN ONE GRID POINT.  REFER TO GAO ET AL (1999) 
C TO SEE A DESCRIPTION OF THIS 3 BY 3 SYMMETRIC MATRIX AND THE RIGHT HAND SIDE
C VECTORS
C
C SUM1 IS THE SUMMATION OF ALL THE PRODUCTS OF THE RADIAL (ALPHAI) AND
C AND AZIMUTHAL (BETAI) DIRECTION COSINES OF THE DOPPLER RADIALS
C
                SUM1(II,JJ,KK,L2)=
     +          SUM1(II,JJ,KK,L2)+P*ALPHAI*BETAI
C
C SUM2 IS THE SUM OF ALL THE TANGENTIAL PROJECTIONS OF DOPPLER RADIAL
C VELOCITY TIMES THE THE DENSITY OF THE AIR AT GRID POINT
C
                SUM2(II,JJ,KK,L2)=
     +          SUM2(II,JJ,KK,L2)+P*BETAI*RHOVRVR(KK)
C
C SUM3 IS THE SUM OF ALL THE SQUARES OF THE AZIMUTHAL DIRECTION COSINES
C
                SUM3(II,JJ,KK,L2)=
     +          SUM3(II,JJ,KK,L2)+P*BETAI*BETAI
C
C SUM4 IS THE SUM OF ALL THE RADIAL PROJECTIONS OF DOPPLER RADIAL
C VELOCITY TIMES THE DENSITY OF THE AIR AT GRID POINT
C
                SUM4(II,JJ,KK,L2)=
     +          SUM4(II,JJ,KK,L2)+P*ALPHAI*RHOVRVR(KK)
C
C SUM5 IS THE SUM OF ALL THE SQUARES OF THE RADIAL DIRRECTION COSINES
C
                SUM5(II,JJ,KK,L2)=
     +          SUM5(II,JJ,KK,L2)+P*ALPHAI*ALPHAI
C
C SUM6 IS THE SUM OF THE PRODUCTS OF THE RADIAL AND VERTICAL DIRECTION COSINES
C

                SUM6(II,JJ,KK,L2)=
     +          SUM6(II,JJ,KK,L2)+P*ALPHAI*GAMMA
C
C SUM7 IS THE SUM OF THE PRODUCTS OF THE TANGENTIAL AND VERTICAL 
C DIRECTION COSINES
C
                SUM7(II,JJ,KK,L2)=
     +          SUM7(II,JJ,KK,L2)+P*BETAI*GAMMA
C
C SUM8 IS THE SUM OF THE SQUARES OF THE VERTICAL DIRECTIONS COSINES
C
                SUM8(II,JJ,KK,L2)=
     +          SUM8(II,JJ,KK,L2)+P*GAMMA*GAMMA
C
C SUM 9 IS THE SUM OF THE VERTICAL PROJECTIONS OF THE DOPPLER RADIAL VELOCITY
C TIMES THE AIR DENSITY AT THE GRID POINT
C
                SUM9(II,JJ,KK,L2)=
     +          SUM9(II,JJ,KK,L2)+P*GAMMA*RHOVRVR(KK)
C
C SUMS 10 -13 ARE USED TO GET A MEAN VECTOR, NOTING THAT THE VECTOR WILL BE TOO
C SMALL IF THERE IS A LARGE VARIATION IN DOPPLER DIRECTION WITH THE DATA 
C INFLUENCING THE GRID POINT
C
C SUM 10 IS SUM OF ALL THE RADIAL DIRECTION COSINES
C
                SUM10(II,JJ,KK,L2)=
     +          SUM10(II,JJ,KK,L2)+P*ALPHAI
C
C SUM 11 IS THE SUM OF ALL THE TANGENTIAL DIRECTION COSINES
C
                SUM11(II,JJ,KK,L2)=
     +          SUM11(II,JJ,KK,L2)+P*BETAI
C
C SUM 12 IS THE SUM OF ALL THE VERTICAL DIRECTION COSINES
C
                SUM12(II,JJ,KK,L2)=
     +          SUM12(II,JJ,KK,L2)+P*GAMMA
C
C SUM 13 IS THE SUM OF ALL THE DOPPLER RADIAL VELOCITIES TIMES THE AIR DENSITY
C
                SUM13(II,JJ,KK,L2)=
     +          SUM13(II,JJ,KK,L2)+P*RHOVRVR(KK)
C
C SUMS 14-24 ARE INCREMENTED BASED UPON WHAT IS NEEDED TO INCLUDE A LINEAR 
C MEAN WIND AT EACH HEIGHT WITHIN THE THE WIND FIELD OTHERWISE WAVE-NUMBER-ZERO 
C DESCRIBED BY THE MEAN RADIAL, TANGENTIAL, AND VERTICAL WIND FIELD AT EACH 
C HEIGHT AND RADIUS FROM STORM CENTER
C
C ALPHA0 AND BETA0 ARE THE DIRECTION COSINES OF THE PROJECTION OF THE DOPPLER
C RADIAL ON THE HORIZONTAL PLANE
C
C SUM14 IS THE SUM OF THE PRODUCTS OF RADIAL DIRECTION COSINE AND THE RADIAL 
C DIRECTION COSINE OF THE PROJECTION OF THE RADIAL ON THE HORIZONTAL PLANE
C
                SUM14(II,JJ,KK,L2)=
     +          SUM14(II,JJ,KK,L2)+P*ALPHA0*ALPHAI
C
C SUM15 IS THE SUM OF THE SQUARE OF THE RADIAL DIRECTION COSINE OF THE 
C PROJECTION OF THE DOPPLER RADIAL ON THE HORIZONTAL PLANE
C
                SUM15(II,JJ,KK,L2)=
     +          SUM15(II,JJ,KK,L2)+P*ALPHA0*ALPHA0
C
C SUM16 IS THE SUM OF THE PRODUCT OF THE AZIMUTHAL AND RADIAL DIRECTION COSINES
C OF THE DOPPLER RADIAL
C
                SUM16(II,JJ,KK,L2)=
     +          SUM16(II,JJ,KK,L2)+P*ALPHA0*BETA0
C
C SUM17 IS THE SUM OF THE PRODUCT OF THE TANGENTIAL DIRECTION COSINE TIMES
C THE RADIAL DIRECTION COSINE OF THE PROJECTION OF THE DOPPLER RADIAL ON THE
C HORIZONTAL PLANE
C
                SUM17(II,JJ,KK,L2)=
     +          SUM17(II,JJ,KK,L2)+P*ALPHA0*BETAI
C
C SUM18 IS THE SUM OF THE PRODUCT OF THE VERTICAL DIRECTION COSINE TIMES
C THE RADIAL DIRECTION COSINE OF THE PROJECTION OF THE DOPPLER RADIAL ON THE
C HORIZONTAL PLANE
C
                SUM18(II,JJ,KK,L2)=
     +          SUM18(II,JJ,KK,L2)+P*ALPHA0*GAMMA
C
C SUM19 IS THE SUM OF THE PRODUCT OF THE RADIAL DIRECTION COSINE TIMES
C THE AZIMUTHAL DIRECTION COSINE OF THE PROJECTION OF THE DOPPLER RADIAL ON THE
C HORIZONTAL PLANE
C
                SUM19(II,JJ,KK,L2)=
     +          SUM19(II,JJ,KK,L2)+P*BETA0*ALPHAI
C
C SUM20 IS THE SUM OF THE PRODUCT OF AZIMUTHAL DIRECTION COSINE 
C AND THE RADIAL DIRECTION COSINE OF THE PROJECTION OF THE RADIAL 
C ON THE HORIZONTAL PLANE
C
                SUM20(II,JJ,KK,L2)=
     +          SUM20(II,JJ,KK,L2)+P*BETA0*BETAI
C
C SUM21 IS THE SUM OF THE SQUARE OF THE AZIMUTHAL DIRECTION COSINE OF THE 
C PROJECTION OF THE DOPPLER RADIAL ON THE HORIZONTAL PLANE
C
                SUM21(II,JJ,KK,L2)=
     +          SUM21(II,JJ,KK,L2)+P*BETA0*BETA0
C
C SUM22 IS THE SUM OF THE PRODUCT OF THE VERTICAL DIRECTION COSINE TIMSE
C THE AZIMUTHAL DIRECTION COSINE OF THE PROJECTION OF THE DOPPLER RADIAL ON THE
C HORIZONTAL PLANE
C
                SUM22(II,JJ,KK,L2)=
     +          SUM22(II,JJ,KK,L2)+P*BETA0*GAMMA
C
C SUM23 IS AIR DENSITY AT THE GRID POINT TIMES THE RADIAL DIRECTION COSINE OF 
C THE PROJECTION OF THE DOPPLER RADIAL ON THE HORIZONTAL PLANE
C
                SUM23(II,JJ,KK,L2)=
     +          SUM23(II,JJ,KK,L2)+P*ALPHA0*RHOVRVR(KK)
C
C SUM24 IS AIR DENSITY AT THE GRID POINT TIMES THE AZIMUTHAL DIRECTION COSINE 
C OF THE PROJECTION OF THE DOPPLER RADIAL ON THE HORIZONTAL PLANE
C
                SUM24(II,JJ,KK,L2)=
     +          SUM24(II,JJ,KK,L2)+P*BETA0*RHOVRVR(KK)
C
C SUMWTSAVE IS THE SUM OF THE WEIGHTS OF ALL THE DOPPLER RADIAL VELOCITIES
C INTERPOLATED TO THE GRID POINT.  THIS DIFFERS FROM SUMMER, SINCE THERE ARE
C POINTS WITH REFLECTIVITY BUT WITH FLAGGED DOPPLER RADIAL VELOCITY
C
                SUMWTSAVE(II,JJ,KK,L2)=SUMWTSAVE(II,JJ,KK,L2)+P
C
C XWSAVE, YWSAVE, AND ZWSAVE ARE THE AVERAGE WEIGHTED DISPLACEMENT OF THE 
C DOPPLER OBSERVATIONS FROM THE LOCATIONS OF THE GRID POINTS
C
                XWSAVE(II,JJ,KK,L2)=XWSAVE(II,JJ,KK,L2)+P*RX(II)
                YWSAVE(II,JJ,KK,L2)=YWSAVE(II,JJ,KK,L2)+P*RY(JJ)
                ZWSAVE(II,JJ,KK,L2)=ZWSAVE(II,JJ,KK,L2)+P*RZ(KK)
               ENDIF
6298          ENDDO
             ENDDO
            ENDDO
           ENDIF
          ENDIF
         ENDIF
        ENDDO
       ENDIF
27272  NR=NR+1
      ENDDO
C
C BEGIN SUMMATIONS THAT ARE DESIGNED TO DIAGNOSE ERRORS IN ANTENNA TILT
C
C AS INDICATED ABOVE J=1 INDICATES AFT TILT, AND J=2 INDICATES FORE TILT
C
      DO J=1,2
C
C KNO INDICATES THE FIRST THREE RADII ALONG THE DOPPLER VECTOR
C
C VRTOT AND VRTOTN 
C
       DO KNO=1,3
        VRTOT(J,KNO)=0.
        VRTOTN(J,KNO)=0.
       ENDDO
       DO I=1,45
        DO KNO=1,3
         IF(SUMNVR(I,J,KNO).GT.0..AND.SUMNVR(I+45,J,KNO).GT.0.)THEN
         SUMVRSHOW(I,J,KNO)=SUMVR(I,J,KNO)/SUMNVR(I,J,KNO)
         SUMVRSHOW(I+45,J,KNO)=SUMVR(I+45,J,KNO)/SUMNVR(I+45,J,KNO)
         VRTOT(J,KNO)=
     +    VRTOT(J,KNO)+SUMVRSHOW(I,J,KNO)+SUMVRSHOW(I+45,J,KNO)
          VRTOTN(J,KNO)=VRTOTN(J,KNO)+2.
         ELSE
          SUMVRSHOW(I,J,KNO)=0.
          SUMVRSHOW(I+45,J,KNO)=0.
         ENDIF
        ENDDO
       ENDDO
      ENDDO
      DO J=1,2
       DO KNO=1,3
        VRINTERIM(J,KNO)=0.
        IF(VRTOTN(J,KNO).GT.0.)THEN
         VRTOT(J,KNO)=VRTOT(J,KNO)/VRTOTN(J,KNO)
         VRTOTSUM(J,KNO)=VRTOT(J,KNO)+VRTOTSUM(J,KNO)
         VRTOTSUMN(J,KNO)=VRTOTSUMN(J,KNO)+1.
        ELSE
         VRTOT(J,KNO)=0.
        ENDIF
        IF(VRTOTSUMN(J,KNO).GT.0.)THEN
         VRINTERIM(J,KNO)=VRTOTSUM(J,KNO)/VRTOTSUMN(J,KNO)
        ENDIF
       ENDDO
      ENDDO
C
C END DIAGNOSIS OF BIAS IN TILT ANGLE WHERE IT IS ASSUMED
C
      GO TO 92923
92929 WRITE(6,*)'JUST FINISHED VR SUMMATION'
c5554  OPEN(103,FILE='/hrd/dat/gustav/tracking/insideabcd')
c      WRITE(103,*)'AT STATEMENT 5554--NF=',NF
c      WRITE(103,*)'JUST FINISHED VR SUMMATION'
c      CLOSE(103)
C
C DETERMINE IF GRID POINT IS SURROUNDED BY DATA
C
C THE DISTXYZ STUFF SHOULD BE LEFT IN A RESEARCH VERSION BUT FOR NOW WE WILL
C SHUT IT OFF AND IT COULD BE REMOVED FOR REAL-TIME VERSION **LEGACY REMOVE?**
C
      DO L=1,2
       DO KK=1,KMAXB
        DO JJ=1,JMAXB
         DO II=1,IMAXB
          ITEST=0
          IF(KK.LE.4)THEN
           KABOT=2
          ELSE
           KABOT=1
          ENDIF
          DO KA=KABOT,2
           DO JA=1,2
            DO IA=1,2
             DIST=DISTXYZ(II,JJ,KK,L,IA,JA,KA)
C
C SETTING THIS TEST SO HIGH MEANS THE TEST OF A GRID POINT BEING SURROUNDED
C IS TURNED OFF
C
             IF(DIST.GE.99999999.)THEN
              SUM1(II,JJ,KK,L)=0
              SUM2(II,JJ,KK,L)=0
              SUM3(II,JJ,KK,L)=0
              SUM4(II,JJ,KK,L)=0
              SUM5(II,JJ,KK,L)=0
              SUM6(II,JJ,KK,L)=0
              SUM7(II,JJ,KK,L)=0
              SUM8(II,JJ,KK,L)=0
              SUM9(II,JJ,KK,L)=0
              SUM10(II,JJ,KK,L)=0
              SUM11(II,JJ,KK,L)=0
              SUM12(II,JJ,KK,L)=0
              SUM13(II,JJ,KK,L)=0
              SUM14(II,JJ,KK,L)=0
              SUM15(II,JJ,KK,L)=0
              SUM16(II,JJ,KK,L)=0
              SUM17(II,JJ,KK,L)=0
              SUM18(II,JJ,KK,L)=0
              SUM19(II,JJ,KK,L)=0
              SUM20(II,JJ,KK,L)=0
              SUM21(II,JJ,KK,L)=0
              SUM22(II,JJ,KK,L)=0
              SUM23(II,JJ,KK,L)=0
              SUM24(II,JJ,KK,L)=0
              XWSAVE(II,JJ,KK,L)=1000.*SUMWTSAVE(II,JJ,KK,L)
              YWSAVE(II,JJ,KK,L)=1000.*SUMWTSAVE(II,JJ,KK,L)
              ZWSAVE(II,JJ,KK,L)=1000.*SUMWTSAVE(II,JJ,KK,L)
              SUMWTSAVE(II,JJ,KK,L)=0.
              GO TO 10097
             ENDIF
            ENDDO
           ENDDO
          ENDDO
10097    ENDDO
        ENDDO
       ENDDO
      ENDDO
      IOKAY=1
72735 IF(IOKAY.EQ.1)THEN
C
C At end of each complete iteration
C
c       WRITE(6,*)'IN ABCD'
c       WRITE(6,*)'SUM1,SUM2,SUM3 = ',
c     + SUM1(1,1,1,1),SUM2(1,1,1,1),SUM3(1,1,1,1),
c     + SUMDBZ(1,1,1,1),SUMWTSAVE(1,1,1,1)
C
C L =1 AND 2 REPRESENT FORE AND AFT SUMMATIONS
C
       DO L=1,2
        DO KK=KMIN2,KMAX2
c        OPEN(102,FILE='/hrd/dat/gustav/tracking/abcd')
c        WRITE(102,*)'IN ABCD--K,NF = ',KK,NF
c        CLOSE(102)
         DO JJ=1,JMAXB
          DO II=1,IMAXB
C
C SUMWTSAVE AND SUMMER BOTH BEING GREATER THAN ZERO MEANS THERE ARE
C BOTH VELOCITY AND REFLECTIVITY DATA MAPPED TO THE GRID POINT 
C
           IF(SUMWTSAVE(II,JJ,KK,L).GT.0.AND.
     +       SUMMER(II,JJ,KK,L).GT.0.)THEN
C
C NORMALIZE THE SUMS OF THE PARAMETERS BY DIVIDING BY THE SUMS OF THE WEIGHTS
C THIS MAKES IT EASIER TO LOOK AT THE MAPPED SUMS IN GRAPHICS AND IT ALSO
C MAKES SURE EACH FILLED GRID POINT CONTRIBUTES EQUALLY TO THE FINAL WIND
C 3D WIND ANALYSIS
C
            SUM1(II,JJ,KK,L)=SUM1(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM2(II,JJ,KK,L)=SUM2(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM3(II,JJ,KK,L)=SUM3(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM4(II,JJ,KK,L)=SUM4(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM5(II,JJ,KK,L)=SUM5(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM6(II,JJ,KK,L)=SUM6(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM7(II,JJ,KK,L)=SUM7(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM8(II,JJ,KK,L)=SUM8(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM9(II,JJ,KK,L)=SUM9(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM10(II,JJ,KK,L)=SUM10(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM11(II,JJ,KK,L)=SUM11(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM12(II,JJ,KK,L)=SUM12(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM13(II,JJ,KK,L)=SUM13(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM14(II,JJ,KK,L)=SUM14(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM15(II,JJ,KK,L)=SUM15(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM16(II,JJ,KK,L)=SUM16(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM17(II,JJ,KK,L)=SUM17(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM18(II,JJ,KK,L)=SUM18(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM19(II,JJ,KK,L)=SUM19(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM20(II,JJ,KK,L)=SUM20(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM21(II,JJ,KK,L)=SUM21(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM22(II,JJ,KK,L)=SUM22(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM23(II,JJ,KK,L)=SUM23(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            SUM24(II,JJ,KK,L)=SUM24(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            XWSAVE(II,JJ,KK,L)=XWSAVE(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            YWSAVE(II,JJ,KK,L)=YWSAVE(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
            ZWSAVE(II,JJ,KK,L)=ZWSAVE(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
C
C ZE IS THE MEAN POWER AT THE GRID POINT
C
            ZE=SUMDBZ(II,JJ,KK,L)/SUMMER(II,JJ,KK,L)
C
C POWER WAS SUMMED SO SUMDBZ IS RETURNED TO DBZ
C
            SUMDBZ(II,JJ,KK,L)=10.*ALOG10(ZE)
           ELSEIF(SUMMER(II,JJ,KK,L).GT.0.)THEN
C
C THERE ARE NO VELOCITY DATA MAPPED TO THIS POINT BUT THERE ARE REFLECTIVITY
C DATA MAPPED
C
            ZE=SUMDBZ(II,JJ,KK,L)/SUMMER(II,JJ,KK,L)
            SUMDBZ(II,JJ,KK,L)=10.*ALOG10(ZE)
C
C IN THIS CASE THERE WILL BE NO VELOCITY DATA FROM THIS GRID POINT 
C CONTRIBUTING TO THE COST FUNCTION OF THE 3D WIND ANALYSIS
C
            SUM1(II,JJ,KK,L)=0
            SUM2(II,JJ,KK,L)=0
            SUM3(II,JJ,KK,L)=0
            SUM4(II,JJ,KK,L)=0
            SUM5(II,JJ,KK,L)=0
            SUM6(II,JJ,KK,L)=0
            SUM7(II,JJ,KK,L)=0
            SUM8(II,JJ,KK,L)=0
            SUM9(II,JJ,KK,L)=0
            SUM10(II,JJ,KK,L)=0
            SUM11(II,JJ,KK,L)=0
            SUM12(II,JJ,KK,L)=0
            SUM13(II,JJ,KK,L)=0
            SUM14(II,JJ,KK,L)=0
            SUM15(II,JJ,KK,L)=0
            SUM16(II,JJ,KK,L)=0
            SUM17(II,JJ,KK,L)=0
            SUM18(II,JJ,KK,L)=0
            SUM19(II,JJ,KK,L)=0
            SUM20(II,JJ,KK,L)=0
            SUM21(II,JJ,KK,L)=0
            SUM22(II,JJ,KK,L)=0
            SUM23(II,JJ,KK,L)=0
            SUM24(II,JJ,KK,L)=0
           ELSE
C
C THERE WERE NO REFLECTIVITY OR VELOCITY DATA WITHIN THE RADIUS OF INFLUENCE
C
            SUM1(II,JJ,KK,L)=0
            SUM2(II,JJ,KK,L)=0
            SUM3(II,JJ,KK,L)=0
            SUM4(II,JJ,KK,L)=0
            SUM5(II,JJ,KK,L)=0
            SUM6(II,JJ,KK,L)=0
            SUM7(II,JJ,KK,L)=0
            SUM8(II,JJ,KK,L)=0
            SUM9(II,JJ,KK,L)=0
            SUM10(II,JJ,KK,L)=0
            SUM11(II,JJ,KK,L)=0
            SUM12(II,JJ,KK,L)=0
            SUM13(II,JJ,KK,L)=0
            SUM14(II,JJ,KK,L)=0
            SUM15(II,JJ,KK,L)=0
            SUM16(II,JJ,KK,L)=0
            SUM17(II,JJ,KK,L)=0
            SUM18(II,JJ,KK,L)=0
            SUM19(II,JJ,KK,L)=0
            SUM20(II,JJ,KK,L)=0
            SUM21(II,JJ,KK,L)=0
            SUM22(II,JJ,KK,L)=0
            SUM23(II,JJ,KK,L)=0
            SUM24(II,JJ,KK,L)=0
            SUMDBZ(II,JJ,KK,L)=FLAG
           ENDIF
          ENDDO
         ENDDO
        ENDDO 
C
C DEBUG STATEMENT BELOW
C     
       WRITE(6,*)'SUM1,SUM2,SUM3,SUMDBZ,SUMWTSAVE = ',
     + SUM1(1,1,1,L),SUM2(1,1,1,L),SUM3(1,1,1,L),
     + SUMDBZ(1,1,1,L),SUMWTSAVE(1,1,1,L)
       ENDDO
      ENDIF
      RETURN
      END
      SUBROUTINE VRLOCATE(OLAT,OLON,TIMES,
     + RLAT,RLON,ALT,ELEV,AZIM,RANGE,XR,YR,ZR,
     + SMOTIONU,SMOTIONV,ISCANDIM,CENTIME,XSHFT,YSHFT,RAD,THETA,
     + ISCANMAX)
C
C THIS ROUTINE IS USED TO LOCATE AN OBSERVATION PROPERLY WITHIN THE 
C THE INTERPOLATION COORDINATE GRID
C
C OLAT AND OLON ARE LATITUDE AND LONGITUDE OF ANALYSIS GRID AT 
C      ANALYSIS "CENTER TIME"
C RLAT AND RLON ARE LATITUDE AND LONGITUDE OF AIRCRAFT (RADAR) AT TIME
C      OF OBSERVATION
C TIMES IS TIME IN SECONDS SINCE THE MIDNIGHT BEFORE TAKEOFF
C ALT IS ALTITUDE OF AIRCRAFT IN METERS
C AZIM IS THE EARTH-RELATIVE AZIMUTH OF THE DOPPLER RADIAL (DEFINED 
C      CLOCKWISE FROM NORTHWARD (NAVIGATION ANGLE)
C ELEV IS THE EARTH-RELATIVE ELEVATION 
C      (DEFINED COUNTER-CLOCKWISE FROM HORIZONTAL)
C RANGE IS THE DISTANCE FROM THE RADAR IN KM
C XR, YR, AND ZR ARE THE X, Y, AND Z LOCATIONS OF OBSERVATION RELATIVE 
C     TO ANALYSIS ORIGIN ADVECTED WITH STORM MOTION, WHERE X, Y AND Z
C     ARE THE EASTWARD-POSITIVE, NORTHWARD-POSITIVE, AND UPWARD-POSITIVE 
C     DIMENSIONS, RESPECTIVELY
C ISCANMAX IS THE NUMBER OF POINTS ALONG THE RADIAL TO DO THE LOCATION
C          COMPUTATION, AND SHOULD BE .LE. DIMENSION IN CALLING PROGRAM
C SMOTIONU AND SMOTIONV ARE THE ESTIMATED STORM MOTION IN M/S IN THE
C          EASTWARD-POSITIVE AND NORTHWARD-POSITIVE DIRECTIONS, RESPECTIVELY
C CENTIME IS THE TIME, IN SECONDS SINCE THE MIDNIGHT BEFORE TAKEOFF WHEN
C         THE ORIGIN OF THE ADVECTED ANALYSIS IS AT OLAT AND OLON
C XSHFT AND YSHFT ARE AMOUNT TO SHIFT X AND Y SEPARATE FROM THAT DUE TO
C       ADVECTION ASSOCIATED WITH STORM MOTION--THESE ARE ZERO FOR THE
C       AUTOMATED ANALYSES AND REAL-TIME
C RAD IS THE RADIUS IN KM FROM THE ORIGIN OF THE OBSERVATION
C THETA IS THE AZIMUTH ANGLE OF THE OBSERVATION FROM THE ORIGIN, DEFINED
C       COUNTER-CLOCKWISE FROM EASTWARD
C ISCANDIM IS THE DIMENSION OF THE RADIAL IN THIS ROUTINE AND MUST
C BE <= TO THE DIMENSION OF THE RADIAL IN THE CALLING PROGRAM
C
      REAL RANGE(ISCANDIM),XR(ISCANDIM),YR(ISCANDIM),ZR(ISCANDIM)
      REAL RAD(ISCANDIM),THETA(ISCANDIM)
C
C COMPUTE AIRCRAFT ALTITUDE IN KM
C
      RALT=ALT/1000.
C
C DEFINE THE MATHEMATICAL CONSTANT PI
C
      PI=ASIN(1.0)*2.
C
C FACTOR TO CONVERT ANGLE IN DEGREES TO ANGLE IN RADIANS
C
      DTR=PI/180.
C
C RADIUS OF EARTH IN KM
C
      REARTH=6366.
C
C DIFFERENCE BETWEEN OBSERVATION TIME AND ORIGIN CENTIME
C
      TDIFF=TIMES-CENTIME
C
C SHIFT IN X AND Y DUE TO MOTION OF STORM OVER TIME
C
      XSHIFT=TDIFF*SMOTIONU/1000.
      YSHIFT=TDIFF*SMOTIONV/1000.  
C
C EARTH-RELATIVE AZIMUTH AND ELEVATION IN RADIANS
C   
      RAZIM=AZIM*DTR
      RELEV=ELEV*DTR
      DO I=1,ISCANMAX
c xradar=horizontal distance from aircraft
c yradar=vertical distance from center of earth
       XRADAR=RANGE(I)*COS(RELEV)
       YRADAR=REARTH+RALT+RANGE(I)*SIN(RELEV)
c radnew=distance of datum from center of earth
       RADNEW=SQRT(XRADAR*XRADAR+YRADAR*YRADAR)
c       write(6,*)'I,XRADAR,YRADAR,RADNEW,REARTH,RALT,RELEV,RANGE = ',
c     1 I,XRADAR,YRADAR,RADNEW,REARTH,RALT,RELEV,RANGE(I)
c delangle=angle between vertical at aircraft and vertical at datum
       DELANGLE=ATAN(XRADAR/YRADAR)
c distance along great circle from radar to datum
       DISTANCE=.5*(RADNEW+REARTH+RALT)*DELANGLE
c height=altitude of datum
       HEIGHT=RADNEW-REARTH
c       WRITE(6,*)'HEIGHT,RADNEW,REARTH = ',HEIGHT,RADNEW,REARTH
c distance2=xradar
       DISTANCE2=RANGE(I)*COS(RELEV)
c height2=altitude of datum not accounting for earth's curvature
       HEIGHT2=RALT+RANGE(I)*SIN(RELEV)
c delx=distance (aircraft/datum) along great circle due to east west
       DELX=DISTANCE*SIN(RAZIM)
c dely=distance(aircraft/datum)along great circle due to north-south
       DELY=DISTANCE*COS(RAZIM)
c dx=east west distance from origin to aircraft
       XLAT=.5*(RLAT+OLAT)*DTR
       DX=(RLON-OLON)*DTR*REARTH*COS(XLAT)
c dy=north south distance from origin to aircraft
       DY=(RLAT-OLAT)*DTR*REARTH
c XR=eastward distance of datum from origin after any 
c    "manual shift" and advection
c YR=northward distance of datum from orgin after any
c    "manual shift" and advection
       XR(I)=DELX+DX-XSHIFT+XSHFT
c yshift=distance from lower left corner to origin
       YR(I)=DELY+DY-YSHIFT+YSHFT
c zr is the height of the observation
       ZR(I)=HEIGHT
       RAD(I)=SQRT(XR(I)*XR(I)+YR(I)*YR(I))
       THETA(I)=ATAN2(YR(I),XR(I))*180./3.14159
       IF(THETA(I).GT.360.)THETA(I)=THETA(I)-360.
       IF(THETA(I).LT.0.)THETA(I)=THETA(I)+360.
c       WRITE(1,*)'I,RANGE,DISTANCE,HEIGHT,DELX,DELY,DX,DY,XSHIFT,'
c     +  'YSHIFT = ',
c     +  I,RANGE(I),DISTANCE,HEIGHT,DELX,DELY,DX,DY,XSHIFT,YSHIFT
      ENDDO
      CONTINUE
      END
