      SUBROUTINE CFRAD_SWEEP_READER(FILENAME,DIMRANGE,DIMTIME,DBZ,
     +     VEL,WIDTH,SQI,RANGE,EAZM,EEV,LATITUDE,LONGITUDE,ALTITUDE,
     +     HEADING,TRACK,ROLL,PITCH,
     +     DRIFT,ROTATION,TILT,GSE,GSN,VGS,U,V,W,TIMESECS,
     +     FLIGHTID6TEST,FLIGHTID6,AZ_EL,IAUTOMAN,
     +     PCOR,DCOR,AZMCOR,ELCOR,FLOATSHORT,CHARDBZ,CHARV,CHARWIDTH,
     +     CHARSQI)
      USE NETCDF
C     NEED AZ_EL
C     NEED TO COMPUTE PROPER TIME
      IMPLICIT NONE
      REAL TRACKTEMP,TRAKAZMTEMP,TRAKELEVTEMP,HORAZM,HORELEV
      INTEGER MAX_HRD_DIM,MAX_RAYS,IDRADAR,IBST
      PARAMETER(MAX_HRD_DIM=2048,MAX_RAYS=800)
      INTEGER ISTAT,ISTAT2,MODE,NCID,BUFRSIZE,CACHE_SIZE,CACHE_NELEMS
      INTEGER DBZVARID,DBZUNITLENGTH,XTYPE,NUMTIME,I,J,VELVARID
      INTEGER WIDTHVARID,SQIVARID,RANGEVARID,AZIMUTHVARID,ELEVATIONVARID
      INTEGER LATITUDEVARID,LONGITUDEVARID,TIMEVARID,HEADINGVARID
      INTEGER TRACKVARID,ROLLVARID,DRIFTVARID,ROTATIONVARID,TILTVARID
      INTEGER GSEVARID,GSNVARID,VGSVARID,UVARID,VVARID,WVARID
      INTEGER ALTITUDEVARID,PITCHVARID,IAUTOMAN
      INTEGER COMM,INFO,IDDIMTIME,IDRANGE,DIMTIME,DIMRANGE,DBZDIMIDS(2)
      INTEGER IYEAR,IMONTH,IDAY,IHOURS,IMINS,ISECS,IYEAR2
      CHARACTER FLIGHTID6*6,FLIGHTID6TEST*6
      CHARACTER*10 CHARDBZ,CHARV,CHARSQI,CHARWIDTH
      INTEGER FLOATSHORT,ILENTRIMDBZ,ILENTRIMVEL,ILENTRIMWIDTH
      INTEGER ILENTRIMSQI
      REAL TIMESECSIN,TIMESECS(MAX_RAYS),AZ_EL(2,MAX_RAYS)
      REAL PITCH1,DRIFT1,ROLL1,TRAKAZM,TRAKELEV
      REAL PCOR,DCOR,RCOR,AZMCOR,ELCOR
      REAL DBZ(MAX_HRD_DIM,MAX_RAYS)
      REAL VEL(MAX_HRD_DIM,MAX_RAYS)
      REAL WIDTH(MAX_HRD_DIM,MAX_RAYS)
      REAL SQI(MAX_HRD_DIM,MAX_RAYS)
      REAL RANGE(MAX_HRD_DIM),EAZM(MAX_RAYS),EEV(MAX_RAYS)
      REAL LATITUDE(MAX_RAYS),LONGITUDE(MAX_RAYS)
      REAL TIME(MAX_RAYS),ALTITUDE(MAX_RAYS),HEADING(MAX_RAYS)
      REAL TRACK(MAX_RAYS),ROLL(MAX_RAYS),PITCH(MAX_RAYS)
      REAL DRIFT(MAX_RAYS),ROTATION(MAX_RAYS),TILT(MAX_RAYS)
      REAL GSE(MAX_RAYS),GSN(MAX_RAYS),VGS(MAX_RAYS)
      REAL U(MAX_RAYS),V(MAX_RAYS),W(MAX_RAYS)
      INTEGER*2, DIMENSION(:,:),ALLOCATABLE::IDBZ
      INTEGER*2, DIMENSION(:,:),ALLOCATABLE::IVEL
      REAL, DIMENSION(:,:),ALLOCATABLE::RDBZ
      REAL, DIMENSION(:,:),ALLOCATABLE::RVEL
      REAL, DIMENSION(:,:),ALLOCATABLE::DBZIN
      REAL, DIMENSION(:,:),ALLOCATABLE::VELIN
      INTEGER*2, DIMENSION(:,:),ALLOCATABLE::IWIDTH
      INTEGER*2, DIMENSION(:,:),ALLOCATABLE::ISQI
      REAL, DIMENSION(:,:),ALLOCATABLE::RWIDTH
      REAL, DIMENSION(:,:),ALLOCATABLE::RSQI
      REAL, DIMENSION(:,:),ALLOCATABLE::WIDTHIN
      REAL, DIMENSION(:,:),ALLOCATABLE::SQIIN
      REAL, DIMENSION(:),ALLOCATABLE::RANGEIN
      REAL, DIMENSION(:),ALLOCATABLE::AZIMUTHIN
      REAL, DIMENSION(:),ALLOCATABLE::ELEVATIONIN
      DOUBLE PRECISION, DIMENSION(:),ALLOCATABLE::LATITUDEIN      
      DOUBLE PRECISION, DIMENSION(:),ALLOCATABLE::LONGITUDEIN
      DOUBLE PRECISION, DIMENSION(:),ALLOCATABLE::TIMEIN
      DOUBLE PRECISION, DIMENSION(:),ALLOCATABLE::ALTITUDEIN
      REAL, DIMENSION(:),ALLOCATABLE::HEADINGIN
      REAL, DIMENSION(:),ALLOCATABLE::TRACKIN
      REAL, DIMENSION(:),ALLOCATABLE::ROLLIN
      REAL, DIMENSION(:),ALLOCATABLE::PITCHIN
      REAL, DIMENSION(:),ALLOCATABLE::DRIFTIN
      REAL, DIMENSION(:),ALLOCATABLE::ROTATIONIN     
      REAL, DIMENSION(:),ALLOCATABLE::TILTIN
      REAL, DIMENSION(:),ALLOCATABLE::GSEIN
      REAL, DIMENSION(:),ALLOCATABLE::GSNIN
      REAL, DIMENSION(:),ALLOCATABLE::VGSIN
      REAL, DIMENSION(:),ALLOCATABLE::UIN
      REAL, DIMENSION(:),ALLOCATABLE::VIN
      REAL, DIMENSION(:),ALLOCATABLE::WIN
      REAL CACHE_PREEMPTION
      CHARACTER*160 FILENAME
      CHARACTER CTIME*53
c      WRITE(6,*)'FILENAME = ',FILENAME
      MODE=0
      WRITE(6,*)'ENTERED CFRAD_SWEEP_READER'
      ISTAT=NF90_OPEN(FILENAME,MODE,NCID)
c      WRITE(6,*)'OPEN STATUS = ',ISTAT
C      CTIME='time'
C      CRANGE='range'
c     Jan 26 2024 Temporarily change manual to vel since paul used it for dual-PRF
      ILENTRIMDBZ=LEN_TRIM(CHARDBZ)
      ILENTRIMVEL=LEN_TRIM(CHARV)
      ILENTRIMWIDTH=LEN_TRIM(CHARWIDTH)
      ILENTRIMSQI=LEN_TRIM(CHARSQI)
      ISTAT=NF90_INQ_VARID(NCID,CHARDBZ,DBZVARID)
      ISTAT=NF90_INQ_VARID(NCID,CHARV,VELVARID)
      ISTAT=NF90_INQ_VARID(NCID,CHARWIDTH,WIDTHVARID)
      ISTAT=NF90_INQ_VARID(NCID,CHARSQI,SQIVARID)
      WRITE(6,*)'CHARDBZ = ',CHARDBZ
      WRITE(6,*)'CHARV = ',CHARV
      WRITE(6,*)'CHARWIDTH = ',CHARWIDTH
      WRITE(6,*)'CHARSQI = ',CHARSQI
      WRITE(6,*)'FLOATSHORT = ',FLOATSHORT
      WRITE(6,*)'IAUTOMAN = ',IAUTOMAN
      WRITE(6,*)'DBZVARID STATUS, VALUE = ',ISTAT,DBZVARID
      WRITE(6,*)'VELVARID STATUS, VALUE = ',ISTAT,VELVARID
      WRITE(6,*)'WIDTHVARID STATUS, VALUE = ',ISTAT,WIDTHVARID
      WRITE(6,*)'SQIVARID STATUS, VALUE = ',ISTAT,SQIVARID

C      IF(IAUTOMAN.EQ.1)THEN
c     ISTAT=NF90_INQ_VARID(NCID,"DZ",DBZVARID)
C         WRITE(6,*)'CHECKING DBZ'
C         ISTAT=NF90_INQ_VARID(NCID,"DBZ",DBZVARID)         
C      ELSE
C         ISTAT=NF90_INQ_VARID(NCID,"DBZ",DBZVARID)
C      ENDIF

      ISTAT=NF90_INQUIRE_VARIABLE(NCID,DBZVARID,DIMIDS=DBZDIMIDS)
c      WRITE(6,*)'ISTAT DBZINQUIREVARIABLE = ',ISTAT
c      WRITE(6,*)'GOT THE DIMENSION IDS FOR EACH DBZ DIMENSION'
      ISTAT=NF90_INQUIRE_DIMENSION(NCID,DBZDIMIDS(1),LEN=DIMRANGE)
      ISTAT2=NF90_INQUIRE_DIMENSION(NCID,DBZDIMIDS(2),LEN=DIMTIME)
c      WRITE(6,*)'ISTAT DBZDIMIDS 1 AND 2 = ',ISTAT
c      WRITE(6,*)'DIMTIME,DIMRANGE = ',DIMTIME,DIMRANGE

      ISTAT=NF90_INQ_VARID(NCID,"range",RANGEVARID)      
      ALLOCATE(RANGEIN(DIMRANGE))
      ISTAT=NF90_GET_VAR(NCID,RANGEVARID,RANGEIN)
c      WRITE(6,*)'SUBROUTINE RANGE, ISTAT = ',ISTAT
c      WRITE(6,100)(RANGEIN(I),I=1,DIMRANGE)
      DO I=1,MAX_HRD_DIM
         IF(I.LE.DIMRANGE)THEN
            RANGE(I)=RANGEIN(I)
         ELSE
            RANGE(I)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"azimuth",AZIMUTHVARID)      
      ALLOCATE(AZIMUTHIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,AZIMUTHVARID,AZIMUTHIN)
c      WRITE(6,*)'SUBROUTINE AZIMUTH, ISTAT = ',ISTAT
c      WRITE(6,100)(AZIMUTHIN(J),J=1,DIMTIME)
c     EAZM AND AZIMUTHIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            EAZM(J)=AZIMUTHIN(J)
         ELSE
            EAZM(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"elevation",ELEVATIONVARID)      
      ALLOCATE(ELEVATIONIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,ELEVATIONVARID,ELEVATIONIN)
c      WRITE(6,*)'SUBROUTINE ELEVATION, ISTAT = ',ISTAT
c      WRITE(6,100)(ELEVATIONIN(J),J=1,DIMTIME)
C     EEV AND ELEVATIONIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            EEV(J)=ELEVATIONIN(J)
         ELSE
            EEV(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"latitude",LATITUDEVARID)      
      ALLOCATE(LATITUDEIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,LATITUDEVARID,LATITUDEIN)
c      WRITE(6,*)'SUBROUTINE LATITUDE, ISTAT = ',ISTAT
c      WRITE(6,100)(LATITUDEIN(J),J=1,DIMTIME)
C     LATITUDE IS REAL AND LATITUDEIN IS DOUBLE
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            LATITUDE(J)=LATITUDEIN(J)
         ELSE
            LATITUDE(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"longitude",LONGITUDEVARID)      
      ALLOCATE(LONGITUDEIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,LONGITUDEVARID,LONGITUDEIN)
c      WRITE(6,*)'SUBROUTINELONGITUDE, ISTAT = ',ISTAT
c      WRITE(6,100)(LONGITUDEIN(J),J=1,DIMTIME)
C     LONGITUDE IS REAL AND LONGITUDEIN IS DOUBLE PRECISION
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            LONGITUDE(J)=LONGITUDEIN(J)
         ELSE
            LONGITUDE(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"time",TIMEVARID)      
      ALLOCATE(TIMEIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,TIMEVARID,TIMEIN)
c      WRITE(6,*)'TIME, ISTAT = ',ISTAT
c      WRITE(6,100)(TIMEIN(J),J=1,DIMTIME)
C     TIME IS REAL AND TIMEIN IS DOUBLE PRECISION
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            TIME(J)=TIMEIN(J)
         ELSE
            TIME(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_GET_ATT(NCID,TIMEVARID,"units",CTIME)
      WRITE(6,*)'ISTAT = ',ISTAT
      WRITE(6,'(A)')CTIME
      READ(CTIME,333)IYEAR,IMONTH,IDAY,IHOURS,IMINS,ISECS
 333  FORMAT(14X,I4,1X,I2,1X,I2,1X,I2,1X,I2,1X,I2)
      IYEAR2=IYEAR-2000
      WRITE(6,334)IYEAR,IMONTH,IDAY,IHOURS,IMINS,ISECS
 334  FORMAT(I4,2I2.2,1X,3I2.2)
C     TIMESECSIN IS REAL
      TIMESECSIN=IHOURS*3600.+IMINS*60.+ISECS
      WRITE(6,*)'TIMESECS = ',TIMESECSIN

      WRITE(FLIGHTID6,'(3I2.2)')IYEAR2,IMONTH,IDAY
      WRITE(6,*)'FLIGHTID6 = ',FLIGHTID6
      WRITE(6,*)'FLIGHTID6TEST = ',FLIGHTID6TEST
C     TIMESECS, TIMESECSIN AND TIME ARE ALL REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            TIMESECS(J)=TIMESECSIN+TIME(J)
         ELSE
            TIMESECS(J)=-999.9
         ENDIF
         IF(J.LE.DIMTIME.AND.FLIGHTID6.NE.FLIGHTID6TEST)THEN
            TIMESECS(J)=TIMESECS(J)+86400.
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"altitude",ALTITUDEVARID)      
      ALLOCATE(ALTITUDEIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,ALTITUDEVARID,ALTITUDEIN)
c      WRITE(6,*)'SUBROUTINE ALTITUDE, ISTAT = ',ISTAT
c      WRITE(6,100)(ALTITUDEIN(J),J=1,DIMTIME)
C     ALTITUDE IS REAL AND ALTITUDEIN IS DOUBLE
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            ALTITUDE(J)=ALTITUDEIN(J)
         ELSE
            ALTITUDE(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"heading",HEADINGVARID)      
      ALLOCATE(HEADINGIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,HEADINGVARID,HEADINGIN)
c      WRITE(6,*)'SUBROUTINE HEADING, ISTAT = ',ISTAT
c      WRITE(6,100)(HEADINGIN(J),J=1,DIMTIME)
C     HEADING AND HEADINGIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            HEADING(J)=HEADINGIN(J)
         ELSE
            HEADING(J)=-999.9
         ENDIF
      ENDDO

c      ISTAT=NF90_INQ_VARID(NCID,"track",TRACKVARID)      
c      ALLOCATE(TRACKIN(DIMTIME))
c      ISTAT=NF90_GET_VAR(NCID,TRACKVARID,TRACKIN)
cc      WRITE(6,*)'SUBROUTINE, ISTAT = ',ISTAT
cc      WRITE(6,100)(TRACKIN(J),J=1,DIMTIME)
cC     TRACK AND TRACKIN ARE BOTH REAL
c      DO J=1,MAX_RAYS
c         IF(J.LE.DIMTIME)THEN
c            TRACK(J)=TRACKIN(J)
c         ELSE
c            TRACK(J)=-999.0
c         ENDIF
c      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"roll",ROLLVARID)      
      ALLOCATE(ROLLIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,ROLLVARID,ROLLIN)
c      WRITE(6,*)'SUBROUTINE ROLL, ISTAT = ',ISTAT
c      WRITE(6,100)(ROLLIN(J),J=1,DIMTIME)
C     ROLL AND ROLLIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            ROLL(J)=ROLLIN(J)
         ELSE
            ROLL(J)=-999.0
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"pitch",PITCHVARID)      
      ALLOCATE(PITCHIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,PITCHVARID,PITCHIN)
c      WRITE(6,*)'SUBROUTINE PITCH, ISTAT = ',ISTAT
c      WRITE(6,100)(PITCHIN(J),J=1,DIMTIME)
C     PITCH AND PITCHIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            PITCH(J)=PITCHIN(J)
         ELSE
            PITCH(J)=-999.9
         ENDIF
       ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"drift",DRIFTVARID)      
      ALLOCATE(DRIFTIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,DRIFTVARID,DRIFTIN)
c      WRITE(6,*)'SUBROUTINE DRIFT, ISTAT = ',ISTAT
c      WRITE(6,100)(DRIFTIN(J),J=1,DIMTIME)
C     DRIFT AND DRIFTIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            DRIFT(J)=DRIFTIN(J)
         ELSE
            DRIFT(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"rotation",ROTATIONVARID)      
      ALLOCATE(ROTATIONIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,ROTATIONVARID,ROTATIONIN)
c      WRITE(6,*)'SUBROUTINE ROTATION, ISTAT = ',ISTAT
c      WRITE(6,100)(ROTATIONIN(J),J=1,DIMTIME)
C     ROTATION AND ROTATIONIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            ROTATION(J)=ROTATIONIN(J)
         ELSE
            ROTATION(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"tilt",TILTVARID)      
      ALLOCATE(TILTIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,TILTVARID,TILTIN)
c      WRITE(6,*)'SUBROUTINE TILT, ISTAT = ',ISTAT
c      WRITE(6,100)(TILTIN(J),J=1,DIMTIME)
C     TILT AND TILTIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            TILT(J)=TILTIN(J)
         ELSE
            TILT(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"eastward_velocity",GSEVARID)      
      ALLOCATE(GSEIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,GSEVARID,GSEIN)
c      WRITE(6,*)'SUBROUTINE GSE, ISTAT = ',ISTAT
c      WRITE(6,100)(GSEIN(J),J=1,DIMTIME)
C     GSE AND GSEIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            GSE(J)=GSEIN(J)
         ELSE
            GSE(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"northward_velocity",GSNVARID)      
      ALLOCATE(GSNIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,GSNVARID,GSNIN)
c      WRITE(6,*)'SUBROUTINE GSN, ISTAT = ',ISTAT
c      WRITE(6,100)(GSNIN(J),J=1,DIMTIME)
C     GSN AND GSNIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            GSN(J)=GSNIN(J)
         ELSE
            GSN(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"vertical_velocity",VGSVARID)      
      ALLOCATE(VGSIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,VGSVARID,VGSIN)
c      WRITE(6,*)'SUBROUTINE VGS, ISTAT = ',ISTAT
c      WRITE(6,100)(VGSIN(J),J=1,DIMTIME)
C     VGS AND VGSIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            VGS(J)=VGSIN(J)
         ELSE
            VGS(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"eastward_wind",UVARID)      
      ALLOCATE(UIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,UVARID,UIN)
c      WRITE(6,*)'SUBROUTINE U, ISTAT = ',ISTAT
c      WRITE(6,100)(UIN(J),J=1,DIMTIME)
C     BOTH U AND UIN ARE REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            U(J)=UIN(J)
         ELSE
            U(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"northward_wind",VVARID)      
      ALLOCATE(VIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,VVARID,VIN)
c      WRITE(6,*)'SUBROUTINE V, ISTAT = ',ISTAT
c      WRITE(6,100)(VIN(J),J=1,DIMTIME)
C     V AND VIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            V(J)=VIN(J)
         ELSE
            V(J)=-999.9
         ENDIF
      ENDDO

      ISTAT=NF90_INQ_VARID(NCID,"vertical_wind",WVARID)      
      ALLOCATE(WIN(DIMTIME))
      ISTAT=NF90_GET_VAR(NCID,WVARID,WIN)
c      WRITE(6,*)'SUBROUTINE W, ISTAT = ',ISTAT
c      WRITE(6,100)(WIN(J),J=1,DIMTIME)
C     W AND WIN ARE BOTH REAL
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            W(J)=WIN(J)
         ELSE
            W(J)=-999.9
         ENDIF
      ENDDO
      ALLOCATE(DBZIN(DIMRANGE,DIMTIME))
      IF(FLOATSHORT.EQ.4)THEN
         ALLOCATE(RDBZ(DIMRANGE,DIMTIME))
         ISTAT=NF90_GET_VAR(NCID,DBZVARID,RDBZ)
      ELSE
         ALLOCATE(IDBZ(DIMRANGE,DIMTIME))
         ISTAT=NF90_GET_VAR(NCID,DBZVARID,IDBZ)
      ENDIF
C      ISTAT=NF90_GET_VAR(NCID,DBZVARID,IDBZ)
      WRITE(6,*)'ISTAT GET VAR DBZ = ',ISTAT
C     IDBZ IS INTEGER*2 AND DBZIN IS REAL
      DO J=1,DIMTIME
c     WRITE(6,*)'DBZ J = ',J
         IF(FLOATSHORT.EQ.4)THEN
            DO I=1,DIMRANGE
               IF(RDBZ(I,J).LT.-30000)THEN
                  DBZIN(I,J)=-32.
               ELSE
                  DBZIN(I,J)=RDBZ(I,J)
               ENDIF
            ENDDO
         ELSE
            DO I=1,DIMRANGE
               IF(IDBZ(I,J).LT.-30000)THEN
                  DBZIN(I,J)=-32.
               ELSE
                  DBZIN(I,J)=IDBZ(I,J)/100
               ENDIF
            ENDDO
         ENDIF
c         WRITE(6,200)(IDBZ(I,J),I=1,DIMRANGE)
c         WRITE(6,100)(DBZIN(I,J),I=1,DIMRANGE)
 100     FORMAT(10F8.2)
      ENDDO
c Jan 26 2024 Temporarily change manual to vel since paul used it for dual-PRF
C      IF(FLOATSHORT.EQ.4THEN
C     c         ISTAT=NF90_INQ_VARID(NCID,"VU",VELVARID)
      ISTAT=NF90_INQ_VARID(NCID,CHARV,VELVARID)         
C      ELSE
C         ISTAT=NF90_INQ_VARID(NCID,"VEL",VELVARID)
C      ENDIF
c
      WRITE(6,*)'VELVARID STATUS 1, VALUE = ',ISTAT,VELVARID
      ALLOCATE(VELIN(DIMRANGE,DIMTIME))
      IF(FLOATSHORT.EQ.4)THEN
         ALLOCATE(RVEL(DIMRANGE,DIMTIME))         
         ISTAT=NF90_GET_VAR(NCID,VELVARID,RVEL)
      ELSE
         ALLOCATE(IVEL(DIMRANGE,DIMTIME))
         ISTAT=NF90_GET_VAR(NCID,VELVARID,IVEL)
      ENDIF
      WRITE(6,*)'VELVARID STATUS 2, VALUE = ',ISTAT,VELVARID
C     IVEL IS INTEGER*2 AND VELIN IS REAL
      DO J=1,DIMTIME
c     WRITE(6,*)'VEL J = ',J
         IF(FLOATSHORT.EQ.4)THEN
            DO I=1,DIMRANGE
               IF(RVEL(I,J).LT.-299.)THEN
                  VELIN(I,J)=-888.8
               ELSE
c     VELIN(I,J)=IVEL(I,J)/100.
                  VELIN(I,J)=RVEL(I,J)               
               ENDIF
            ENDDO
         ELSE
            DO I=1,DIMRANGE
               IF(IVEL(I,J).LT.-30000)THEN
                  VELIN(I,J)=-888.8
               ELSE
                  VELIN(I,J)=IVEL(I,J)/100.
C                  VELIN(I,J)=IVEL(I,J)               
               ENDIF
            ENDDO
         ENDIF
c         WRITE(6,200)(IVEL(I,J),I=1,DIMRANGE)
c         WRITE(6,100)(VELIN(I,J),I=1,DIMRANGE)
      ENDDO
      ALLOCATE(WIDTHIN(DIMRANGE,DIMTIME))      
      ISTAT=NF90_INQ_VARID(NCID,CHARWIDTH,WIDTHVARID)
      WRITE(6,*)'ISTAT FOR WIDTHVARID = ',ISTAT
      IF(FLOATSHORT.EQ.4)THEN
         ALLOCATE(RWIDTH(DIMRANGE,DIMTIME))
         ISTAT=NF90_GET_VAR(NCID,WIDTHVARID,RWIDTH)
      ELSE
         ALLOCATE(IWIDTH(DIMRANGE,DIMTIME))
         ISTAT=NF90_GET_VAR(NCID,WIDTHVARID,IWIDTH)
      ENDIF
      WRITE(6,*)'ISTAT FOR WIDTHVARID,VALUE = ',ISTAT,WIDTHVARID
C     IWIDTH IS INTEGER*2 AND WIDTHIN IS REAL
      DO J=1,DIMTIME
c          WRITE(6,*)'J = ',J
          IF(FLOATSHORT.EQ.4)THEN
c             WRITE(6,*)'DIMTIME,WIDTH J = ',DIMTIME,J
             DO I=1,DIMRANGE
c                WRITE(6,*)'I,J,DIMRANGE,DIMTIME = ',
c     +               I,J,DIMRANGE,DIMTIME
c                WRITE(6,*)'RWIDTH(I,J) = ',RWIDTH(I,J)
c                WRITE(6,*)'WIDTHIN(I,J) = ',WIDTHIN(I,J)
                IF(RWIDTH(I,J).LT.-299.)THEN
                   WIDTHIN(I,J)=-888.8
                ELSE
                   WIDTHIN(I,J)=RWIDTH(I,J)
                ENDIF
             ENDDO
          ELSE
             DO I=1,DIMRANGE
                IF(IWIDTH(I,J).LT.-299.)THEN
                   WIDTHIN(I,J)=-888.8
                ELSE
                   WIDTHIN(I,J)=327.68+IWIDTH(I,J)/100.
                ENDIF
             ENDDO
         ENDIF
 200     FORMAT(10I8)
c         WRITE(6,100)(WIDTHIN(I,J),I=1,DIMRANGE)
      ENDDO
      ISTAT=NF90_INQ_VARID(NCID,CHARSQI,SQIVARID)
      WRITE(6,*)'ISTAT VALUE FOR CHARSQI  = ',ISTAT
      ALLOCATE(SQIIN(DIMRANGE,DIMTIME))
      IF(FLOATSHORT.EQ.4)THEN
         ALLOCATE(RSQI(DIMRANGE,DIMTIME))
         ISTAT=NF90_GET_VAR(NCID,SQIVARID,ISQI)
      ELSE
         ALLOCATE(ISQI(DIMRANGE,DIMTIME))
         ISTAT=NF90_GET_VAR(NCID,SQIVARID,RSQI)
      ENDIF
      WRITE(6,*)'ISTAT VALUE FOR SQIVARID,VALUE = ',ISTAT,SQIVARID
C     ISQI IS INTEGER*2 AND SQIIN IS REAL
      DO J=1,DIMTIME
         IF(FLOATSHORT.EQ.4)THEN
c            WRITE(6,*)'SQI J = ',J
            DO I=1,DIMRANGE
c               WRITE(6,*)'SQI I,J = ',I,J
               IF(RSQI(I,J).LT.-299.)THEN
                  SQIIN(I,J)=0.
               ELSE
                  SQIIN(I,J)=RSQI(I,J)
               ENDIF
            ENDDO
         ELSE
            DO I=1,DIMRANGE
               IF(ISQI(I,J).LT.-32767)THEN
                  SQIIN(I,J)=0.
               ELSE
                  SQIIN(I,J)=.5+ISQI(I,J)*.00001525949
               ENDIF
            ENDDO   
c     WRITE(6,100)(SQIIN(I,J),I=1,DIMRANGE)
         ENDIF
      ENDDO
      WRITE(6,*)'I GOT HERE ALL 8 VARIABLES'
      DO J=1,DIMTIME
         DO I=1,DIMRANGE
C     ALL 8 VARIABLES IN THIS LOOP ARE REAL
            DBZ(I,J)=DBZIN(I,J)
            VEL(I,J)=VELIN(I,J)
            WIDTH(I,J)=WIDTHIN(I,J)
            SQI(I,J)=SQIIN(I,J)
         ENDDO
         IF(DIMRANGE.LT.MAX_HRD_DIM)THEN
            DO I=DIMRANGE+1,MAX_HRD_DIM
               DBZ(I,J)=-32.0
               VEL(I,J)=-888.8
               WIDTH(I,J)=-888.8
               SQI(I,J)=0.
            ENDDO
         ENDIF
      ENDDO
      WRITE(6,*)'I GOT HERE ALL 8 VARIABLES 2'
      IF(DIMTIME.LT.MAX_RAYS)THEN
         DO J=DIMTIME+1,MAX_RAYS
            DO I=1,MAX_HRD_DIM
               DBZ(I,J)=-32.0
               VEL(I,J)=-888.8
               WIDTH(I,J)=-888.8
               SQI(I,J)=0.
            ENDDO
         ENDDO
      ENDIF
      ISTAT=NF90_CLOSE(NCID)
      RCOR=0.
      IF(IAUTOMAN.EQ.0)THEN
         PCOR=0.
         DCOR=0.
         AZMCOR=0.
         ELCOR=0.
      ENDIF
C     ALL THE VARIABLES IN THIS LOOP ARE REAL
      WRITE(6,*)'PCOR,DCOR,AZMCOR,ELCOR = ',PCOR,DCOR,AZMCOR,ELCOR
      WRITE(6,*)'IAUTOMAN = ',IAUTOMAN
      DO J=1,MAX_RAYS
         IF(J.LE.DIMTIME)THEN
            PITCH1=PITCH(J)
            DRIFT1=DRIFT(J)
            ROLL1=ROLL(J)
            TRAKAZM=ROTATION(J)
            TRAKELEV=TILT(J)
            IDRADAR=2
            IF(PITCH1.GT.-100..AND.DRIFT1.GT.-100..AND.ROLL1.GT.-100..
     +           AND.TRAKAZM.GT.-100..AND.TRAKELEV.GT.-100.)THEN
               TRACK(J)=AMOD(HEADING(J)+DRIFT1+DCOR+360.0,360.)
               CALL ANGLECOR(PITCH1,DRIFT1,ROLL1,TRAKAZM,TRAKELEV,
     +           IDRADAR,PCOR,DCOR,RCOR,AZMCOR,ELCOR)
               TRACKTEMP=TRACK(J)
               TRAKAZMTEMP=TRAKAZM
               TRAKELEVTEMP=TRAKELEV
c               WRITE(6,*)'J,TRACK,TRAKAZM,TRAKELEV BEFORE = ',
c     +              J,TRACKTEMP,TRAKAZMTEMP,TRAKAZMTEMP,TRAKELEVTEMP
c               WRITE(6,*)'J,HORAZM, HORELEV BEFORE = ',J,HORAZM,HORELEV
               CALL CONVERTANGLES(TRACKTEMP,TRAKAZMTEMP,TRAKELEVTEMP,
     +              HORAZM,HORELEV)
c               WRITE(6,*)'J,TRACK,TRAKAZM,TRAKELEV AFTER = ',
c     +            J,TRACKTEMP,TRAKAZMTEMP,TRAKAZMTEMP,TRAKELEVTEMP
c               WRITE(6,*)'J,HORAZM, HORELEV AFTER = ',J,HORAZM,HORELEV
               AZ_EL(1,J)=TRAKAZMTEMP
               AZ_EL(2,J)=TRAKELEVTEMP
               IF(IAUTOMAN.EQ.1)THEN
                  HORAZM=90-HORAZM
                  IF(HORAZM.LT.0.)HORAZM=HORAZM+360.
                  IF(HORAZM.GT.360.)HORAZM=HORAZM-360.
c     TRACK(J)=TRACKTEMP
                  EEV(J)=HORELEV
                  EAZM(J)=HORAZM
               ENDIF
            ELSE
               AZ_EL(1,J)=-999.9
               AZ_EL(2,J)=-999.9
            ENDIF
            IF(IAUTOMAN.EQ.1)THEN
               PITCH(J)=PITCH1
               DRIFT(J)=DRIFT1
               ROTATION(J)=ROTATION(J)+AZMCOR
               TILT(J)=TILT(J)+ELCOR
            ENDIF
         ELSE
            AZ_EL(1,J)=-999.9
            AZ_EL(2,J)=-999.9
         ENDIF
      ENDDO
      RETURN
      END
