      PROGRAM MAKEINOUTFILES
C 
C A program to make the files infiles, infiles_profile, outfiles,
C and outfiles_profile that are used to make the netcdf versions of the 3D
C and radial profile wind and reflectivity analysis files.
C
C INFILE Variable contains 8-byte flight ID, two underscore 
C and a 4-byte center time
      CHARACTER INFILE*14,DUMMY*80,FLIGHTID*8,STORM*12
      CHARACTER DIRECTORY*60,FILE*18,PREFIX*14
C file infiles contains the input 3D files that will be converted to
C 3D netcdf files
      OPEN(71,FILE='jobfile_radar')
      OPEN(72,FILE='jobfile_radar_in')
      OPEN(73,FILE='jobfile_radar_out')
      READ(71,'(A)')DUMMY
      READ(71,'(A)')DUMMY
      READ(72,'(A)')DUMMY
      READ(72,'(A)')DUMMY
      READ(73,'(A)')DUMMY
      READ(73,'(A)')DUMMY
      READ(71,*)IJOBSTART,IJOBEND
      READ(72,*)IJOBSTARTIN,IJOBENDIN
      READ(73,*)IJOBSTARTOUT,IJOBENDOUT
      CLOSE(71)
      CLOSE(72)
      CLOSE(73)
      IF(IJOBSTART.LT.IJOBSTARTIN)THEN
         IJOBSTARTDOWNIN=IJOBSTART
         IJOBENDDOWNIN=IJOBSTARTIN
      ELSE
         IJOBSTARTDOWNIN=0
         IJOBENDDOWNIN=0
      ENDIF
      IF(IJOBEND.GT.IJOBENDOUT)THEN
         IJOBSTARTDOWNOUT=IJOBENDOUT
         IJOBENDDOWNOUT=IJOBEND
      ELSE
         IJOBSTARTDOWNOUT=0
         IJOBENDDOWNOUT=0
      ENDIF
      WRITE(6,100)'PREJOB TIMES  = ',IJOBSTARTDOWNIN,IJOBENDDOWNIN
      WRITE(6,100)'POSTJOB TIMES = ',IJOBSTARTDOWNOUT,IJOBENDDOWNOUT
      IF(IJOBSTARTDOWNIN.NE.0)THEN
         OPEN(71,FILE='prejobyesno')
         WRITE(71,'(A)')'y'
         CLOSE(71)
      ENDIF
      IF(IJOBSTARTDOWNOUT.NE.0)THEN
         OPEN(71,FILE='postjobyesno')
         WRITE(71,'(A)')'y'
         CLOSE(71)
      ENDIF
 100  FORMAT(A16,I6.6,1X,I6.6)
      OPEN(71,FILE='jobfile_radar_in')
      OPEN(72,FILE='jobfile_radar_pre')
      OPEN(73,FILE='jobfile_radar_post')
      READ(71,201)FLIGHTID
 201  FORMAT(A8)
      WRITE(72,201)FLIGHTID
      WRITE(73,201)FLIGHTID
      READ(71,202)STORM
      WRITE(72,202)STORM
      WRITE(73,202)STORM
 202  FORMAT(A12)
      READ(71,*)IISTART,IIEND
      WRITE(72,203)IJOBSTARTDOWNIN,IJOBENDDOWNIN
      WRITE(73,203)IJOBSTARTDOWNOUT,IJOBENDDOWNOUT
 203  FORMAT(I6.6,1X,I6.6)
      READ(71,*)UMOVE,VMOVE
      WRITE(72,204)UMOVE,VMOVE
      WRITE(73,204)UMOVE,VMOVE
 204  FORMAT(2F8.2)
      READ(71,*)ICENTIME
 205  FORMAT(I6.6)
      WRITE(72,205)IJOBSTARTDOWNIN
      WRITE(73,205)IJOBSTARTDOWNOUT
      READ(71,*)OLAT,OLON
      WRITE(72,206)OLAT,OLON
      WRITE(73,206)OLAT,OLON
 206  FORMAT(2F10.3)
      READ(71,*)SX,SY,SZ
      WRITE(72,207)SX,SY,SZ
      WRITE(73,207)SX,SY,SZ
 207  FORMAT(4F8.2)
      READ(71,*)XZ,YZ,ZZ,ROT
      WRITE(72,207)XZ,YZ,ZZ,ROT
      WRITE(73,207)XZ,YZ,ZZ,ROT
      READ(71,*)IMAX,JMAX,KMAX
      WRITE(72,208)IMAX,JMAX,KMAX
      WRITE(73,208)IMAX,JMAX,KMAX
 208  FORMAT(3I4)
      READ(71,*)LURNT
      WRITE(72,208)LURNT
      WRITE(73,208)LURNT
      READ(71,*)IBST,INOB
      WRITE(72,208)IBST,INOB
      WRITE(73,208)IBST,INOB
      DO I=1,4
         READ(71,*)PARAM1,PARAM2,PARAM3
         WRITE(72,207)PARAM1,PARAM2,PARAM3
         WRITE(73,207)PARAM1,PARAM2,PARAM3
      ENDDO
      READ(71,*)PARAM1,PARAM2,PARAM3,PARAM4
      WRITE(72,207)PARAM1,PARAM2,PARAM3,PARAM4
      WRITE(73,207)PARAM1,PARAM2,PARAM3,PARAM4
      READ(71,*)SQI
      WRITE(72,207)SQI
      WRITE(73,207)SQI
      READ(71,*)IISTART,IIEND
      WRITE(72,203)IJOBSTARTDOWNIN,IJOBENDDOWNIN
      WRITE(73,203)IJOBSTARTDOWNOUT,IJOBENDDOWNOUT
      READ(71,*)CONTINUITY
      WRITE(72,209)CONTINUITY
      WRITE(73,209)CONTINUITY
 209  FORMAT(F10.1)
      READ(71,*)HTMELT,TKMELT
      WRITE(72,210)HTMELT,TKMELT
      WRITE(73,210)HTMELT,TKMELT
 210  FORMAT(2F10.2)
      READ(71,*)ZLOW,ZHIGH
      WRITE(72,210)ZLOW,ZHIGH
      WRITE(73,210)ZLOW,ZHIGH
      READ(71,211)FILE
      WRITE(72,211)FILE
      WRITE(73,211)FILE
 211  FORMAT(A18)
      READ(71,*)AZIIN,AZIOUT
      WRITE(72,210)AZIIN,AZIOUT
      WRITE(73,210)AZIIN,AZIOUT
 212  FORMAT(A60)
      READ(71,212)DIRECTORY
      WRITE(72,212)DIRECTORY
      WRITE(73,212)DIRECTORY
      READ(71,*)IRADAR
 213  FORMAT(I1)
      WRITE(72,213)IRADAR
      WRITE(73,213)IRADAR
      READ(71,*)ISTORM
 214  FORMAT(I3)
      WRITE(72,214)ISTORM
      WRITE(73,214)ISTORM
      CLOSE(71)
      CLOSE(72)
      CLOSE(73)
      OPEN(71,FILE='jobfile_radar_profile_in')
      OPEN(72,FILE='jobfile_radar_profile_pre_preliminary')
      OPEN(73,FILE='jobfile_radar_profile_post_preliminary')
      READ(71,201)FLIGHTID
      WRITE(72,201)FLIGHTID
      WRITE(73,201)FLIGHTID
      READ(71,202)STORM
      WRITE(72,202)STORM
      WRITE(73,202)STORM
      READ(71,*)IISTART,IIEND
      WRITE(72,203)IJOBSTARTDOWNIN,IJOBENDDOWNIN
      WRITE(73,203)IJOBSTARTDOWNOUT,IJOBENDDOWNOUT
      READ(71,*)UMOVE,VMOVE
      WRITE(72,204)UMOVE,VMOVE
      WRITE(73,204)UMOVE,VMOVE
      READ(71,*)ICENTIME
      WRITE(72,205)ICENTIME
      WRITE(73,205)ICENTIME
      READ(71,*)OLAT,OLON
      WRITE(72,206)OLAT,OLON
      WRITE(73,206)OLAT,OLON
      READ(71,*)SX,SY,SZ
      WRITE(72,207)SX,SY,SZ
      WRITE(73,207)SX,SY,SZ
      READ(71,*)XZ,YZ,ZZ,ROT
      XZNEW=102
      WRITE(72,207)XZNEW,YZ,ZZ,ROT
      WRITE(73,207)XZNEW,YZ,ZZ,ROT
      READ(71,*)IMAX,JMAX,KMAX
      WRITE(6,*)'IMAX,JMAX,KMAX = ',IMAX,JMAX,KMAX
      IMAX2=200
      WRITE(72,208)IMAX2,JMAX,KMAX
      WRITE(73,208)IMAX2,JMAX,KMAX
      WRITE(6,*)'IMAX2,JMAX,KMAX = ',IMAX2,JMAX,KMAX
      READ(71,*)LURNT
      WRITE(72,208)LURNT
      WRITE(73,208)LURNT
      READ(71,*)IBST,INOB
      WRITE(72,208)IBST,INOB
      WRITE(73,208)IBST,INOB
      DO I=1,4
         READ(71,*)PARAM1,PARAM2,PARAM3
         WRITE(72,207)PARAM1,PARAM2,PARAM3
         WRITE(73,207)PARAM1,PARAM2,PARAM3
      ENDDO
      READ(71,*)PARAM1,PARAM2,PARAM3,PARAM4
      WRITE(72,207)PARAM1,PARAM2,PARAM3,PARAM4
      WRITE(73,207)PARAM1,PARAM2,PARAM3,PARAM4
      READ(71,*)SQI
      WRITE(72,207)SQI
      WRITE(73,207)SQI
      READ(71,*)IISTART,IIEND
      WRITE(72,203)IJOBSTARTDOWNIN,IJOBENDDOWNIN
      WRITE(73,203)IJOBSTARTDOWNOUT,IJOBENDDOWNOUT
      READ(71,*)CONTINUITY
      WRITE(72,209)CONTINUITY
      WRITE(73,209)CONTINUITY
      READ(71,*)HTMELT,TKMELT
      WRITE(72,210)HTMELT,TKMELT
      WRITE(73,210)HTMELT,TKMELT
      READ(71,*)ZLOW,ZHIGH
      WRITE(72,210)ZLOW,ZHIGH
      WRITE(73,210)ZLOW,ZHIGH
      READ(71,215)PREFIX
      WRITE(72,'(A14,"vert_pre.w")')PREFIX
      WRITE(73,'(A14,"vert_post.w")')PREFIX
 215  FORMAT(A14)
      READ(71,*)ISTORM
      WRITE(72,214)ISTORM
      WRITE(73,214)ISTORM
      READ(71,*)AZIIN,AZIOUT
      WRITE(72,210)AZIIN,AZIOUT
      WRITE(73,210)AZIIN,AZIOUT
      CLOSE(71)
      CLOSE(72)
      CLOSE(73)
      STOP
      END
