	program gps_dop_wind_plot
C Read in a wind file (*.w) and a GPS sonde file and plot vertical
C wind profiles of Doppler-derived and GPS horizontal wind speed
C 	22 May 2000 - Added dBZ profiles
C	25 May 2000 - Added code to take into account the movement
C of the coordinate system, and the movement of the sonde in that system.
C the lat,lon to dy,dx calculations are done assuming deg to km
C conversions at the radar coordinate systems olat, olan...
	parameter(imax = 300, jmax = 300, kmax = 120)
	parameter( bad_val = -999.0 )
	parameter(rad2deg = 57.2957795, deg2rad = 0.0174533)
	parameter( mxdopts=300, 
     +		maxvar = 5, missing = -9999, bad_w = -9000.0)
	integer*2 indat(maxvar,mxdopts) ! for reading in dop3d or wind3d files
	real u(imax,jmax,kmax), v(imax,jmax,kmax), w(imax,jmax,kmax)
	real dbz(imax,jmax,kmax)
	integer idim, jdim, kdim, inun
	real sxt, syt, szt, zz, xz, yz
	real stime, etime
	character*1 ans, filename*80, jfile*64, batchname*80
	character keywd*4,flight*8,storm*12,radarid*4,
     +		experiment*32,create_time*32,extra1*28
C Sonde stuff
	character*80 snd_fn,dopdifffile
	parameter (max_snd = 2400)
        real rw(max_snd),tw(max_snd),rw_dop(max_snd),tw_dop(max_snd)
	real TIME(max_snd), PR(max_snd), TE(max_snd), RH(max_snd), 
     +		GA(max_snd), WD(max_snd), WS(max_snd), WSZ(max_snd)
	real SATS(max_snd), SLAT(max_snd), SLON(max_snd)
	integer IFLAGP(max_snd), IFLAGT(max_snd), IFLAGH(max_snd), 
     +		IFLAGW(max_snd)
C Averaging stuff:
	real wd_w_av(max_snd), ws_w_av(max_snd)
	real dbz_av(max_snd)
	real coord_u, coord_v, coord_time
	real kmdeglat, kmdeglon
	character gpsfile*28, cminhgt*5, cspdmax*2,outfile*80
	character cuspeed*7,cvspeed*7,ctimein*6
C
	logical ps_out
C
        common /postoutfile/ outfile
	call getarg(1,gpsfile)
	write(6,*)'gps file = ',gpsfile
	snd_fn=gpsfile
	call getarg(2,filename)
	write(6,*)'w file = ',filename
	read(filename,'(4X,i2)')iwday
	write(6,*)'iwday = ',iwday
c	pause
	call getarg(3,cminhgt)
	read(cminhgt,*)ht_min_start
	write(6,*)'ht_min = ',ht_min_start
	i_ht_min_start=nint(ht_min_start)
	write(outfile,"(a24,'_',i5.5,'.ps')")gpsfile,i_ht_min_start
	call getarg(4,cspdmax)
	read(cspdmax,*)spd_max
	write(6,*)'spd_max = ',spd_max
	call getarg(5,cuspeed)
	read(cuspeed,*)coord_u
	write(6,*)'coord_u = ',coord_u
	call getarg(6,cvspeed)
	read(cvspeed,*)coord_v
	write(6,*)'coord_v = ',coord_v
	call getarg(7,ctimein)
	read(ctimein,'(3i2)')ih,im,is
	write(6,*)'ih,im,is = ',ih,im,is
	do i=1,max_snd
	   tw(i)=bad_val
	   rw(i)=bad_val
	enddo
	open(1, file = '/dev/tty')
	open(66, file = 'gps_debug_output.txt')
C Read in wind file:
	inun = 22
c        write(6,*)'enter batch file name'
c        read(5,1604)batchname
c        ibatch = 23
c        open(23,file=batchname)
	   write(6,603)
603        FORMAT(2X,'Enter wind file name') 
c           READ(23,1604) filename
c1604        FORMAT(a80) 
           open(unit=inun,file=filename,err=605,
     +		form = 'unformatted',	iostat=ier,status='old') 
      	   go to 610 ! skip around error handler 
605   	   WRITE(6,607) IER 
607   	   FORMAT('Open error. Will try /hrd/dat/, err= ',I4)
      	   jfile= '/hrd/dat/' // filename
      	   open(unit=inun,file=jfile,err=608,form = 'unformatted',
     + 		 status = 'old', iostat=ier) 
      	   go to 610 ! skip around error handler 
608  	   write(6,609) IER 
609   	   FORMAT('open error not on /hrd/dat/, err= ',I4)
	   go to 1000
610	   write(6,*)' reading header '
	   read(inun,err=695,iostat=ier)keywd,flight,storm,radarid,
     +		experiment,create_time,extra1,idim,jdim,kdim, 
     +		nsweeps,nmosm,unfold,interven_attn,flag_dop,iextra2,
     +		iextra3, stime, etime, olat, olon, 
     +          sxt, syt, szt, xz, yz, zz,
     +		rot, ra, co1, co2, azmcor, elcor, thresh,
     +        powerT,pcor,dcor,rcor,extra5,extra6,extra7
	go to 696
695	write(6,*)' read error reading header, err # ',ier
	go to 1000
696     write(6,*)' Finished reading in 3-d header.'
	if(keywd. eq. 'wind')keywd = 'WIND' ! for old files
C
C Read in file, convert to u,v:
	   do k=1,kdim 			! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	    do j=1,jdim
                write(66,*)'nv,idim,k,j = ',nv,idim,k,j
		read(inun)((indat(nv,ii),
     +			nv = 1,5), ii =1,idim)
		do i=1,idim		! ------------------------------>
		  wd_w = indat(1,i) * 0.1
		  ws_w = indat(2,i) * 0.1
		  call wdir2uv(wd_w, ws_w, u(i,j,k), 
     +			v(i,j,k), bad_val, ier)
		  w(i,j,k)= indat(3,i)
		  dbz(i,j,k) = indat(4,i) * 0.1
c                  write(66,*)'i,j,k,dbz,indat = ',
c     + i,j,k,dbz(i,j,k),indat(4,i)
		  div = indat(5,i)
		  if(div.ge.32767.0)div = bad_val
 		  if( w(i,j,k) .le. -9000 )then
				w(i,j,k)= bad_val
		  else
			w(i,j,k) = w(i,j,k) * 0.01 ! cm/s to m/s
		  end if
		end do
	  end do
	end do
	close(inun)
C Read in GPS file:
	write(6,*)' enter sonde file name:'
c	read(5,'(a)')snd_fn
	nxmax = max_snd
	open(87,file=snd_fn)
	write(dopdifffile,'(a24,"_",i5.5,"_dopdiff.txt")')snd_fn,
     +   i_ht_min_start
	write(6,'("dopdifffile = ",a)')dopdifffile
	open(97,file=dopdifffile)
c	pause
	do l=1,15
	   read(87,'(A)')dummy
	enddo
	read(87,'(A7,3I2)')dummy,iyear,imonth,iday
	read(87,'(A7,I6)')dummy,ITIMEL
	if(iday.ne.iwday)then
	   write(6,*)'iday,iwday,itimel = ',iday,iwday,itimel
	   itimel=itimel+240000
	   write(6,*)'itimel changed to ',itimel
c	   pause
	endif
	do l=1,4
	   read(87,'(A)')dummy
	enddo
	TIMEL=ITIMEL
	itest=1
	nx=0
	do while(itest.eq.1)
	   read(87,*,end=1001)
     +               nreadnum,time(nx+1),pr(nx+1),te(nx+1),rh(nx+1),
     +               ga(nx+1),wd(nx+1),
     +               ws(nx+1),u0,v0,ns0,wsz(nx+1),zw0,iflagp(nx+1),
     +               iflagt(nx+1),
     +               iflagh(nx+1),iflagw(nx+1),slat(nx+1),slon(nx+1)
	   nx=nx+1
	enddo
 1001	write(6,*)'nx = ',nx
c        write(6,*)'calling getpds'
c	call GETPDS(snd_fn,NID,IYEAR,IMONTH,IDAY,TIMEL,
c     *                  ACLAT,ACLON,ACPR,ACTE,ACRH,ACGA,ACWD,ACWS,
c     *                  IDAC,FLRATE,SMPLRATE,NXMAX,NX,
c     *                  TIME,PR,TE,RH,GA,WD,WS,WSZ,SATS,SLAT,SLON,
c     *                  IFLAGP,IFLAGT,IFLAGH,IFLAGW,
c     *                  PBSLN,TBSLN,HBSLN,PBIAS,TBIAS,HBIAS,
c     *                  PTHFILT,WINDFILT,PSPLASH,HYDSFCP,HYDIP,
c     *                  DYNT, dynw, rhtc, GPSVERR,GACORR,IERR)

c       write(6,*)'returned from getpds'
C     Argument list:
C     ----------------------------------------------------------------
C     FILENAME          Input pds file name (CHAR*60)
C       
C     Returned arguments:
C     ----------------------------------------------------------------
C     NID               Sonde serial number
C
C     IYEAR             Launch year (yy)
C     IMONTH            Launch month (mm)
C     IDAY              Launch day (dd)
C     TIMEL             Launch time (hhmmss)
C     ACLAT             Launch latitude (deg N)
C     ACLON             Launch longitude (deg E)
C     ACPR              Launch pressure (mb)
C     ACTE              Launch temperature (C)
C     ACRH              Launch relative humidity (%)
C     ACGA              Launch geopotential altitude (m)
C     ACWD              Launch wind direction (deg)
C     ACWS              Launch wind speed (m/s)
C
C     IDAC              Aircraft ID (42, 43, 49, ...)
C     FLRATE            Nominal sonde fall rate (  )
C     SMPLRATE          Sonde sampling rate (  )
C
C     NXMAX             Size of sonde data arrays
C     NX                Array index of last valid record (splash)
C
C     TIME              Time after launch (s)
C     PR                Pressure (mb)
C     TE                Temperature (C)
C     RH                Rel humidity (%)
C     GA                Geopotential altitude (m)
C     WD                Wind direction (deg)
C     WS                Wind speed (m/s)
C     WSZ               Vertical sonde velocity (m/s)
C     SATS              # of GPS satellites in wind solution
C     SLAT              Sonde latitude (deg N)
C     SLON              Sonde longitude (deg E)
C
C     IFLAGP            Flag for pressure
C     IFLAGT            Flag for temperature
C     IFLAGH            Flag for humidity
C     IFLAGW            Flag for wind
C
C                       Flag values:
C                       0 = Data ok
C                       3 = Interpolated value
C                       4 = Doubtful or questionable accuracy
C                       5 = Subjectively determined
C                       6 = Ten meter value
C
C     PBSLN             Baseline pressure bias adjustment (mb)
C     TBSLN             Baseline temperature bias adjustment (C)
C     HBSLN             Baseline humidity bias adjustment (%)
C
C     PBIAS             Processing pressure bias adjustment (mb)
C     TBIAS             Processing temperature bias adjustment (C)
C     HBIAS             Processing humidity bias adjustment (%)
C
C     PTHFILT           Processing PTH filter cutoff wavelength (s)
C     WINDFILT          Processing wind filter cutoff wavelength (s)
C
C     PSPLASH           Raw splash pressure (mb)
C     HYDSFCP           Hydrostatic MSLP
C     HYDIP             Hydrostatic anchor point (1 = flt, 2 = sfc)
C     DYNT              Dynamic temperature correction (0 = no, 1 = yes)
C     GPSVERR           Mean GPS vertical velocity error (m/s)
C
C     IERR              Successful file open if = 0.
C     ----------------------------------------------------------------
C
	write(6,*)' Enter coord system u, v: '
c	read(5,*)coord_u, coord_v
	write(6,*)' enter coordinate center time (hhmmss):'
c	read(5,'(3i2)')ih,im,is
	coord_time = ih*3600.0 + im*60.0 + is
C trig series from Bowditch:
	kmdeglat = 111.13209 - 0.56605 * cosd(2.*olat) +
     +        		0.00012*cosd(4.0*olat)-
     +			0.000002*cosd(6.*olat) 
	kmdeglon = 111.41513*cosd(olat)-0.09455*cosd(3.*olat)+
     +        		0.00012*cosd(5.*olat)
C
	ih = timel / 10000
	im = (timel - ih * 10000 ) / 100
	is = timel - ih * 10000 - im * 100
	time_launch = ih * 3600.0 + im * 60.00 + is
	splash_time = time_launch + time(nx)
	write(6,*)' First pos ',slat(1), slon(1),
     +		' at time: ',time_launch + time(1)
	write(6,*)' Last pos ',slat(nx), slon(nx),' at time: ',
     +		time_launch + time(nx)
	write(6,*)'olat,olon,kmdeglat,kmdeglon = ',
     +             olat,olon,kmdeglat,kmdeglon
c        pause
C Get position of GPS sonde in Doppler box
	do it = 2, nx
	  if( ga(it) .gt. 0 ) then
		time_pos = time_launch + time(it)
		dt = time_pos - coord_time
C Sonde position in earth coordinates:
		y = yz + (slat(it) - olat) * kmdeglat
		x = xz + (slon(it) - olon) * kmdeglon
C coord translation
		dx = dt * coord_u * 0.001
		dy = dt * coord_v * 0.001
C snd position in moving coordinate system
		x_snd = x - dx
		y_snd = y - dy
                xsnd=x_snd-xz
                ysnd=y_snd-yz
                usnd=-sin(3.14159/180.*wd(it))*ws(it)
                vsnd=-cos(3.14159/180.*wd(it))*ws(it)
                rad_snd = sqrt(xsnd*xsnd+ysnd*ysnd)
		write(6,*)'before it,ws and tw,rw = ',
     +            it,ws(it),tw(it),rw(it)
		write(6,*)'it usnd,vsnd,xsnd,ysnd = ',
     +                     it,usnd,vsnd,xsnd,ysnd
                if(ws(it).gt.bad_val.and.slat(it).gt.-900.)then
                 rw(it)=(usnd*xsnd+vsnd*ysnd)/rad_snd
                 tw(it)=(vsnd*xsnd-usnd*ysnd)/rad_snd
                 write(66,*)'xsnd,ysnd,wd,ws,usnd,vsnd,rw,tw = ',
     +  xsnd,ysnd,wd(it),ws(it),usnd,vsnd,rw(it),tw(it)
                else
                 rw(it)=bad_val
                 tw(it)=bad_val
                endif
		write(6,*)'after ws and tw,rw = ',tw(it),rw(it)
		i_snd = (x_snd+.5*sxt) / sxt
		j_snd = (y_snd+.5*syt) / syt
c	if( (it.eq.1) .or. (it.eq. nx)) then
		write(66, *)'slat = ',slat(it),'  slon = ',slon(it)
		write(66, *)it, ' i_snd, j_snd:', i_snd, j_snd
		write(66, *)' x_snd, y_snd: ', x_snd, y_snd
c	end if
c		if( (i_snd.gt.1) .and. (i_snd.lt.idim) .and.
c     +			(j_snd.gt.1) .and. (j_snd.lt.jdim)) then ! >>>>>>>>>
c		  i1 = i_snd - 1
c		  i2 = i_snd + 1
c		  j1 = j_snd - 1
c		  j2 = j_snd + 1
		if( (i_snd.gt.0) .and. (i_snd.lt.idim) .and.
     +			(j_snd.gt.0) .and. (j_snd.lt.jdim)) then ! >>>>>>>>>
		  i1 = i_snd 
                  x1 = (i1-1)*sxt+.5*sxt
		  i2 = i_snd + 1
                  x2 = (i2-1)*sxt+.5*sxt
		  j1 = j_snd 
                  y1=(j1-1)*syt+.5*syt
		  j2 = j_snd + 1
                  y2=(j2-1)*syt+.5*syt
C Make average:
		  ksave = ((ga(it)*0.001-zz)/ szt) +1
                  k1=ksave
                  k2=ksave+1
                  z1 = (k1-1)*szt+zz
                  z2 = (k2-1)*szt+zz
                  if(k1.lt.1)k1=1
                  if(k2.gt.kdim)k2=kdim
		  npts = 0
                  rsum = 0
		  u_av = 0
		  v_av = 0
		  n_zpts = 0
		  z_av = 0
                  write(66,*)'i1,i2,j1,j2,k1,k2 = ',i1,i2,j1,j2,k1,k2
                  do k=k1,k2
                   z1=(k-1)*szt+zz
                   z_snd=ga(it)*.001
                   zdiff=z_snd-z1
                   write(66,*)'k,z1,z_snd,zdiff = ',k,z1,z_snd,zdiff
 		   do j = j1, j2
                      y1=(j-1)*syt+.5*syt
                      ydiff=y1-y_snd
                      write(66,*)'j,y1,y_snd,ydiff = ',
     +  j,y1,y_snd,ydiff
			do i = i1, i2
			   if( u(i,j,k) .gt. bad_val) then
                            x1=(i-1)*sxt+.5*sxt
                            xdiff=x1-x_snd
                       write(66,*)'i,x1,x_snd,xdiff = ',
     + i,x1,x_snd,xdiff
                             rrr=sqrt(xdiff**2.+ydiff**2.+zdiff**2.)
                             if(rrr.eq.0.)then
                              rrr1=1000000.
                             else
                              rrr1=1./rrr
                             endif
				u_av = u_av + u(i,j,k)*rrr1
				v_av = v_av + v(i,j,k)*rrr1
                                rsum=rsum+rrr1
				npts = npts + 1
			   end if
			   if( dbz(i,j,k) .gt. bad_val) then
				z_av = z_av + 10.0**(dbz(i,j,k)*0.1)
				n_zpts = n_zpts + 1
			   end if
			end do
                 enddo
		end do
                k=ksave
		if ( npts .gt. 0) then
			u_av = u_av / rsum
			v_av = v_av / rsum
                        rw_dop(it) = (u_av*xsnd+v_av*ysnd)/rad_snd
                        tw_dop(it) = (v_av*xsnd-u_av*ysnd)/rad_snd
			call uv2wd(u_av, v_av, wd_w_av(it), 
     +				ws_w_av(it), bad_val)
                 write(66,*)'it,rw,tw,u,v,wd,ws = ',
     + it,rw_dop(it),tw_dop(it),u_av,v_av,wd_w_av(it),ws_w_av(it)
		else
                        rw_dop(it) = bad_val
                        tw_dop(it) = bad_val
			wd_w_av(it) = bad_val
			ws_w_av(it) = bad_val
		end if
		if( n_zpts .gt. 0) then
			z_av = z_av / n_zpts
			dbz_av(it) = 10.0 * log10(z_av)
		else
			dbz_av(it) = bad_val
		end if
	  else
                rw_dop(it) = bad_val
                tw_dop(it) = bad_val
		wd_w_av(it) = bad_val
		ws_w_av(it) = bad_val
		dbz_av(it) = bad_val
	  end if ! <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	 else 
                rw_dop(it) = bad_val
                tw_dop(it) = bad_val
		wd_w_av(it) = bad_val
		ws_w_av(it) = bad_val
		dbz_av(it) = bad_val
	 end if
	end do

C Plot vertical profiles:
c	spd_max = 50.0
	ps_out = .true.
c	ht_min = -999.0
	ht_max = -999.0
	do i=1,nx
	   if(ga(i).gt.ht_max)ht_max=ga(i)
	   if(ga(i).gt.-998.0.and.ht_min.le.-998.9)ht_min=ga(i)
	   if(ga(i).lt.ht_min)ht_min=ga(i)
	enddo
c	ht_max = ga(1)
	ht_min=ht_min_start
	write(6,*)' Height min: ',ht_min
c	write(6,*)' Height max: ',ht_max,'m. Change? '
c	read(5,'(a)')ans
	ans='n'
	if( (ans.eq.'y') .or. (ans.eq.'Y') ) then
		write(6,*)' enter height max (m) '
		read(5,*)ht_max
                write(6,*)' enter height min (m) '
                read(5,*)ht_min
	end if
	write(6,*)' windspeed max: ',spd_max,' m/s. Change? '
c	read(5,'(a)')ans
	ans='n'
	if( (ans.eq.'y') .or. (ans.eq.'Y') ) then
		write(6,*)' enter windspeed max (m/s) '
		read(5,*)spd_max
	end if
c	call ctme(splash_time, ih, im , is)
        ih = int(splash_time/3600.)
        splashleft=splash_time-3600.*ih
        im = int(splashleft/60.)
        is = int(splash_time - 3600.*ih - 60.*im)
	do ix=2,nx-1
	   write(6,*)'ix,rw_dop,tw_dop = ',ix,rw_dop(ix),tw_dop(ix)
	enddo
	do ix=2,nx-1
	   write(6,*)'before ix,rw_dop = ',ix,rw_dop(ix)	   
	   write(6,*)'before ix,tw_dop = ',ix,tw_dop(ix)
	   write(6,*)'before ix,ws = ',ix,ws(ix)
	   if(ga(ix).lt.-900.)then
	      if(ga(ix-1).gt.-900..and.ga(ix+1).gt.-900.)then
		 ga(ix)=.5*(ga(ix-1)+ga(ix+1))
	      endif
	   endif
	   if(ws(ix).lt.-900.)then
	      if(ws(ix-1).gt.-900..and.ws(ix+1).gt.-900.)then
		 wd(ix)=.5*(wd(ix-1)+wd(ix+1))
		 ws(ix)=.5*(ws(ix-1)+ws(ix+1))
	      endif
	   endif
	   if(tw(ix).lt.-200.)then
	      if(tw(ix-1).gt.bad_val.and.tw(ix+1).gt.bad_val)then
		 rw(ix)=.5*(rw(ix-1)+rw(ix+1))
		 tw(ix)=.5*(tw(ix-1)+tw(ix+1))
c              else
c
c		 rw(ix)=bad_val
c		 tw(ix)=bad_val
	      endif
	   endif
	   if(tw_dop(ix).lt.-200.)then
	      if(tw_dop(ix-1).gt.bad_val.and.tw_dop(ix+1).gt.bad_val)then       
		 tw_dop(ix)=.5*(tw_dop(ix-1)+tw_dop(ix+1))
	      endif
	   endif
	   write(6,*)'before ix,rw_dopm1,rwdop,rwdopp1 = ',
     +          ix,rw_dop(ix-1),rw_dop(ix),rw_dop(ix+1)
	   if(rw_dop(ix).lt.-200.)then
	      if(rw_dop(ix-1).gt.bad_val.and.rw_dop(ix+1).gt.bad_val)then
		 rw_dop(ix)=.5*(rw_dop(ix-1)+rw_dop(ix+1))
              endif
	   endif
	   write(6,*)'after ix,rw_dopm1,rwdop,rwdopp1 = ',
     +          ix,rw_dop(ix-1),rw_dop(ix),rw_dop(ix+1)
	   if(ws_w_av(ix).lt.-900.)then
	      if(ws_w_av(ix-1).gt.-900..and.ws_w_av(ix+1).gt.-900.)then
		 wd_w_av(ix)=.5*(wd_w_av(ix-1)+wd_w_av(ix+1))
		 ws_w_av(ix)=.5*(ws_w_av(ix-1)+ws_w_av(ix+1))
	      endif
	   endif
	   if(dbz_av(ix).lt.-900.)then
	      if(dbz_av(ix-1).gt.-900..and.dbz_av(ix+1).gt.-900.)then
		 dbz_av(ix)=.5*(dbz_av(ix-1)+dbz_av(ix+1))
	      endif
	   endif
	   write(6,*)'ix,dbz_av = ',ix,dbz_av(ix)
	   write(6,*)'ix,ws = ',ix,ws(ix)
	   write(6,*)'ix,rw_dop = ',ix,rw_dop(ix)	   
	   write(6,*)'ix,tw_dop = ',ix,tw_dop(ix)	   
	enddo
	do ix=1,nx
	   ws_w_av(ix)=tw_dop(ix)
	   ws(ix)=tw(ix)
	   write(6,*)'ix,ws_w_av,ws = ',ix,ws_w_av(ix),ws(ix)
        enddo
	write(6,*)'calling first plot'
	call plot_vert_profile(ga, wd, ws, nx,
     +		wd_w_av, ws_w_av, dbz_av, ps_out,
     +		ih, im, is, spd_max, ht_min, ht_max, bad_val,
     +		filename, snd_fn,rw,tw,rw_dop,tw_dop)
	write(6,*)'leaving first plot'
c	write(outfile,"(a24,'_',i5.5,'_rw.ps')")gpsfile,i_ht_min_start
c	write(6,*)'calling second plot'
c	call plot_vert_profile(ga, wd, ws, nx,
c     +		wd_w_av, ws_w_av, dbz_av, ps_out,
c     +		ih, im, is, spd_max, ht_min, ht_max, bad_val,
c     +		filename, snd_fn,rw,tw,rw_dop,tw_dop)
c	write(6,*)'returned from second plot'
c	write(6, *)' Pausing...'
c	read(5, *)
1000	close(66)
	stop
	end
C ======================================
	subroutine plot_vert_profile(snd_ht, snd_wd, snd_ws, num_snd,
     +		dop_wd, dop_ws, dbz, ps_out,
     +		ih, im, is, spd_max, ht_min, ht_max, bad_val,
     +		doppler_fn, sonde_fn,rw,tw,rw_dop,tw_dop)
C
	real snd_ht(num_snd), snd_wd(num_snd), snd_ws(num_snd)
	real dop_wd(num_snd), dop_ws(num_snd)
	real dbz(num_snd)
        real rw(num_snd),tw(num_snd),rw_dop(num_snd),tw_dop(num_snd)
	logical ps_out
	character*60 sonde_fn, doppler_fn*64
C
	real w(4)
	logical pen_down
	character cstr*80
	integer*2 istring(40)
	integer plotter
	integer thin_line, medium_line, thick_line
	integer black, red,orange,yellow,green,blue,darkturq,violet,white
	data black, red,orange,yellow,green,blue,darkturq,violet,white/0,
     +		-1,-2,-3,-4,-5,-6,-7,-8/
C
	thin_line = 1
	medium_line = 2
	thick_line = 3
C
	plotter = 2 ! X - window
	ipst_file_lu = 20
	ifont_points = 16
	csiz = ifont_points / 72.0
	tsiz = csiz * 0.5
	width = 4.0
	height = 4.0
	xl = 1.5
	yb = 1.5
	w(1) = 0.0
	w(2) = 0.0
	w(3) = width
	w(4) = height
	yt = yb + height
C set scaling:
	x_sc = width / (spd_max +10.)
	x_frac = 10./(spd_max+10)
	y_sc = height / ht_max
	x_pwr_sc = width / 60.0
	ires = 400 ! magic number
	iwid = (width + 2.0 * xl +4.0 * csiz) * 10
	iht = (height + 2.0 * yb +4.0 * csiz) * 10
	call initl(plotter, ires, iwid, iht, im1, im1, im1)
	if( ps_out ) then
		call initl( -plotter, ires, iwid, iht,
     +			ipst_file_lu, ifont_points,im1)
	end if
C
	call factr(1.0)
	call plot(0.0, 0.0, -3)
C Draw box and label
	call newpn(thin_line)
	call plot(xl, yb, 3)
	call plot(xl + width, yb, 2)
	call plot(xl + width, yb+height, 2)
	call plot(xl, yb + height, 2)
	call plot(xl, yb, 2)
	call plot(xl + x_frac*width,yb,3)
	call plot(xl + x_frac*width,yb+height,2)
c
	write(cstr,100)ih,im,is
100	format(3i2.2,' UTC')
	read(cstr(1:10),'(5a2)')(istring(ii), ii = 1, 5)
	y = yb - 2.5 * csiz
	call symbl(xl, y, csiz, istring, 0.0, 10)
	read(sonde_fn(1:60),'(30a2)')(istring(ii), ii = 1, 30)
	y = y - 1.5 * csiz
	call symbl(xl, y, csiz, istring, 0.0, 60)
	read(doppler_fn(1:64),'(32a2)')(istring(ii), ii = 1, 32)
	y = y - 1.5 * csiz
	call symbl(xl, y, csiz, istring, 0.0, 64)
C
	do i = -10, spd_max, 2
		x = (i+10) * x_sc
		call plot(xl + x, yb, 3)
		call plot(xl + x, yb + tsiz, 2)
	end do
	do i = -10, spd_max, 10
		x = (i+10) * x_sc
		call plot(xl + x, yb, 3)
		call plot(xl + x, yb + 2.0 * tsiz, 2)
		val = i
		call numbr(xl + x - 0.75*csiz, yb-csiz, csiz, 
     +			val, 0.0, -1)
	end do
C dBZ scale on top
	do i = -10, spd_max, 2
		x = (i+10) * x_sc
		call plot(xl + x, yt, 3)
		call plot(xl + x, yt - tsiz, 2)
	end do
	do i = -10, spd_max, 10
		x = (i+10) * x_sc
		call plot(xl + x, yt, 3)
		call plot(xl + x, yt - 2.0 * tsiz, 2)
		val = i
		call numbr(xl + x - 0.75*csiz, yt+0.2*csiz, csiz, 
     +			val, 0.0, -1)
	end do
C height scale
	do i = 100, ht_max, 100
		y = i * y_sc
		call plot(xl, yb + y, 3)
		call plot(xl + tsiz, yb + y, 2)
	end do
	do i = 1000, ht_max, 1000
		y = i * y_sc
		call plot(xl, yb + y, 3)
		call plot(xl + 2.0 * tsiz, yb + y, 2)
		val = i * 0.001
		call numbr(xl - 0.2 * csiz, yb + y - 0.5 * csiz,
     +			-csiz, val, 0.0, 1)
	end do
C
C Draw curves:
C GPS Sonde - Wind Speed:
	call newpn(thin_line)
	call newpn(black)
	xp = 0.0
	yp = height -2.0 * tsiz + 3.6 * csiz
	call plot(xl + xp, yb + yp, 3)
	call plot(xl + xp + 1.5 * csiz, yb + yp, 2)
	cstr = 'GPS Tangential Wind (m/s) '
	read(cstr(1:26),'(13a2)')(istring(ii), ii =1, 13)
	y = yp - 0.5 * csiz
	call symbl(xl + xp + 2.0 * csiz, yb + y, csiz, istring, 0.0, 26)
	pen_down = .false.
        usum=0
        vsum=0
        wssum=0
        rsum=0
        tsum=0
        usum2=0
        vsum2=0
        rsum2=0
        tsum2=0
        wssum2=0
        ncount=0
        ncount2=0
	vecdiffsum=0
	vecdiffsum2=0
        open(96,file='sondedopdiff.txt')
	if( snd_ws(1) .gt. bad_val) then
c	   if( snd_ht(1) .le. ht_max. and .snd_ht(1).gt.0) then
	   if( snd_ht(1) .le. ht_max. and .snd_ht(1).gt.ht_min) then
		xp = (10.+snd_ws(i)) * x_sc
		yp = snd_ht(1) * y_sc
		call plot(xl + xp, yb + yp, 3)
		pen_down = .true.
                if(snd_ws(1).gt.bad_val.and.dop_ws(1).gt.bad_val)then
                 if(snd_ht(1).le.ht_max.and.snd_ht(1).gt.ht_min)then
                 usonde=-sin(3.14159/180.*snd_wd(1))*snd_ws(1)
                 vsonde=-cos(3.14159/180.*snd_wd(1))*snd_ws(1)
                 udoppler=-sin(3.14159/180.*dop_wd(1))*dop_ws(1)
                 vdoppler=-cos(3.14159/180.*dop_wd(1))*dop_ws(1)
                 udiff=usonde-udoppler
                 vdiff=vsonde-vdoppler
                 wsdiff=snd_ws(1)-dop_ws(1)
                 vecdiff=sqrt(udiff*udiff+vdiff*vdiff)
		 vecdiffsum=vecdiffsum+vecdiff
		 vecdiffsum2=vecdiffsum2+vecdiff*vecdiff
                 write(96,*)snd_ws(1),snd_wd(1),dop_ws(1),dop_wd(1)
                 write(96,*)udiff,vdiff,vecdiff
                 usum=usum+udiff
                 vsum=vsum+vdiff
                 wssum=wssum+wsdiff
                 usum2=usum2+udiff*udiff
                 vsum2=vsum2+vdiff*vdiff
                 wssum2=wssum2+wsdiff*wsdiff
                 ncount=ncount+1
                 endif
                endif
                if(rw(1).gt.bad_val.and.rw_dop(1).gt.bad_val)then
                 if(snd_ht(1).le.ht_max.and.snd_ht(1).gt.ht_min)then
                 rdiff=rw(1)-rw_dop(1)
                 tdiff=tw(1)-tw_dop(1)
                 vecdiff=sqrt(rdiff*rdiff+tdiff*tdiff)
                 write(96,*)rw(1),rw_dop(1),tw(1),tw_dop(1)
                 write(96,*)rdiff,tdiff,vecdiff
                 rsum=rsum+rdiff
                 tsum=tsum+tdiff
                 rsum2=rsum2+rdiff*rdiff
                 tsum2=tsum2+tdiff*tdiff
                 ncount2=ncount2+1
                 endif
                endif
	   end if
	end if
	do i = 2, num_snd
                if(snd_ws(i).gt.bad_val.and.dop_ws(i).gt.bad_val)then
                 if(snd_ht(i).le.ht_max.and.snd_ht(i).gt.ht_min)then
                 usonde=-sin(3.14159/180.*snd_wd(i))*snd_ws(i)
                 vsonde=-cos(3.14159/180.*snd_wd(i))*snd_ws(i)
                 udoppler=-sin(3.14159/180.*dop_wd(i))*dop_ws(i)
                 vdoppler=-cos(3.14159/180.*dop_wd(i))*dop_ws(i)
                 udiff=usonde-udoppler
                 vdiff=vsonde-vdoppler
                 wsdiff=snd_ws(i)-dop_ws(i)
                 vecdiff=sqrt(udiff*udiff+vdiff*vdiff)
		 vecdiffsum=vecdiffsum+vecdiff
		 vecdiffsum2=vecdiffsum2+vecdiff*vecdiff
                 write(96,*)snd_ws(i),snd_wd(i),dop_ws(i),dop_wd(i)
                 write(96,*)udiff,vdiff,vecdiff
                 usum=usum+udiff
                 vsum=vsum+vdiff
                 wssum=wssum+wsdiff
                 usum2=usum2+udiff*udiff
                 vsum2=vsum2+vdiff*vdiff
                 wssum2=wssum2+wsdiff*wsdiff
                 ncount=ncount+1
                 endif
                endif
                if(rw(i).gt.bad_val.and.rw_dop(i).gt.bad_val)then
                 if(snd_ht(i).le.ht_max.and.snd_ht(i).gt.ht_min)then
                 rdiff=rw(i)-rw_dop(i)
                 tdiff=tw(i)-tw_dop(i)
                 vecdiff=sqrt(rdiff*rdiff+tdiff*tdiff)
                 write(96,*)rw(i),rw_dop(i),tw(i),tw_dop(i)
                 write(96,*)rdiff,tdiff,vecdiff
                 rsum=rsum+rdiff
                 tsum=tsum+tdiff
                 rsum2=rsum2+rdiff*rdiff
                 tsum2=tsum2+tdiff*tdiff
                 write(66,*)'rw,rwdop,tw,twdop,ws,wsdop = ',
     +           rw(i),rw_dop(i),tw(i),tw_dop(i),snd_ws(i),dop_ws(i)
                 write(66,*)'rdiff,tdiff,wsdiff,rsum2,tsum2,wssum2 = ',
     +           rdiff,tdiff,wsdiff,rsum2,tsum2,wssum2
                 ncount2=ncount2+1
                 endif
                endif
           WRITE(66,*)'plotter i,snd_ws,snd_ht = ',snd_ws(i),snd_ht(i)
           WRITE(66,*)'plotter ht_min,ht_max = ',ht_min,ht_max
	   if( snd_ws(i) .gt. bad_val) then
c	     if( snd_ht(i) .le. ht_max .and. snd_ht(i).gt.0.) then
	     if( snd_ht(i) .le. ht_max .and. snd_ht(i).gt.ht_min) then
		xp = (10.+snd_ws(i)) * x_sc
		yp = snd_ht(i) * y_sc
		if( pen_down) then
		   call plot(xl + xp, yb + yp, 2)
		else
		   call plot(xl + xp, yb + yp, 3)
		   pen_down = .true.
		endif
	     else
		pen_down = .false.
	     end if
	   else
		pen_down = .false.
	   end if
	end do
C Doppler wind speed:
        if(ncount.gt.0)then
         umean=usum/ncount
         vmean=vsum/ncount
         wsmean=wssum/ncount
         ustand=sqrt(usum2/ncount)
         vstand=sqrt(vsum2/ncount)
         wsstand=sqrt(wssum2/ncount)
         ustandmean=sqrt(usum2/ncount-umean*umean)
         vstandmean=sqrt(vsum2/ncount-vmean*vmean)
         wsstandmean=sqrt(wssum2/ncount-wsmean*wsmean)
	 vecdiffmean=vecdiffsum/ncount
	 vecdiffrms=sqrt(vecdiffsum2/ncount)
        else
         umean=-999.9
         vmean=-999.9
         ustand=-999.9
         vstand=-999.9 
         ustandmean=-999.9
         vstandmean=-999.9
         wsmean=-999.9
         wsstand=-999.9
        endif
        if(ncount2.gt.0)then
         rmean=rsum/ncount2
         tmean=tsum/ncount2
         rstand=sqrt(rsum2/ncount2)
         tstand=sqrt(tsum2/ncount2)
         rstandmean=sqrt(rsum2/ncount2-rmean*rmean)
         tstandmean=sqrt(tsum2/ncount2-tmean*tmean)
        else
         rmean=-999.9
         tmean=-999.9
         rstand=-999.9
         tstand=-999.9 
         rstandmean=-999.9
         tstandmean=-999.9
        endif
        write(96,*)'count for cartesian = ',ncount
        write(96,*)'umean,vmean = ',umean,vmean
        write(96,*)'ustand,vstand = ',ustand,vstand
        write(96,*)'ustandmean,vstandmean = ',ustandmean,vstandmean
        write(96,*)'count for cylindrical = ',ncount2
        write(96,*)'rmean,tmean = ',rmean,tmean
        write(96,*)'rstand,tstand = ',rstand,tstand
        write(96,*)'rstandmean,tstandmean = ',rstandmean,tstandmean
        write(96,*)'wsmean = ',wsmean
        write(96,*)'wsstand = ',wsstand
        write(96,*)'wsstandmean = ',wsstandmean
	write(96,*)'vecdiffmean = ',vecdiffmean
	write(96,*)'vecdiffrms = ',vecdiffrms
        close(96)
        write(97,*)'count for cartesian = ',ncount
        write(97,*)'umean,vmean = ',umean,vmean
        write(97,*)'ustand,vstand = ',ustand,vstand
        write(97,*)'ustandmean,vstandmean = ',ustandmean,vstandmean
        write(97,*)'count for cylindrical = ',ncount2
        write(97,*)'rmean,tmean = ',rmean,tmean
        write(97,*)'rstand,tstand = ',rstand,tstand
        write(97,*)'rstandmean,tstandmean = ',rstandmean,tstandmean
        write(97,*)'wsmean = ',wsmean
        write(97,*)'wsstand = ',wsstand
        write(97,*)'wsstandmean = ',wsstandmean
	write(97,*)'vecdiffmean = ',vecdiffmean
	write(97,*)'vecdiffrms = ',vecdiffrms
        close(97)
c
c	if(vecdiffrms.lt..01)then
c	   write(cstr,200)vecdiffmean
 200	   format(' mean vector difference = ',f6.2,' m/s')
c	   read(cstr(1:36),'(31a2)')(istring(ii), ii = 1, 18)
c	   y = yt + 2.5 * csiz
c	   call symbl(xl, y, csiz, istring, 0.0, 36)
c	   write(cstr,300)vecdiffrms
 300	   format(' rms vector difference = ',f6.2,' m/s ')
c	   read(cstr(1:36),'(31a2)')(istring(ii), ii = 1, 18)
c	   y = yt + 1.25 * csiz
c	   call symbl(xl, y, csiz, istring, 0.0, 36)
c	endif
	call newpn(medium_line)
	call newpn(red)
	xp = 0.0
	yp = height - 2.0 * tsiz + 4.8 * csiz
	call plot(xl + xp, yb + yp, 3)
	call plot(xl + xp + 1.5 * csiz, yb + yp, 2)
	cstr = 'Doppler Tangential wind (m/s) '
	read(cstr(1:30),'(15a2)')(istring(ii), ii =1, 15)
	y = yp - 0.5 * csiz
	call symbl(xl + xp + 2.0 * csiz, yb + y, csiz, istring, 0.0, 30)
	pen_down = .false.
	if( snd_ws(1) .gt. bad_val) then
	   if( snd_ht(1) .le. ht_max .and. snd_ht(1).gt.ht_min) then
		xp = (10.+dop_ws(1)) * x_sc
		yp = snd_ht(1) * y_sc
		call plot(xl + xp, yb + yp, 3)
		pen_down = .true.
	   endif
	end if
	call plot(xl + xp, yb + yp, 3)
	do i = 2, num_snd
	  if( snd_ht(i) .le. ht_max .and. snd_ht(i).gt.ht_min) then
	   if( dop_ws(i) .gt. bad_val) then
		xp = (10.+dop_ws(i)) * x_sc
		yp = snd_ht(i) * y_sc
		if( pen_down) then
		   call plot(xl + xp, yb + yp, 2)
		else
		   call plot(xl + xp, yb + yp, 3)
		   pen_down = .true.
		endif
	   else
		pen_down = .false.
	   end if
	  else
	   pen_down = .false.
	  end if
	end do
	call plot(0.0, 0.0, 998)
        write(6,*)'i got here'
c	pause
	return
	end
