c Fortran 90 version if IRIS structures for working with 
c SIGMET Vaisala data in the RAW format. Converted 10 dec 2008 P eter dodge HRD AOML

C  *   Version of iris_structures.h that includes the extended header
C * designed by Sigmet-Vaisala for the G IV Doppler radar. 
C * This subset of IRIS (copyright SIGMET) should be sufficient to read
C * raw format files on disk or from tape. See the latest version of the
C * IRIS Programmer's Manual at www.sigmet.com for details. Note that my 
C * variable names probably do NOT conform to those in the official IRIS
C * *.h files...but if you have IRIS you should not need my code anyway!
C * 25 May 2004
C * P dodge, HRD AOML OAR NOAA
C * added stuff 5 Jan 2005
C * 

C Constants
cout for now intil i fix	include "sigmet_dsp_data_types_f90.h"
	integer BLK_LENGTH, MAX_WDS, MAX_DATA
	integer MAX_FIELDS
	real ANG_CONV, DOUBLE_ANG_CONV
	integer TRUE, FALSE
	
	parameter(BLK_LENGTH = 3072) !	 * 6144 bytes in raw data blocks * 
	parameter(MAX_WDS = 2000) !  * Max 4000 bytes in a single ray * 
	parameter(MAX_DATA = 4000) !  * Max 4000 data words - maybe overkill* 
	parameter(MAX_FIELDS = 10) ! only 6 in current giv tdr data
	parameter(ANG_CONV = 180.0 / 32768.0) !  * 16 bit binary angle * 
	parameter(DOUBLE_ANG_CONV = 360.0 / 4294967296.0) !  * 32 bit binary angle * 
C comment these out intil I make them work in f90. I may not
C need these anyway...
cout   	parameter(ANG_CON_16 = -180.0 INT16_MIN)
cout	parameter(ANG_CON_32 = -180.0 INT32_MIN)

	parameter( TRUE = 1)
	parameter( FALSE = 0)

C Structures
	TYPE struct_hdr  
		integer*2 struct_id
		integer*2 format_version_num
		integer*4 num_bytes
		integer*2 reserved
		integer*2 flags
	END TYPE
C
	TYPE ymds_time  
		integer*4 seconds
		integer*2 msec  !  * in lowest 10 bits * 
		integer*2 year
		integer*2 month
		integer*2 day
	END TYPE
C
	TYPE raw_psi_struct  
		integer*4 data_bit_mask
		integer*4 last_bin_rng
		integer*4 format_conv_flag
		integer*4 flag
		integer*4 sweep_number
		integer*4 spare(6)
	END TYPE
C
C  * First record on tape is 320 bytes, with this at beginning:
C  * 
	TYPE tape_header_rec  
		type (struct_hdr) struct_hdr
		character*16 tape_id
		character*16 site_name
		type (ymds_time) create_time
		integer*4 spare
		character*8 iris_version
		integer*4 spare2(63)
	END TYPE
C
C  * Rest of data in files, one sweep per file.
C * First record holds product_hdr:
C * struct_hdr + product_configuration + product_end
C * 
	TYPE product_config  
		type (struct_hdr)  struct_hdr
		integer*2 product_type_code
		integer*2 sched_code
		integer*4 skip_seconds
		type (ymds_time) prod_gen_time
		type (ymds_time) swp_ingest_time
		type (ymds_time)  file_ingest_time
		character*6 spare
		character*12 prod_config_file
		character*12 task_name
		integer*2 flag_word
		integer*4 x_scale
		integer*4 y_scale
		integer*4 z_scale
		integer*4 x_array_size
		integer*4 y_array_size
		integer*4 z_array_size
		integer*4 x_radar_loc
		integer*4 y_radar_loc
		integer*4 z_radar_loc
		integer*4 maximum_rng
		character*2 spare2
		integer*2 data_type_gen
		character*12 projection
		integer*2 data_type_input
		character*1 proj
		character*1 spare3
		integer*2 rad_smoother
		integer*2 num_run_times
		integer*4 z_r_const
		integer*4 z_r_exp
		integer*2 x_smooth
		integer*2 y_smooth
c  * Note following can hold many different types of structures (enum?)
c * For files on tape, though, it should only be raw_psi_struct (44 bytes),
c *  so that is what I will declare here:
c * 
		type (raw_psi_struct)  raw_prod_info
		integer*2 spare4(18)
c  * Then 28 char spare and 48 char color scale def, but that may be
c * removed in future, so iset it spare also...
c * 
		integer*2 spare5(14)
		integer*2 spare6(24)
	END TYPE
C
	TYPE product_end  
		character*16 prod_site_name
		character*8 iris_version_prod
		character*8 iris_version_ingest
		type (ymds_time) oldest_time
		character*28 spare
		integer*2 local_ahead_gmt
		character*16 hardware_name
		character*16 ingest_site_name
		integer*2 ahead_gmt
		integer*4 lat_center
		integer*4 lon_center
		integer*2 gd_height
		integer*2 radar_ht_above_gd
		integer*4 prf
		integer*4 pulse_width
		integer*2 sig_proc_type
		integer*2 trigger_scheme
		integer*2 num_samples
		character*12 clutter_file
		integer*2 filter_num
		integer*4 wavelength
		integer*4 trunc_height
		integer*4 first_bin_rng
		integer*4 last_bin_rng
		integer*4 num_output_bins
		integer*2 flag_word
		integer*2 num_files_used
		integer*2 polarization_used
		character*54 spare2
		integer*4 task_fault_status
		integer*4 input_sites_mask
		integer*2 log_filter_num
		integer*2 cluttermap_flag
		integer*4 lat_proj_ref
		integer*4 lon_proj_ref
		integer*2 prod_seq_num
		integer*2 color_numbers(16)
		integer*2 spare3
		integer*2 ref_height
		integer*2 num_array_elem
		character*1 mean_wind_speed
		character*1  mean_wind_dir
		character*2 spare4
		character*8 time_zone_name
		character*8 spare5
	END TYPE
C
C  *  Then the second record holds the ingest_header =
C * struct_hdr + ingest_configuration + task_configuration +
C * 732 char spare + GPARM from DSP1 (524 bytes).
C * 
C * Modified 5 March 2008 to conform to latest IRIS docs
C * 
	TYPE ingest_configuration  
		character*80 disk_file
		integer*2 num_assoc_files
		integer*2 spare
		integer*4 tot_file_size
		type (ymds_time) vscan_start_time
		character*12 spare2
		integer*2 num_bytes_ray_hdr
		integer*2 n_bytes_ext_hdr
		integer*2 num_task_c_tab
		character*4 spare3
		character*8 iris_version
		character*16 hardware_site_name
		integer*2 time_zone_lst
		character*16 site_name
		integer*2 time_zone_recorded
		integer*4 radar_lat
		integer*4 radar_lon
		integer*2 gd_height
		integer*2 radar_ht_above_gd
		integer*2 resolution
		integer*2 index_first_ray
		integer*2 n_rays_sweep
		integer*2 n_bytes_gparam
		integer*4 radar_ht_msl
		integer*4 platform_vel(3)
		integer*4 antenna_inu_offset(3)
		integer*4 start_fault_status
		integer*2 melt_layer_ht
		integer*2 spare6
		character*8 time_zone_name
		integer*4 flags
		character*16 config_name
		integer*2 spare5(114)
	END TYPE
C
C  * The next structure is task_configuration:
C * struct_hdr + task_sched_info + task_dsp_info + task_calib_info +
C * task_range_info + task_scan_info + task_misc_info + task_end_info + 
C * 730 bytes of comments!
C * 
	TYPE task_sched_info  
		integer*4 start_sec
		integer*4 stop_sec
		integer*4 skip_sec
		integer*4 last_run_time_sec
		integer*4 last_time_used
		integer*4 last_run_day
		integer*2 flag
		integer*2 spare(47)
	END TYPE
C
	TYPE task_dsp_info  
		integer*2 major_mode
		integer*2 dsp_type
		integer*4 data_type_mask(6) 
		integer*4 aux_data_def(27)
		integer*4 prf
		integer*4 pulse_width
		integer*2 prf_mode
		integer*2 dual_prf_delay
		integer*2 agc_feedback_code
		integer*2 sample_size
		integer*2 gain_control_flag
		character*12 clutter_filter_file
		character*1 lin_filter_num
		character*1 log_filter_num
		integer*2 attenuation
		integer*2 gas_attenuation
		integer*2 clutter_flag
		integer*2 xmt_phase_seq
C  * this last spare probably contains the name of the custom extended 
C  * headet in a 16 character ASCII string. 5 Feb 2008
C  * 
		integer*2 spare2(72)
	END TYPE
C
	TYPE task_calib_info  
		integer*2 refl_slope
		integer*2 refl_noise_thresh
		integer*2 clutter_corr_thresh
		integer*2 sqi_threshold
		integer*2 pwr_trhreshold
		integer*2 spare(4)
		integer*2 cal_refl
		integer*2 uncor_refl_thresh
		integer*2 cor_refl_thresh
		integer*2 vel_thresh
		integer*2 width_thresh
		integer*2 zdr_thresh
		integer*2 spare2(3)
		integer*2 flags
		integer*2 spare3(2)
		integer*2 zdr_bias
		integer*2 spare4(138)
	END TYPE
C
	TYPE task_range_info  
		integer*4 first_bin_range
		integer*4 last_bin_range
		integer*2 num_input_bins
		integer*2 num_output_bins
		integer*4 input_step
		integer*4 output_step
		integer*2 flag
		integer*2 rng_avg_flag
		integer*2 spare(68)
	END TYPE
C
	TYPE task_scan_info  
		integer*2 antenna_scan_mode
		integer*2 ang_resolution
		integer*2 spare
		integer*2 num_sweeps
C  * The following 200 bytes can hold a variety of structures:
C  * task_rhi_scan_info, task_ppi_scan_info, task_file_scan, or
C  * task_manual_scan_info:
C  * 
		integer*2 scan_info(100)
		integer*2 spare2(56)
	END TYPE
C
	TYPE task_misc_info  
		integer*4 wavelength
		character*16 tr_ser_number
		integer*4 trans_power
		integer*2 flags
		integer*2 polarization_type
		integer*4 trunc_height
		integer*2 spare_pol_spec(9)
		integer*2 spare(6)
		integer*2 n_bytes_comments
		integer*4 horiz_beamwidth
		integer*4 vert_beamwidth
		integer*4 customer_defined(10)
		integer*2 spare2(104)
	END TYPE
C
	TYPE task_end_info  
		integer*2 task_major_num
		integer*2 task_minor_num
		character*12 task_config_file
		character*80  task_description
		integer*4 num_tasks
		integer*2 task_state
		integer*2 spare
		type (ymds_time) data_time
		integer*2 spare2(102)
	END TYPE
C
C  * Well, the damn task_scan_info can hold one of the following:
C * task_rhi_scan_info, task_ppi_scan_info, task_file_scan_info, or
C * task_manual_scan_info. So I guess I need those also, because I don't
C * know if I am going to get PPI's, RHI's....
C * 
C
	TYPE task_rhi_scan_info  
		integer*2 el_start_angle
		integer*2 el_end_angle
		integer*2 az_scan_angles(40)
		integer*2 spare(58)
	END TYPE
C
	TYPE task_ppi_scan_info  
		integer*2 az_start_angle
		integer*2 az_end_angle
		integer*2 el_scan_angles(40)		
		integer*2 spare(58)
	END TYPE
C
	TYPE task_file_scan_info  
		integer*2 first_az_angle
		integer*2 first_el_angle
		character*12 ant_ctrl_file
		integer*2 spare(92)
	END TYPE
C
	TYPE task_manual_scan_info  
		integer*2 flag
		integer*2 spare(99)

C  * the other 198 bytes are spare * 
	END TYPE
C
C  * Then, after we've waded through all that stuff, we finally get to the data.
C * Well, almost. First each record starts with raw_prod_bhdr, a header for raw 
C * data, and if is the first data record there will be ingest_data_headers,
C * one for each type of data recorded. Then aach ray in the record starts with 
C * -32762 (=6 data words to follow), then the six words of the ray header, and 
C * then the run_length encoded data. Whew!
C * 
C
	TYPE ingest_data_hdr  
		type (struct_hdr) s_hdr
		type (ymds_time) date
		integer*2 sweep_num
		integer*2 ray_resolution
		integer*2 first_ray_index
		integer*2 expected_num_rays
		integer*2 num_rays_in_file
		integer*2 fixed_angle ! unsigned in C
		integer*2 bits_per_bin
		integer*2 data_type ! insigned in C
		integer*2 spare(18)
	END TYPE
C
	TYPE raw_prod_bhdr  
		integer*2 rec_num
		integer*2 sweep_num
		integer*2 offset_first_full_ray
		integer*2 ray_num
		integer*2 flags ! insigned in C
		integer*2 spare
	END TYPE
C
	TYPE ray_hdr  
		integer*2 az_beg ! unsigned in C
		integer*2 el_beg ! unsigned in C
		integer*2 az_end ! unsigned in C
		integer*2 el_end ! unsigned in C
		integer*2 num_bins_in_ray
		integer*2 secs_from_start
	END TYPE
C
	TYPE extended_hdr_v0  
		integer*4 msec_from_start
		integer*2 cal_sig_level
		integer*2 spare(7)
	END TYPE
C 
	TYPE  extended_hdr_v1  
		integer*4 msec_from_start
		integer*2 cal_sig_level
		integer*2 az ! unsigned in C
		integer*2 el ! unsigned in C
		integer*2 train_order ! unsigned in C
		integer*2 el_order ! unsigned in C
		integer*2 pitch ! unsigned in C
		integer*2 roll ! unsigned in C
		integer*2 heading ! unsigned in C
		integer*2 az_rate ! unsigned in C
		integer*2 el_rate ! unsigned in C
		integer*2 pitch_rate ! unsigned in C
		integer*2 roll_rate ! unsigned in C
		integer*4 lat ! unsigned in C
		integer*4 lon ! unsigned in C
		integer*2 hdg_rate ! unsigned in C
		integer*2 altitude
		integer*2 vel_ew
		integer*2 vel_ns
		integer*4 msec_since_update
		integer*2 vel_vert
		integer*2 nav_sys_ok_flag ! unsigned in C
		integer*2 radial_vel_correction
	END TYPE
