      PROGRAM JOBFILETOPARAMETERS
      LOGICAL SQIEXISTS,CHANGEMELTBANDEXISTS
      CHARACTER DUMMY*80,FL*2,STORM*12
C parameters.txt is the file that is used to enter many metadata into the
C netcdf version of the wind analysis files
C this program uses data from the jobfile_radar file to write the first lines
C of the parameters.txt file
      OPEN(80,FILE='jobfile_radar')
      OPEN(81,FILE='parameters.txt')
      READ(80,'(3I2,A2)')IYEAR,IMONTH,IDAY
C the structure of the wind-file name was formed well before Y2K and 
C for backwards compatibility we still use it, bu for other purposes
C we want the whole year
C We assume anything any file with a 50 or above at the begin is in the
C 20th century, and anything less if from the 21st century
      IF(IYEAR.GT.49)THEN
         IYEAR=IYEAR+1900
      ELSE
         IYEAR=IYEAR+2000
      ENDIF
      WRITE(81,'(3I5)')IYEAR,IMONTH,IDAY
C STORM is the name of the storm (or experiment), generally simply determined
C from the data entered by the flight directory and incorporated into the 
C jobfile
      READ(80,'(A)')STORM
      WRITE(81,'(A)')STORM
C Time for the beginning and end of the analysis period in hours, mins, secs
      READ(80,'(3I2,X,3I2)')IHS,IMS,ISS,IHE,IME,ISE
      WRITE(81,'(3I2.2,X,3I2.2)')IHS,IMS,ISS,IHE,IME,ISE
C Storm motion in the east and north directions in m/s
      READ(80,*)UMOVE,VMOVE
      WRITE(81,'(2F6.2)')UMOVE,VMOVE
C Center time (where the storm latitude and longitude below was valid)
      READ(80,'(3I2)')IHC,IMC,ISC
      WRITE(81,'(3I2.2)')IHC,IMC,ISC
      READ(80,'(A)')DUMMY
      READ(80,'(A)')DUMMY
      READ(80,'(A)')DUMMY
      READ(80,'(A)')DUMMY
      READ(80,'(A)')DUMMY
C IBST--number of bins at the beginning of ray to be ignored
C INOB--number of bins to be average to de-alias the next bin by Bargen/Brown
      READ(80,*)IBST,INOB
C AAZMCOR, AELCOR, AND ARDEL are for the aft-pointing radar antenna
C AAZMCOR  is the amount to add to the rotation angle relative to aircraft
C AELCOR is the amount to add to the tilt relative to the plane normal
C to the fuselage of the aircraft
C ARDEL is the range delay correction added to the distance from the aircraft
C read from the raw Doppler-radar file
      READ(80,*)AAZMCOR,AELCOR,ARDEL
C APCOR and ADCOR are for the aft-pointing radar antenna
C APCOR is the amount to add to the aircraft pitch to account for a systematic
C       bias of the antenna pointing direction relative to the aircraft
C ADCOR is the corresponding number for aircraft drift
      READ(80,*)APCOR,ADCOR
      WRITE(81,'(2I5)')IBST,INOB
      WRITE(81,'(3F8.2)')AAZMCOR,AELCOR,ARDEL
      WRITE(81,'(2F8.2)')APCOR,ADCOR
C FAZMCOR, FELCOR, AND FRDEL are for the fore-pointing radar antenna
C FAZMCOR  is the amount to add to the rotation angle relative to aircraft
C FELCOR is the amount to add to the tilt relative to the plane normal
C to the fuselage of the aircraft
C FRDEL is the range delay correction added to the distance from the aircraft
C read from the raw Doppler-radar file
      READ(80,*)FAZMCOR,FELCOR,FRDEL
C FPCOR and FDCOR are for the fore-pointing radar antenna
C FPCOR is the amount to add to the aircraft pitch to account for a systematic
C       bias of the antenna pointing direction relative to the aircraft
C FDCOR is the corresponding number for aircraft drift
      READ(80,*)FPCOR,FDCOR
      WRITE(81,'(3F8.2)')FAZMCOR,FELCOR,FRDEL
      WRITE(81,'(2F8.2)')FPCOR,FDCOR
C DBZSLOPE IS THE AMOUNT TO MULTIPLY THE DBZ FROM THE RAW RADAR FILES
C THIS IS ALMOST ALWAYS 1.0
      READ(80,*)CDUMMY,CDUMMY2,CDUMMY3,DBZSLOPE
      WRITE(81,'(F8.2)')DBZSLOPE
C SQI IS SIGNAL QUALITY INDEX--SINCE RVP8, 0. IS THE WORST, 1.0 IS THE BEST
      READ(80,*)SQI
      INQUIRE(FILE='changesqi',EXIST=SQIEXISTS)
      IF(SQIEXISTS)THEN
        OPEN(88,FILE='changesqi')
        READ(88,*)SQI
        CLOSE(88)
      ENDIF
      WRITE(81,'(F8.2)')SQI
      READ(80,'(A)')DUMMY
C CONTINUITY is the number of times the weight of the continuity equation is
C above what would be expected (a number much higher than 1 is needed to
C remove connected volumes with a single-sign error in cont. equation)
      READ(80,*)CONTINUITY
C HTMELT is the height midway through the thickness of the bright band (km)
C TKMELT is the thickness (km) of the melting band
C The above are the initial prescribed values which may be changed by software
      READ(80,*)HTMELT,TKMELT
      INQUIRE(FILE='changemeltingband',EXIST=CHANGEMELTBANDEXISTS)
      IF(CHANGEMELTBANDEXISTS)THEN
         OPEN(88,FILE='changemeltingband')
         READ(88,*)HTMELT,TKMELT
         CLOSE(88)
      ENDIF
      WRITE(81,'(2F8.2)')HTMELT,TKMELT
C ZLOW IS THE Lowest reflectivity (dBZ) above which some of the precipitation
C above the melting band is considered to be rain
C ZHIGH is the reflectivity (dBZ) where all the precipitation above the melting
C band is considered to be rain
C The above two are prescribed and used in a linear manner to determine
C the precipitation fallspeed to remove from Doppler radial velocities
      READ(80,*)ZLOW,ZHIGH
      WRITE(81,'(2F8.2)')ZLOW,ZHIGH
      READ(80,'(A)')DUMMY
C AZMIN is the nominal heading from storm center for inbound profile
C AZMOUT is the nominal heading from center for outbound profile
      READ(80,*)AZMIN,AZMOUT
      WRITE(81,'(2F8.2)')AZMIN,AZMOUT
      READ(80,'(A)')DUMMY
C IANTENNA is the antenna aboard the aircraft
C 0 is the original NOAA parabolic antennas
C 1 is the French antenna
C 2 is the antenna aboard the G-IV
C 3 is the Malibu-built antennas aboard the P-3s
      READ(80,*)IANTENNA
      WRITE(81,'(I1)')IANTENNA
      CLOSE(80)
      CLOSE(81)
      STOP
      END

