      PROGRAM LISTWINDS
      CHARACTER KEYWORD*4,FLTNAME*8,STMNAME*12,RADAR*4,EXPERIMENT*32
      CHARACTER CREATIME*32,EXTRA1*28,FILNAM*80,OUTFILNAM*80
      INTEGER IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3
C IMAX X DIMENSION OF WIND AND REFLECTIVITY ARRAYS
C JMAX Y DIMENSION OF WIND AND REFLECTIVITY ARRAYS
C JMAX = 2 FOR VERTICAL CROSS SECTIONS
C KMAX Z DIMENSION OF WIND AND REFLECTIVITY ARRAYS
C FLTNAME IS FLIGHT ID IN FORM YYMMDDAI
C KEYWORD INDICATES WHETHER W FILE IS 16 BIT INTEGER OR REAL
C KEYWORD = 'WIND' IS 16 BIT INTEGER
C KEYWORD = 'RYV ' IS 32-BIT REAL
C STIME IS START TIME OF ANALYSIS IN SECONDS SINCE 0 UTC ON DAY OF FLIGHT
C ETIME IS END TIME OF ANALYSIS IN SEONCDS SINCE 0 UTC ON DAY OF FLIGHT
C STIME AND ETIME CAN BE GREATER THAN 86400
      REAL STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
      REAL U(2000000),V(2000000),W(2000000),DBZ(2000000)
C U = EAST-WEST COMPONENT (xy) or RADIAL (vert_inbound or vert_outbound)
C V = SOUTH-NORTH COMPONENT (xy) OR TANGENTIAL (vert_inbound or vert_outbound)
C W = VERTICAL WIND 
C U, V, AND, W ARE IN (m/s)
C DBZ = RADAR REFLECTIVITY (dBZ)
C FOR 'xy' FILES:
C  x = .5 * SX + (I-1)*SX - XZ
C  y = .5 * SY + (J-1)*SY - YZ
C  z = ZZ + (Z-1)*SZ
C FOR 'vert_inbound or vert_outbound' FILES:
C  r = XZ + SX*(I-1)
C  z = ZZ * (K-1)*SZ
C  J = 1 is for inbound data
C  J = 2 is for outbound data
C FILNAM is the name of the ".w" file
      LU=80
      READ(5,'(A)')FILNAM
      CALL READHEADER(LU,FILNAM,KEYWORD,FLTNAME,
     + STMNAME,RADAR,EXPERIMENT,
     + CREATIME,EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     + SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     + POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7)
      IHS=INT(STIME/3600.)
      IMS=INT((STIME-3600.*IHS)/60.)
      ISS=INT((STIME-3600*IHS-60.*IMS))
      IHE=INT(ETIME/3600.)
      IME=INT((ETIME-3600.*IHE)/60.)
      ISE=INT((ETIME-3600*IHE-60.*IME))
      WRITE(6,50)IHS,IMS,ISS
      WRITE(6,60)IHE,IME,ISE
 50   FORMAT('START TIME = ',3I2.2)
 60   FORMAT('END TIME =   ',3I2.2)
      IF(KEYWORD.EQ.'WIND'.OR.KEYWORD.EQ.'wind')THEN
       IUV=0
       WRITE(6,*)'IUV = ',IUV
      ELSEIF(KEYWORD.EQ.'RUV '.OR.KEYWORD.EQ.'ruv ')THEN
       IUV=1
       WRITE(6,*)'IUV = ',IUV
      ELSE
       WRITE(6,89)KEYWORD
89     FORMAT('KEYWORD IS ',A4,'....STOPPING')
       STOP
      ENDIF
      CALL LDPLN(LU,U,V,W,DBZ,IMAX,JMAX,KMAX,IUV,ZZ,SZ)
      CLOSE(80)
      CALL LISTWIND(U,V,W,DBZ,IMAX,JMAX,KMAX,SX,SY,SZ,XZ,YZ,ZZ)
      END
      SUBROUTINE LISTWIND(U,V,W,DBZ,IMAX,JMAX,KMAX,SX,SY,SZ,XZ,YZ,ZZ)
      REAL U(IMAX,JMAX,KMAX),V(IMAX,JMAX,KMAX),W(IMAX,JMAX,KMAX)
      REAL DBZ(IMAX,JMAX,KMAX)
      REAL X(200),Z(200)
C      DO K=1,KMAX
C       DO J=1,JMAX
C        DO I=1,IMAX
C         U(I,J,K)=-999.9
C         V(I,J,K)=-999.9
C         W(I,J,K)=-999.9
C         DBZ(I,J,K)=-999.9
C        ENDDO
C       ENDDO
C      ENDDO
      DO K=1,KMAX
       Z(K)=ZZ+(K-1)*SZ
       DO I=1,IMAX
        X(I)=XZ+(I-1)*SX
       ENDDO
      ENDDO
      I=1
      DO WHILE(I.LT.IMAX)
       WRITE(6,*)'U'
       WRITE(6,100)(X(N),N=I,I+9)
 100   FORMAT('X       ',10F7.1)
       DO J=1,2
        DO K=KMAX,1,-1
         WRITE(6,200)J,Z(K),(U(N,J,K),N=I,I+9)
 200     FORMAT(I1,1X,11F7.1) 
        ENDDO
       ENDDO
       I=I+10
      ENDDO
      I=1
      DO WHILE(I.LT.IMAX)
       WRITE(6,*)'V'
       WRITE(6,100)(X(N),N=I,I+9)
       DO J=1,2
        DO K=KMAX,1,-1
         WRITE(6,200)J,Z(K),(V(N,J,K),N=I,I+9)
        ENDDO
       ENDDO
       I=I+10
      ENDDO
      I=1
      DO WHILE(I.LT.IMAX)
       WRITE(6,*)'W'
       WRITE(6,100)(X(N),N=I,I+9)
       DO J=1,2
        DO K=KMAX,1,-1
         WRITE(6,200)J,Z(K),(W(N,J,K),N=I,I+9)
        ENDDO
       ENDDO
       I=I+10
      ENDDO
      I=1
      DO WHILE(I.LT.IMAX)
       WRITE(6,*)'DBZ'
       WRITE(6,100)(X(N),N=I,I+9)
       DO J=1,2
        DO K=KMAX,1,-1
         WRITE(6,200)J,Z(K),(DBZ(N,J,K),N=I,I+9)
        ENDDO
       ENDDO
       I=I+10
      ENDDO
      RETURN
      END
      SUBROUTINE READHEADER(LU,FILNAM,KEYWORD,FLTNAME,
     + STMNAME,RADAR,EXPERIMENT,
     + CREATIME,EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     + SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     + POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7)
      CHARACTER KEYWORD*4,FLTNAME*8,STMNAME*12,RADAR*4,EXPERIMENT*32
      CHARACTER CREATIME*32,EXTRA1*28,FILNAM*80
      INTEGER IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3
      REAL STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
      OPEN(LU,FILE=FILNAM,STATUS='OLD',FORM='UNFORMATTED')
      READ(LU)KEYWORD,FLTNAME,STMNAME,
     + RADAR,EXPERIMENT,CREATIME,
     + EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,
     + EXTRA3,STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
      RETURN
      END
      SUBROUTINE LDPLN(LU,U,V,W,DBZ,IMAX,JMAX,KMAX,IUV,ZZ,SZ)
c      USE NETCDF
      REAL U(IMAX,JMAX,KMAX),V(IMAX,JMAX,KMAX),W(IMAX,JMAX,KMAX)
      REAL DBZ(IMAX,JMAX,KMAX)
      INTEGER*2 IU(200),IV(200),IW(200),IDB(200),IDV(200)
      REAL RU(200),RV(200),RW(200),RDV(200)
      FLAG=-999.9
      WRITE(6,*)'INSIDE LDPLNW'
      WRITE(6,*)'IMAX,JMAX,KMAX,IUV = ',IMAX,JMAX,KMAX,IUV
      DO K=1,KMAX
       DO J=1,JMAX
        IF(IUV.EQ.0)THEN
         READ(LU)(IU(I),IV(I),IW(I),IDB(I),IDV(I),I=1,IMAX)
c         write(6,*)'j,k,iu = ',(j,k,iu(i),i=1,imax)
c         write(6,*)'j,k,iv = ',(j,k,iv(i),i=1,imax)
c         write(6,*)'j,k,iw = ',j,k,(iw(i),i=1,imax)
c         write(6,*)'j,k,idb = ',j,k,(idb(i),i=1,imax)
c         write(6,*)'j,k,idv = ',(j,k,idv(i),i=1,imax)
        ELSE
         READ(LU)(RU(I),RV(I),RW(I),IDB(I),RDV(I),I=1,IMAX)
        ENDIF
        DO I=1,IMAX
         IF(IDB(I).GT.-1000)THEN
          DBZZ=IDB(I)*.1
          DBZ(I,J,K)=DBZZ
         ELSE
          DBZZ=FLAG
          DBZ(I,J,K)=FLAG
         ENDIF
         IF(IUV.EQ.0)THEN
          IF(IU(I).LT.-9990)THEN
           U(I,J,K)=FLAG
           V(I,J,K)=FLAG
          ELSE
           WDR=IU(I)*.1
           WSP=IV(I)*.1
           XU=-SIN(WDR*3.14159/180.)*WSP
           XV=-COS(WDR*3.14159/180.)*WSP
           U(I,J,K)=XU
           V(I,J,K)=XV
          ENDIF
          IF(IW(I).GT.-9990.AND.DBZZ.GT.FLAG)THEN
           W(I,J,K)=VT+IW(I)*.01
          ELSE
           U(I,J,K)=FLAG
           V(I,J,K)=FLAG
           W(I,J,K)=FLAG
          ENDIF
          IF(U(I,J,K).GT.FLAG.AND.W(I,J,K).LE.FLAG)THEN
           WRITE(6,*)'I,J,K,U,V,W,IU,IV,IW = ',
     1    I,J,K,U(I,J,K),V(I,J,K),W(I,J,K),IU(I),IV(I),IW(I)
          ENDIF
         ELSE
          IF(RU(I).GT.FLAG.AND.RV(I).GT.FLAG.AND.RW(I).GT.FLAG)THEN
           U(I,J,K)=RU(I)
           V(I,J,K)=RV(I)
           DBZ(I,J,K)=IDB(I)*.1
           W(I,J,K)=VT+RW(I)
          ELSE
           U(I,J,K)=FLAG
           V(I,J,K)=FLAG
           W(I,J,K)=FLAG
           DBZ(I,J,K)=FLAG
          ENDIF
         ENDIF
        ENDDO
c        WRITE(6,*)'J,K,U = ',J,K,(U(I,J,K),I=1,IMAX)
       ENDDO
      ENDDO
      RETURN
      END
