      PROGRAM MAKEINOUTFILES
C 
C A program to make the files infiles, infiles_profile, outfiles,
C and outfiles_profile that are used to make the netcdf versions of the 3D
C and radial profile wind and reflectivity analysis files.
C
C INFILE Variable contains 8-byte flight ID, two underscore 
C and a 4-byte center time
      CHARACTER INFILE*14
C file infiles contains the input 3D files that will be converted to
C 3D netcdf files
      OPEN(80,FILE='infiles')
C
C file infiles_profile contains the names of the 6 vertical profile
C data files that will be converted to netcdf vertical profile files
      OPEN(81,FILE='infiles_profile')
C Read the variable INFILE from the first line of file 'infiles'
      READ(80,'(A14)')INFILE
C
C Write the file names of the input profile .w files that are in
C infiles_profile
C
      WRITE(81,'(A14,"vert_inbound.w")')INFILE
      WRITE(81,'(A14,"vert_inbound_rel.w")')INFILE
      WRITE(81,'(A14,"vert_inbound_fall.w")')INFILE
      WRITE(81,'(A14,"vert_outbound.w")')INFILE
      WRITE(81,'(A14,"vert_outbound_rel.w")')INFILE
      WRITE(81,'(A14,"vert_outbound_fall.w")')INFILE
      CLOSE(81)
C 
C Write the file names of the output vertical-profile netcdf files that 
C have been converted from the profile .w files
      OPEN(81,FILE='outfiles_profile')
      WRITE(81,'(A14,"vert_inbound.nc")')INFILE
      WRITE(81,'(A14,"vert_inbound_rel.nc")')INFILE
      WRITE(81,'(A14,"vert_inbound_fall.nc")')INFILE
      WRITE(81,'(A14,"vert_outbound.nc")')INFILE
      WRITE(81,'(A14,"vert_outbound_rel.nc")')INFILE
      WRITE(81,'(A14,"vert_outbound_fall.nc")')INFILE
      CLOSE(81)
      CLOSE(80)
C
C BELOW IS WHAT IS NEEDED TO PRODUCE BOTH A SINGLE DELTAX TOLERANCE OR A 
C       2 DELTAX TOLERANCE IN OUTPUT WIND FIELDS--HOW FAR AWAY FROM A GRID
C       POINT THE CENTER OF WEIGHT CAN BE FROM A GRID POINT FOR A VALUE TO BE
C       PUT AT THAT GRID POINT
C
      OPEN(81,FILE='infiles_netcdf')
      OPEN(82,FILE='outfiles')
      WRITE(81,'(A)')'1.0'
      WRITE(81,'(A14,"xy.w")')INFILE
      WRITE(81,'(A)')'0.5'
      WRITE(81,'(A14,"xy_singleacc.w")')INFILE
      WRITE(82,'(A14,"xy.nc")')INFILE
      WRITE(82,'(A14,"xy_singleacc.nc")')INFILE
      STOP
      END
