void rasx_get_image(width, im_array, pani)
int *width;
int im_array[JMAX][IMAX]; /* = im_array(imax, jmax) in Fortran */
struct mizu *pani;
{
	int i, j;
	unsigned long pix;
	char *dptr;
	unsigned char ipix;
 	int color_index[256];
	XImage *temp_xi;
/* Clear array: */
 	for (i = 0; i<256; i++)
 		color_index[i] = 0;
/* Load the colors I am using: */
	for (i = 0; i < 32; i++) {
		color_index[pani->col_pix[i]] = i;
	}
	
/* Retrieve XImage from pixmap. I have to do this because any text
 * or lines that i drew are in the pixmap, not in the XImage...
 * Unfortunately, I think this slows things down a bit.
 *	Note, I use a temporary XImage (as of 11 Oct 2000), so that I
 * can use pani->xi for drawing rasters. I destroy temp_xi each time,
 * to plug up a rather large memory leak.
 */
	temp_xi = XGetImage(pani->display, pani->pixmap, 
		0, 0, IMAX, JMAX, AllPlanes, ZPixmap);
/* Read XImage, load image array with color map pointers
 * corresponding to pixel values.
 *	NOTE: To speed this up I am reading the pixel values directly from the 
 * XImage.data, instead of calling XGetPixel. The way I have done this is not 
 * very portable!! I am assuming the byte order is the same on server and 
 * client. Also I assume that width of image is a multiple of 4, so I don't 
 * worry about pad bytes at the end of the scan lines. So buyer beware. 
 * Peter Dodge 31 Aug 2000*/
	dptr = temp_xi->data;
	printf(" dptr: %d \n", dptr);
/* Note image is stored with 0,0 at top, but I want 0,0 at bottom, hence
 * decrementing J loop
 */
	for ( j = JMAX-1; j >-1; j--){
		for( i = 0; i < *width; i++) {
			ipix = *dptr;
			pix = ipix;
			im_array[j][i] = color_index[pix];
			dptr++;
		}
	}
/* Now we have to free up that image, or we will have a monster memory leak
*/
	XDestroyImage(temp_xi);
}

