/*   previous_ten.c
* This program uses the Standard C Library time
* functions (see time.h) to obatain the current time in UTC and then figure out
* previous 10 minute period to generate a file name filter to
* get alist of radar file names in 10 minute chumnks and then dump the headers
* to a file that Paul Reasors INE correction code can work on.
* 14 May, 2018
*/
#include <time.h>
#include <stdlib.h>
#include <stdio.h>
# include <string.h>

int main(int argc, char **argv)
{
FILE *infile;
    time_t current_time;
	struct tm *gmt;
    char* c_time_string;
/* pathe something like
*	/home/hrd/yearmodaNn/
*/
	char path[22], flight_id[10];
	char command_string[132];
	int len;
	int month,day,hour;
	int interval;
	int year_code;

	if(argc > 1)
		strcpy(path, argv[1]);
	else {
infile = 	fopen( "/dev/shm/FLID", "r");
	if(infile == NULL ) {
	sprintf(path,"/home/sysop/nowhereman/");
}
	else {
	fread(flight_id,sizeof (char), 10, infile); 
	fclose(infile);
		sprintf(path, "/home/sysop/%.10s/", flight_id);
	}
}
    /* Obtain current time. */
    current_time = time(NULL);
	gmt = gmtime(&current_time);

    if (current_time == ((time_t)-1))
    {
        (void) fprintf(stderr, "Failure to obtain the current time.\n");
        exit(EXIT_FAILURE);
    }



/*
printf("Day of year: %d\n", gmt->tm_yday);
	printf("UTC time: %.2d:%.2d:%.2d \n", gmt->tm_hour,gmt->tm_min,gmt->tm_sec);
*/
/* now make up the radar file name string to search for:
*/
	year_code = gmt->tm_year -100;
/* that should work until 2099, by which time this code 
* will not be needed!
*/
	month = gmt->tm_mon + 1;
	day = gmt->tm_mday;
	hour = gmt->tm_hour;
	interval = gmt->tm_min / 10;
	interval = interval -1;
	if(interval < 0) {
		interval = 5;
	hour = hour -1;
}
	if(hour <0) {
		hour = 23;
		day = day -1;
}
/* and if day is 0 then we have to get mmonth and day right!
* and that could even mean adjusting the year
*  if we are flying on Jan 11!
* That would involve getting the Modified Julian day (day relative to 1/1/1970), subtracting 1 and then
* inverting to get new year, month and day.
 * But we are doing this for tropical storm season of 2018 so I will ignore stuff about
* about Leap Year etc.
*/
if (day == 0) {
	month = month -1;
	if(month == 6) day = 30;
	else if(month == 7) day = 31;
	else if (month == 8) day = 31;
	else if(month == 9) day = 30;
	else if(month == 10) day = 31;
	else if(month == 11) day =  30;
/* and if this does not work then we are flying 
* in early winter of 2019 and AOC failed to 
* implement the blended solution!
*/
}
	len = sprintf(command_string, "ls %snrs%.2d%.2d%.2d%.2d%.1d*RAW* > swps_list \n",path,year_code,month,day,hour,interval);
	system(command_string);

    exit(EXIT_SUCCESS);
}

