      subroutine sub_radar_rvp8_read(lu,KINDRADAR,IHEADERFLAG,IDATAFLAG,
     +                          IERR)
C This code modifies the program read_iris_sweeps
C to a F90 suvroitne that is called to read one radar ray at a time
c /read in a radar tape file and write out sweeos in the
c SIGMET/Vaisala IRIS Raw data format. to simlate sweeps
C written out by the RVP8. Oh how I did not want to
C write this code.... started 9 Dec 2008. Peter Dodge,
C radar data p;umber, HRD 
C Iris data structures

C
C   This subroutine reads and unpacks the 1988 Radar format data.  
C The data is read from a disc file. The routine
C returns 1 ray of data from one of the radars per call.  Radardiscread
C follows the SIGMET documentation.  It returns the Tape Header information,
C the Data Record Header information, the Ray Header information and the data.
C The Tape Header is a 1024 record, the Data record is variable length with
C a maximum size of 4096 words, the Ray Header which is part of the Data
C record is 22 words long and the data contains a maximum of 512 bins.
C NOTE: rvp8 may contain more than 512 bins !!
C IDRADAR contains the radar being read: 1 for Lower Fuselage and
C 2 for Tail.  LF stands for Lower Fuselage, TA stands for Tail.
C The Tape Header contains information from both radars.
C    The calling program sends:
C    lu - unit number connected to the file
C    KINDRADAR - kind of radar to decode, 0=both, 1=LF, 2=TA (integer)
C    IHEADERFLAG - flag that determines if the user wants the 1024 words
C                  contained in the Tape Header, 0=no, 1=yes.
C                  A subset is returned in the TAPEHEADER common area.(integer)
C    IDATAFLAG - flag that determines the type of data to be returned
C                to the calling program: 
C              bit 2 on: returns dbz
C              bit 1 on: returns velocity    
C              bit 0 on: returns spectral width
C    Radardiscread returns:
C    IERR - error code
C            0 no error; good read
C           -2 end of file(final record on the file)
C    
C    Radardiscread returns two common areas.
C    TAPEHEADER - common area containing some parameters from the data.
C                 Header and a buffer(IHEADER) that contains the 1024 words.
C                 The information in IHEADER is scaled according to the
C                 SIGMET documentation.  The routine returns buffer IHEADER
C                 if IHEADERFLAG equals 1.  IHEADER is set to 0 otherwise.
C                  TAPEHEADER is composed of the followi
C --------- ebd  of original comments -----------
C
	implicit none 
	integer lu,KINDRADAR,IHEADERFLAG,IDATAFLAG
	integer IERR
	include "iris_f90_structures.h"
	include "TDR_hdr_f90.h"
	include "sigmet_dsp_data_types_f90.h"
	include "hrd_radar_common_blocks.f"

	integer max_rays, max_gates

	parameter(max_rays = 500, max_gates = max_hrd_dim)

C IRiS files probalby only hold 5 or less but  I keep it  big just in case...


	integer*4 swapped, read_stuff
	character*132 sweep_fn
C pointers are 8 byte on 64 bit machines
	integer*8 swp_lu
	integer*4 iostat
	integer*4 nrem, tot_read
					
	type (struct_hdr) str_hdr
	type (product_config) prod_conf
	type (product_end) prod_end
	type (ingest_configuration) i_config
	type (task_sched_info) t_si
	type (task_dsp_info) t_dsp
	type (task_calib_info) t_calib
	type (task_range_info) t_range
	type (task_scan_info) t_scan

	type (ymds_time) start_time_str
	type (ymds_time) end_time_str
	type (ymds_time) date_time
	
	type (task_misc_info) t_misc
	type (task_end_info) t_end

	type (task_rhi_scan_info) t_rhi
	type (task_ppi_scan_info) t_ppi
	
	type (ingest_data_hdr) idh(MAX_FIELDS) !)* should be more general! */
	type (raw_prod_bhdr) rpbh
cout.	type (ray_hdr) rh
cout	type (TDR_hdr) air_hdr
	type (ray_hdr) rh(max_rays)
	type (TDR_hdr) air_hdr(max_rays)

C and here are the arrays for the pther data types:
cout	real dbz(max_gates), dop(max_gates), wid(max_gates)
C instead use the arrats contained in the radardata common block

C HRD radar tape/file data structures
C Radar tape/file stuff
C 

c note the read_* suntoutines will fill the varaibles intse
C common blocks
	logical tail_fore, tail_aft
	logical french_antenna
	character*1 antenna_type
C Here is the common blick that holks
C file pointer, file status, and file neme
	common/rvp8_files/sweep_open,
     *		current_fptr,
     +		current_fn
C
	logical*8 sweep_open
C 64 bit machines use 8 byte pointers
	integer*8 current_fptr
	character*132 current_fn
C Added this to remember whether ine sweep arrays have been filled
	logical sweep_filled
C and na array with times for eaxh ray. Depinding on whether
C is rotating clockwise or counter
	real ray_time(max_rays)
	integer irot_dir
	integer ray_table(max_rays)
c Here are the arrays
	real dBZ_sweep(max_gates, max_rays)
	real vel_sweep(max_gates, max_rays)
	real wid_sweep(max_gates, max_rays)
C for flexibility, added flags for what types of data
C are stored in ref, vel and width arrays. Note that these
C flags are set in the first sub in this set
	common /rvp8_data_flags/data_sel_flags,
     +		num_data_types, sweep_data_types
	integer*4 data_sel_flags(3)
	integer*4 num_data_types, sweep_data_types(10)

C and save in a common block
	common/ stash /ray_table,
Cout     +		rh, air_hdr,
     +		dBZ_sweep, vel_sweep, wid_sweep
C
	real bam16_TO_deg
	real bad_val
	integer iray, isweep, ifirst_ray, last_ray
	integer num_bins, num_good_rays,io_error
	integer num_rays, num_fields, num_sweeps
	integer i, ii, itemp
	real vel_nyq, wavelength
	real sweep_start, time_start, time_end, azm_m
C save th rh and air_hdr arrays... hp f90 woiln not
C let me put them in common , althoigh it woild when
C they were declared using the record syntac. ke garne...
	save rh, air_hdr
C and save these variables between calls
	save num_rays, num_sweeps,iray, isweep, swapped
	save rpbh, idh, num_fields, nrem, tot_read
	save sweep_start
	save sweep_filled
C added to keep track of midnight crossing for 
c 48 h clock...
C
	COMMON /midnight/flight_jday,crossed_midnight
	integer*4 jday, flight_jday
	logical*8 crossed_midnight
C

	bad_val = -999.0

	
	read_stuff = 0 ! set to  1 to get massive dump of info
D	read_stuff = 1
C set ierr to succesful read initially
	ierr = 0
c Set legacy rvp5 code ised by taycor subroitine
	icode = 0
	icode = ibset(icode,15) ! dBZ
	icode = ibset(icode,14) ! vel
	icode = ibset(icode,13) ! spec edth
	if(kindradar .eq. 1)then
		icode = ibset(icode,11)
	else if(kindradar .eq. 2) then
		icode = ibset(icode,12)
	end if
C
C I had to ass a way to loop back here
C when I read an empty ray (nbins = 0). Previously
C I woild return an ampty ray with ierr= -4, boy other
C HRD code did not check those, and emtyrays had bad times and lat,lons
C so now I will kiip readin intil I get a giid ray) What a tangled web this
C code had become... 29 July 2010
C
        write(6,*)'i got here 1 and sweep_open = ',sweep_open
100	if( .not.sweep_open) then ! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	   sweep_fn = current_fn
	   call open_iris_file(swp_lu, sweep_fn, iostat)
	write(6,*)iostat,' iostat opening ', sweep_fn
D	write(6,*)' returned file pointer ', swp_lu
	if(iostat .ne. 1) then
		stop ' Coild not open file. adios '
	else
D		write(6,*) "Opened sweep file", sweep_fn
d		write(6,*)'swp_lu (ptr to file desc) ',swp_lu
	end if
	   current_fptr = swp_lu
	   sweep_open = .true.

D	call flush(6)
c comment out to see if it  fucckig up
	swapped = 0 ! bytes not swapped   
Cout	call check_byte_swapping(swp_lu, swapped)
C Following for HP Unix big endian machines
Cout	swapped = 1 ! bytes  swapped
C
        write(6,*)'calling read_iris_record_1'
	call read_iris_record_1(swp_lu, swapped, read_stuff,
     +		prod_conf, prod_end )
D	write(6,*)' read first record'
D	call flush(6)
C note i donot trust sweep number in raw_psi so i use my own
	itemp = ntasweep
	call read_product_hdr(0, prod_conf, prod_end)

C restore sweeop number
	ntasweep = itemp
        write(6,*)'calling read_iris_record'
	call read_iris_record_2(swp_lu, swapped, read_stuff, 
     +		 i_config, t_si, 
     +		t_dsp, t_calib, t_range, t_scan,  t_misc, t_end,
     +		t_rhi)
	write(6,*)' Read record 2'
C load tot_read, whick is updated by subsequent
C calls to read the sweep file
	tot_read = 2 * BLK_LENGTH
C
	call read_task_hdr(0, t_si, t_dsp, t_calib,
     +		t_range, t_scan, t_misc, t_end, 
     +		t_rhi)
D	call flush(6)

C load up bin length in common clock, in km
C rvp5 supportes 3 diff ht laengrhs, so need here
C for legaxy
        write(6,*)'kindradar coming'
	if( kindradar .eq. 1 ) then
	  gtlnlf = t_range%output_step * 0.00001
	  rdellf = t_range%first_bin_range * 0.00001
	  rmaxlf = t_range%last_bin_range * 0.00001
	  ivrangelf = 0
	  idradar = 1
	else
	  do ii = 1, 3
	     gtlnta(ii) = t_range%output_step *0.00001
	  end do
	  rdelta = t_range%first_bin_range * 0.00001
	  rmaxta = t_range%last_bin_range * 0.00001
	  ivrangeta = 0
	  idradar = 2
          write(6,*)'rdelta,rmaxta,ivrangeta,idradar = ',
     1                   rdelta,rmaxta,ivrangeta,idradar
	end if
C get Nyquist vel from stuff stored in tasd header structures in m/x
cout	vel_nyq = t_misc%wavelength * 0.0001 * t_dsp%prf * 0.25
        write(6,*)'wavelength coming'
	wavelength= t_misc%wavelength * 0.0001
        write(6,*)'wavelength = ',wavelength
	call get_nyq_vel(t_dsp%prf_mode, t_dsp%prf,wavelength,vel_nyq )


D	write(6, *)"Nyquist velocity ",vel_nyq," m/s"
	if( kindradar .eq. 1 ) then
		xniqlf = vel_nyq
	else
		xniqta = vel_nyq
	end if

        write(6,*)'xniqlf = ',xniqlf
C There  may be multiple sweeps per file (although I hpe not ) so
C I need a do loop here.
C
	num_sweeps = t_scan%num_sweeps
        write(6,*)'num_sweeps = ',num_sweeps
C num_assoc_files is ALL files used to make this file
C and so holds num_fileds x num_
	num_fields = i_config%num_assoc_files/num_sweeps
D	write(6,*)'Number fields, sweeps ',num_fields, num_sweeps
C End of iniital file records block
C prime pumps
        write(6,*)'num_sweeps,num_fields = ',num_sweeps,num_fields
	isweep = 1
	iray = 1
	sweep_filled = .false.
C save sweep_start time to use in getting ray time
	    sweep_start = time
C
	else
C restore file pointer to current open file
	   swp_lu = current_fptr
	end if ! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C
C Note if needed, read in a sewwp and firgure out
C which ray is actually the first ray, in tume.
	if( .not.sweep_filled) then
C If moltiplesweeps per file, we can't read them all in at
C read thrm all in at the same time, would be a qaste of space
C instead isweep and num_sweeps are caved and checked
cout	do isweep = 1, num_sweeps !  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
cout	   write(6,*)" *** Sweep # ",isweep," of file ",current_fn
C Now we need to get the ingest darta structures that
C describe each parameter stored in the rays. These are
C sotired in data blocks, so first read the raw product
C block header, then the ingest structures.
C also increment ntasweep here
Cout	if(iray .eq. 1) then
	   ntasweep = ntasweep + 1
           write(6,*)'incrementing ntasweep and = ',ntasweep
	   call read_iris_sweep_start(swp_lu, swapped, read_stuff,
     +		rpbh, idh(1), num_fields, nrem, tot_read)
	    num_rays = idh(num_fields)%expected_num_rays
C Need to updat sweep start time from ingest data header,
C especially for files with multiple sweeps. mod 13 july 2012
	date_time = idh(1)%date
	call read_time_structure(6, iyear, month, iday,
     +		 ih, im, is, is100, date_time )
	time = date_time%seconds + is100 * 0.01

C get mod julian day to check for midnight crossing
	call cal_to_mjd(iyear,month,iday, jday)
	if(jday .gt. flight_jday) then
	  time = time + 86400.0
cout	  crossed_midnight = .true.
	else if(crossed_midnight) then
	  time = time + 86400.0
	end if
	sweep_start = time
C added stuff to keep the data types so
	     num_data_types = num_fields
	     do i = 1, num_fields
		sweep_data_types(i) = idh(i)%data_type
	     end do
C
Cout	end if

C finally read the rays and expand the data, including the extended headers
C note that if there is an error in this loop, probably 
C an i/o error caused by a truncated fiel. then we
C break lut and reset num_rays to the numver of rays read before the errpr
	  num_good_rays = 0
	  do i = 1, num_rays
D	   write( 6, '("ray # ", i3, 58("=") )'), i
           write(6,*)'calling read_iris_tdr_ray'
	   call read_iris_tdr_ray( swp_lu, swapped, read_stuff,
     +		vel_nyq, idh(1), rpbh, rh(i), 
     +		air_hdr(i), dBZ_sweep(1,i), 
     +		vel_sweep(1,i), wid_sweep(1,i), 
     +		data_sel_flags,num_fields, nrem, 
     +		tot_read,io_error)
            write(6,*)'io_error = ',io_error
	    if(io_error .ne. 1) then
		write(6,*)'err in reading ray ',i,io_error
		go to 333
	    else
		num_good_rays = num_good_rays + 1
	    end if

	    if( rh(i)%num_bins_in_ray .gt. 0 ) then
	      call  read_TDR_hdr(0, air_hdr(i) )
	      num_bins = rh(i)%num_bins_in_ray
C update time
	      ray_time(i) = sweep_start + 
     +		air_hdr(i)%time_since_sweep_start * 0.001
	   else
	     ray_time(i) = -1.0
	   end if
D	write(6,*)'Ray time ',i,ray_time(i)
	 end do
C We read one sweep.
C There may be trailing zerps at end of sweep that
C we need to read before getting the next sweep
C in a multi-sweep file.
	if(nrem .gt. 0) then
	 call skip_iris_words(swp_lu, nrem)
	 nrem = 0
	end if
C veware thtat thiscould blow up if code skipped to 333 before sweep was finished@@@
333	 num_rays = num_good_rays
	  sweep_filled = .true.
        write(6,*)'i got here 2'
c find start ray number
	time_start = 1440000.0
	time_end = -time_start
	  do i = 1, num_rays
	     if( ray_time(i) .ge. 0.0) then
		if(ray_time(i).lt.time_start) then
			time_start = ray_time(i)
			ifirst_ray = i
		end if
		if(ray_time(i).gt.time_end) then
			time_end = ray_time(i)
			last_ray = i
		end if
	     end if
	 end do
cd	write(6,*)'First and last ray ',ifirst_ray, last_ray
C now use first and last ray to figure out totation and load
        write(6,*)'i got here 2b'
	if( ifirst_ray .gt. last_ray)then
C widdershins (counter-clockwise)
	  iray = 1
	  do i = ifirst_ray, num_rays
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  do i = 1, last_ray
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  do i = last_ray+1, ifirst_ray, 1
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  iray = 1 ! reset to first ray
C 
	else if( ifirst_ray .lt. last_ray)then
C clockwise
	  iray = 1
	  do i = ifirst_ray, 1, -1
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  do i = num_rays, last_ray, -1
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  do i = last_ray-1, ifirst_ray, -1
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  iray = 1 ! reset to first ray
C
	end if
C debug, dump ray_table
cd	do i = 1, num_rays
cd	  write(6,*)'Ray Table ',i,ray_table(i),ray_time(ray_table(i))
cd	end do
C 
	end if
C That ends the block to load up the sweep and ray_table.
C Now use ray table to load up the arrays etc. in the
C HRD common blocks
cd	write(6,*)'Iray, ray rable ',iray,ray_table(iray)
C
c only load extended header if ray had dara, wlse may be garbaage
        write(6,*)'i got here 3'
	if( rh(ray_table(iray))%num_bins_in_ray .gt. 0 ) then
	     call  read_TDR_hdr(0, air_hdr(ray_table(iray)) )
	     num_bins = rh(ray_table(iray))%num_bins_in_ray
c update common block
	      nbins = num_bins
C update time
C  dump weird times for  debugging

cout	   write(6,*)'ext hdr msec: ',
cout     +		air_hdr.time_since_sweep_start,
cout     +		'ray hdr sec ', rh.secs_from_start
C a midnight crossing could happen here... the 
C test would be for time > 86400.0 
C if that happens in the middle of the sweep then i guess I should update
C the dat also...aargh... it would get updated as soon as we read the next sweep
C but if i dont take care of this rare occueecne then some rays will have wrong date, oh well, here we go:
	  time = sweep_start + 
     +		air_hdr(ray_table(iray))%time_since_sweep_start * 0.001
C the following code fucks up if the next sweep file
C after this one also starts before midnigt...so comment out
C setting ceossed_midnight to true
C 16 oct 2912
cout	  if(time .ge. 86400.0)then
cout	    if(.not.crossed_midnight) then ! we just crossed
cout		crossed_midnight = .true.
cout	     end if
cout	  end if
C note that if crossed midnight,ih will now be  > 24. Is that what we want?
	  call convert_time(time, ih, im, is)
	      is100 = (time - ih*3600.0 - im * 60.0 -is) * 100
C note that i swap az and el, so first angle is the rotation, 2nd is the tilt
	     if(kindradar .eq. 1) then ! LF
	        nbinlf = num_bins
C I assume kf like a ppi. may need to change
C az ffom math to nav angles
	        elev = bam16_TO_deg(rh(ray_table(iray))%el_beg )
	        azm = bam16_TO_deg( rh(ray_table(iray))%az_beg )
	     else ! Tail radar
		nbinta = num_bins
C At least on the GIV the tail rotation
C angle is a math angle, with 0 deg starboard, 90 deg
C up , 189 deg port and 270 def down.
C Here i convert to nav angel for HRD software.
	      elev = bam16_TO_deg( rh(ray_table(iray))%az_beg )
	       azm_m = bam16_TO_deg(rh(ray_table(iray))%el_beg )
	      azm = 90.0 - azm_m
	      if(azm .lt. 0.0)azm = azm +360.0
	    end if

	  do i = 1, num_bins
	     dbzbuffer(i) = dBZ_sweep(i, ray_table(iray))
	     velbuffer(i) = vel_sweep(i, ray_table(iray))
	     widthbuffer(i) = wid_sweep(i, ray_table(iray))
	  end do 
	  do i = num_bins + 1, max_gates
	     dbzbuffer(i) = bad_val
	     velbuffer(i) = bad_val
	     widthbuffer(i) = bad_val
	  end do 

	else
C zero length rays will have prev time, 
C azm. elev ... unless first ray in sweep
		if(iray .eq. ray_table(1)) then
		  time = sweep_start
C else leave last time in common block
		end if
		do i = 1, max_gates
			dbzbuffer(i) = bad_val
			velbuffer(i) = bad_val
			widthbuffer(i) = bad_val
		end do 
		nbins = 0
		nbinta = 0
		nbinlf = 0
		ierr = -4
	end if


cout	end do !  end sweeps loop <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

	if( iray .eq. num_rays) then
	   if(isweep .lt. num_sweeps)then
		isweep = isweep + 1
		iray = 1
		sweep_filled = .false.
	   else ! done with this file
		call close_iris_file(swp_lu)
		read(lu,'(a)')current_fn
		sweep_open = .false.
		sweep_filled = .false.
	   end if
	else
		iray = iray + 1
	end if
c if vum_bins is  zero, set ierr so calling prigram can deal with it.
C This will not happen in all sweeps.
C Changed 29 July 2010 to ger another ray id
C this one bad, returning to start of sun.
	if( num_bins .eq. 0) then
Cout		ierr = -4
		go to 100
	end if
	return

	end
