/* Fortran callable code for SIGMET/Vaisala data.
 * Note that these functions only used because Fortran 90
 * on HRD's HP do not support the raw binart format. 
 * Otherwise the open, close, read and write could all 
 * be done in Fortran. P Dodge 19 Dec 2008
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
# include "iris_structures.h"
/* This is to save file pointer between calls... */
typedef struct cave { FILE *fp; } ;


void open_new_iris_file(struct cave *cave_ptr, char swp_fname[], 
	int *file_status, int strlan1)
{
int i, len;

/* ADD NULL CHARACTER TO END OF filename STRING */
len = 0;

for (i=0;i<strlen(swp_fname);i++) {
	if (isspace(swp_fname[i])) {break;}
	else {len++;}
}
swp_fname[len]='\0';
/* OPEN THE SWEEP FILE */
if ( (cave_ptr->fp = fopen(swp_fname,"wb"))==NULL) {
      printf("Can't open %s\n",swp_fname);
     *file_status = 0;
}
else *file_status = 1;
return;
}
void open_iris_file(struct cave *cave_ptr, char swp_fname[], int *file_status, int strlan1)
{
int i, len;

/* ADD NULL CHARACTER TO END OF filename STRING */
len = 0;

for (i=0;i<strlen(swp_fname);i++) {
	if (isspace(swp_fname[i])) {break;}
	else {len++;}
}
swp_fname[len]='\0';
/* OPEN THE SWEEP FILE */
if ( (cave_ptr->fp = fopen(swp_fname,"rb"))==NULL) {
      printf("Can't open %s\n",swp_fname);
     *file_status = 0;
}
else *file_status = 1;
return;
}
/* ================================================================== */
void close_iris_file(struct cave *cave_ptr)
{
	fclose(cave_ptr->fp);
	return;
}

/* ================================================================== */
void check_byte_swapping(struct cave *cave_ptr, int  *swapped)
{
	int short word, sw_word;
	int short swap_short( int short);
	
	fread(&word, sizeof(int short),1, cave_ptr->fp);

	if( (word < 0) || (word > 255) ) {

		printf(" first word in file (16 bit): %d \n",word);
		printf(" swapped first word in file (16 bit): %d \n",
		swap_short(word));

		*swapped = TRUE;

		printf(" Bytes need swapping for this machine.\n");

	}
	else {

		printf(" first word in file (16 bit): %d \n",word);
 
 		*swapped = FALSE;

		printf(" Bytes in proper order for this machine:\n");
 
	}

	rewind(cave_ptr->fp);

	return;
}
