# include <stdio.h>
# include <stdlib.h>

# include "iris_structures.h"

/* to sap stuff in prduct header 
 */
void get_product_config(FILE *infile, struct product_config *p_conf,
	int byte_swapped, int print_it)
{
	int short swap_short (int short);
	int swap_long (int);
	int i;
	void swap_time_str( struct  ymds_time *);

	fread(p_conf, sizeof(struct product_config), 1, infile);
	if(byte_swapped == TRUE) {

	p_conf->struct_hdr.struct_id = 
		swap_short(p_conf->struct_hdr.struct_id );
	p_conf->struct_hdr.format_version_num =
		 swap_short(p_conf->struct_hdr.format_version_num );
	p_conf->struct_hdr.num_bytes =
		 swap_long(p_conf->struct_hdr.num_bytes );
	p_conf->struct_hdr.reserved =
		swap_short(p_conf->struct_hdr.reserved );
	p_conf->struct_hdr.flags =
		 swap_short(p_conf->struct_hdr.flags);

	p_conf->product_type_code  =	swap_short(p_conf->product_type_code );
	p_conf->sched_code  =	swap_short(p_conf->sched_code );
	p_conf->skip_seconds  =	swap_long(p_conf->skip_seconds );
		
	swap_time_str(&p_conf->prod_gen_time );
	swap_time_str(&p_conf->file_ingest_time );
	swap_time_str(&p_conf->swp_ingest_time );
		
	p_conf->x_scale  =	swap_long(p_conf->x_scale );
	p_conf->y_scale  =	swap_long(p_conf->y_scale );
	p_conf->z_scale  =	swap_long(p_conf->z_scale );
	p_conf->x_array_size  =	swap_long(p_conf->x_array_size );
	p_conf->y_array_size  =	swap_long(p_conf->y_array_size );
	p_conf->z_array_size  =	swap_long(p_conf->z_array_size );
	p_conf->x_radar_loc  =	swap_long(p_conf->x_radar_loc );
	p_conf->y_radar_loc  =	swap_long(p_conf->y_radar_loc );
	p_conf->z_radar_loc  =	swap_long(p_conf->z_radar_loc );
	p_conf->maximum_rng  =	swap_long(p_conf->maximum_rng );

	p_conf->data_type_gen  =	swap_short(p_conf->data_type_gen );

	p_conf->data_type_input  =	swap_short(p_conf->data_type_input );

	p_conf->rad_smoother  =	swap_short(p_conf->rad_smoother );
	p_conf->num_run_times  =	swap_short(p_conf->num_run_times );
	p_conf->z_r_const  =	swap_long(p_conf->z_r_const );
	p_conf->z_r_exp  =	swap_long(p_conf->z_r_exp );
	p_conf->x_smooth  =	swap_short(p_conf->x_smooth );
	p_conf->y_smooth  =	swap_short(p_conf->y_smooth );
/* Note following can hold many different types of structures [enum?] );
 * For files on tape, though, it should only be raw_psi_struct [44 bytes], );
 *  so that is what I will declare here: );
 */
/*swap rap psi structure here. Of course if file is not raw type
 * this might  f__ up what ever else was stored here.
 */

	p_conf->raw_prod_info.data_bit_mask =
		swap_long(p_conf->raw_prod_info.data_bit_mask);
	p_conf->raw_prod_info.last_bin_rng =
		swap_long(p_conf->raw_prod_info.last_bin_rng);
	p_conf->raw_prod_info.format_conv_flag =
		swap_long(p_conf->raw_prod_info.format_conv_flag);
	p_conf->raw_prod_info.flag =
		swap_long(p_conf->raw_prod_info.flag);
	p_conf->raw_prod_info.sweep_number =
		swap_long(p_conf->raw_prod_info.sweep_number);
	for(i=0;i<6;i++) p_conf->raw_prod_info.spare[i] =
		swap_long(p_conf->raw_prod_info.spare[i]);




	for( i= 0; i < 18; i++)
	  p_conf->spare4[i] =	swap_short(p_conf->spare4[i] );

	for( i= 0; i < 14; i++)
	p_conf->spare5[i]  =	swap_short(p_conf->spare5[i] );

	for( i= 0; i < 24; i++)
	p_conf->spare6[i]  = swap_short(p_conf->spare6[i] );
	}

	if ( print_it == TRUE ) {
		printf("prod cinfig dump under construction.\n");
	}
	return;
}

/* =========================================================================
 */	

void get_product_end(FILE *infile, struct product_end *p_end,
	int byte_swapped, int print_it)
{
	int short swap_short (int short);
	int swap_long (int);
	int i;
	void swap_time_str( struct  ymds_time *);

	fread(p_end, sizeof(struct product_end), 1, infile);
	if(byte_swapped == TRUE) {


	swap_time_str(&p_end->oldest_time );

	p_end->local_ahead_gmt  =	swap_short(p_end->local_ahead_gmt );

	p_end->ahead_gmt  =	swap_short(p_end->ahead_gmt );
	p_end->lat_center  =	swap_long(p_end->lat_center );
	p_end->lon_center  =	swap_long(p_end->lon_center );
	p_end->gd_height  =	swap_short(p_end->gd_height );
	p_end->radar_ht_above_gd  =	swap_short(p_end->radar_ht_above_gd );
	p_end->prf  =	swap_long(p_end->prf );
	p_end->pulse_width  =	swap_long(p_end->pulse_width );
	p_end->sig_proc_type  =	swap_short(p_end->sig_proc_type );
	p_end->trigger_scheme  =	swap_short(p_end->trigger_scheme );
	p_end->num_samples  =	swap_short(p_end->num_samples );

	p_end->filter_num  =	swap_short(p_end->filter_num );
	p_end->wavelength  =	swap_long(p_end->wavelength );
	p_end->trunc_height  =	swap_long(p_end->trunc_height );
	p_end->first_bin_rng  =	swap_long(p_end->first_bin_rng );
	p_end->last_bin_rng  =	swap_long(p_end->last_bin_rng );
	p_end->num_output_bins  =	swap_long(p_end->num_output_bins );
	p_end->flag_word  =	swap_short(p_end->flag_word );
	p_end->num_files_used  =	swap_short(p_end->num_files_used );
	p_end->polarization_used  =	swap_short(p_end->polarization_used );

	p_end->task_fault_status  =	swap_long(p_end->task_fault_status );
	p_end->input_sites_mask  =	swap_long(p_end->input_sites_mask );
	p_end->log_filter_num  =	swap_short(p_end->log_filter_num );
	p_end->cluttermap_flag  =	swap_short(p_end->cluttermap_flag );
	p_end->lat_proj_ref  =	swap_long(p_end->lat_proj_ref );
	p_end->lon_proj_ref  =	swap_long(p_end->lon_proj_ref );
	p_end->prod_seq_num  =	swap_short(p_end->prod_seq_num );
	p_end->color_numbers[16]  =	swap_short(p_end->color_numbers[16] );
	p_end->spare3  =	swap_short(p_end->spare3 );
	p_end->ref_height  =	swap_short(p_end->ref_height );
	p_end->num_array_elem  =  swap_short(p_end->num_array_elem );

	}

	if(print_it == TRUE) {
	   	printf("prod end dump under constructiion \n");
	} 
	return;
}

/* ======================================================================== */
void swap_time_str( struct  ymds_time *time_str )
{
	int short swap_short( int short );
	int swap_long( int );
	
	time_str->seconds = swap_long(time_str->seconds);
	time_str->msec = swap_short(time_str->msec); 
	time_str->year = swap_short(time_str->year);
	time_str->month = swap_short(time_str->month);
	time_str->day = swap_short(time_str->day);

	return;
}

