/* read_iris_recirds.c - inverse functions  from write_iris_records.c
 * I mainly plan to use these Fortran callable routines to write quick look
  * programs. 1 Ictober 2009
  These functions write out the fiprst twop records of the 
 * IRIS filws. Below is the layout of these from the SIGMET
 * documentation. */
/* ================================================ */
/*
 Header Structures
from IRIS Programmers Manual, Chapter 3
product_hdr Structure

<structure_header> 		12 Bytes  ID = 27
<product_configuration> 	320 Bytes
<product_end> 			308 Bytes
Data				Size Variese
----------------------------------------------------

Ingest Header structure

<structure_header>	12 Bytes 	ID = 23
<ingest_configuration>	480 Bytes
<task_configuration>	2612 Bytes
Spare			732 Bytes
GPARM from DSP		128 Bytes
Reserved		920 Bytes
task_configuration Structure
<structure_header>	12 Bytes	ID = 22
<task_sched_info>	120 Bytes
<task_dsp_info>		320 Bytes
<task_calib_info>	320 Bytes
<task_range_info>	160 Bytes
<task_scan_info>	320 Bytes
<task_misc_info>	320 Bytes
<task_end_info>		320 Bytes
*/
/* =============================================== */
/* changed 512 to 1024 .. 8 oct 2010 */
# define MAX_TDR_DATA 1024
# define  MAX_FIELDS 10
# define BAD_VAL -999.0
# include <stdlib.h>
# include <stdio.h>
# include "iris_structures.h"
typedef struct cave {FILE *fp; };

/* read first  tecord which holds product structures 
*/
void read_iris_record_1(cave_ptr, swapped, dump_stuff, 
prod_conf, prod_end )
	struct cave *cave_ptr;
	int *swapped;
	int *dump_stuff;
	struct product_config *prod_conf;
	struct product_end *prod_end;

{
	FILE *file;
	struct struct_hdr  str_hdr;
	int nrem, i;
	int short filler;
	int byte_swapped, print_it;
	void get_product_config(FILE *, struct product_config *, int, int );
	void get_product_end(FILE *, struct product_end *, int, int );
	void get_struct_hdr(FILE *, struct struct_hdr *,int , int );
	
	nrem = BLK_LENGTH;
	filler = 0;

	file = cave_ptr->fp;
	print_it = *dump_stuff;
	byte_swapped = *swapped;


/*
	fread(&str_hdr, 
		sizeof( struct struct_hdr), 1, file); 
*/
	get_struct_hdr(file, &str_hdr, byte_swapped, print_it);

	nrem = nrem - sizeof( struct struct_hdr) / 2;

	get_product_config(file, prod_conf, byte_swapped, print_it);
	nrem = nrem - sizeof( struct product_config) / 2;

	get_product_end(file, prod_end, byte_swapped, print_it);
	nrem = nrem - sizeof( struct product_end) / 2;
/* read the rest of the firstrecord */
	for( i=0; i < nrem; i++)
	   fread(&filler, sizeof(int short), 1, file);

	return;
	}

/* read 2nd record of iris raw data file
*/
void read_iris_record_2( cave_ptr, swapped, dump_stuff, 
ingest_conf, tsk_si, tsk_dsp, 
	tsk_cal, tsk_range, tsk_scan,  tsk_misc, tsk_end, 
	tsk_rhi)
	
	struct cave *cave_ptr;
	int *swapped;
	int *dump_stuff;
	struct ingest_configuration *ingest_conf;
	struct task_sched_info *tsk_si;
	struct task_dsp_info *tsk_dsp;
	struct task_calib_info *tsk_cal;
	struct task_range_info *tsk_range;
	struct task_scan_info *tsk_scan;
	struct task_misc_info *tsk_misc;
	struct task_end_info *tsk_end;
	struct task_rhi_scan_info *tsk_rhi;

{
	FILE *file;
	struct struct_hdr str_hdr;
	int nrem, i;
	int short filler;
	int byte_swapped, print_it;
	
	file = cave_ptr->fp;
	print_it = *dump_stuff;
	byte_swapped = *swapped;
	

	nrem = BLK_LENGTH;
	filler = 0;

	str_hdr.struct_id = 27;
	str_hdr.format_version_num = 4;
	str_hdr.num_bytes = sizeof(struct struct_hdr) +
		sizeof(struct ingest_configuration) +
		sizeof(struct task_sched_info) +
		sizeof(struct task_dsp_info) +
		sizeof(struct task_calib_info) +
		sizeof(struct task_range_info) +
		sizeof(struct task_scan_info) +
		sizeof(struct task_misc_info) +
		sizeof(struct task_end_info);
	str_hdr.reserved = 0;
	str_hdr.flags = 1;


	get_struct_hdr(file, &str_hdr, byte_swapped, print_it);
	nrem = nrem - sizeof( struct struct_hdr) / 2;

	
/* read ingest config stuff
 */
	get_ingest_config(file, ingest_conf, byte_swapped, print_it);
	nrem = nrem - sizeof( struct ingest_configuration) / 2;
/* Now do the various task structures
*/

	get_struct_hdr(file, &str_hdr, byte_swapped, print_it);
	nrem = nrem - sizeof( struct struct_hdr) / 2;

	get_task_sched_info(file,tsk_si, byte_swapped, print_it);
	nrem = nrem - sizeof( struct task_sched_info) / 2;

	get_task_dsp_info(file, tsk_dsp, byte_swapped, print_it);
	nrem = nrem - sizeof( struct task_dsp_info) / 2;

	get_task_calib_info(file, tsk_cal, byte_swapped, print_it);
	nrem = nrem - sizeof( struct task_calib_info) / 2;

	get_task_range_info(file, tsk_range, byte_swapped, print_it);
	nrem = nrem - sizeof( struct task_range_info) / 2;

/* read task_scan_info. I have to do in pieces so I can stick
 * in the task_rhi 
 *		int short antenna_scan_mode;
 *		int short ang_resolution;
 *		int short spare;
 *		int short num_sweeps;
 */
	fread(&tsk_scan->antenna_scan_mode, 
		sizeof(int short), 1, file);
	fread(&tsk_scan->ang_resolution, 
		sizeof(int short), 1, file);
	fread(&tsk_scan->spare, 
		sizeof(int short), 1, file);
	fread(&tsk_scan->num_sweeps, 
		sizeof(int short), 1, file);
	nrem = nrem - 4 * sizeof( int short) / 2;
/* The following 200 bytes can hold a variety of structures:;
 * task_rhi_scan_info, task_ppi_scan_info, task_file_scan, or;
 * task_manual_scan_info:
 * int short scan_info[100];
 .*
 * read task_rhi
 */
	fread(tsk_rhi, 
		sizeof( struct task_rhi_scan_info), 
		1, file); 
	nrem = nrem - sizeof( struct task_rhi_scan_info) / 2;


	if( byte_swapped) {
		tsk_scan->antenna_scan_mode
			= swap_short(tsk_scan->antenna_scan_mode );
		tsk_scan->ang_resolution =
			swap_short(tsk_scan->ang_resolution );
		tsk_scan->spare = swap_short(tsk_scan->spare);
		tsk_scan->num_sweeps = 
			swap_short(tsk_scan->num_sweeps );
		 tsk_rhi->el_start_angle  = 
		 	swap_short( tsk_rhi->el_start_angle );
		 tsk_rhi->el_end_angle  = swap_short( tsk_rhi->el_end_angle );
		for(i=0; i < 40; i++)
			tsk_rhi->az_scan_angles[i] = 
		 	    swap_short( tsk_rhi->az_scan_angles[i] );
		for( i=0; i < 58; i++)
			tsk_rhi->spare[i] =
			   swap_short( tsk_rhi->spare[i] );

	} 
/* read rest of task scan info
 *  int short spare2[56]
 */
	for( i=0; i < 56; i++)
	   fread(&filler, sizeof(int short), 1, file);
	nrem = nrem - 56;
 
/*read  out task misc and task end
 */
	get_task_misc_info(file, tsk_misc, byte_swapped, print_it);
	nrem = nrem - sizeof( struct task_misc_info) / 2;

	get_task_end_info(file, tsk_end, byte_swapped, print_it);
	nrem = nrem - sizeof( struct task_end_info) / 2;

/* read out bytes to pad out record
 */
	for( i=0; i < nrem; i++)
	   fread(&filler, sizeof(int short), 1, file);

	return;
 
}
/* read first part of first record at behinning of sweep.
*/

void read_iris_sweep_start(cave_ptr, swapped, dump_stuff, rpbh, idh,
	num_fields, nrem, total_read)
	struct cave *cave_ptr;
	int *swapped;	
	int *dump_stuff;
	struct raw_prod_bhdr *rpbh;
	struct ingest_data_hdr *idh;
	int *num_fields;
	int *nrem;
	int *total_read;
{
	int i;
	int byte_swapped, print_it;
	FILE *file;
	void get_raw_prod_bhdr(FILE *, struct raw_prod_bhdr *,
	        int , int);
	void get_ingest_data_hdr(FILE * , struct ingest_data_hdr *,
	        int, int);
	
	*nrem = BLK_LENGTH;

	file = cave_ptr->fp;
	print_it = *dump_stuff;
	byte_swapped = *swapped;

	get_raw_prod_bhdr(file,  rpbh,
	        byte_swapped, print_it);
	*nrem = *nrem - sizeof(struct raw_prod_bhdr) / 2;
	*total_read = *total_read + sizeof(struct raw_prod_bhdr) / 2;
/* note yjat idh++ incremnts the pointer it the next idh structure
 * if enough idh structures were not allocatedin the main this will provavly bow up here.
 * I depend on the calling program to have checked for this problem 
 * befor calling this routine.
 */
	for( i = 0; i < *num_fields; i++) {
		get_ingest_data_hdr(file , idh,
			byte_swapped, print_it);
	        *nrem = *nrem - sizeof(struct ingest_data_hdr) / 2;
	        *total_read = *total_read + sizeof(struct ingest_data_hdr) / 2;
	        idh++;
	}
return;
}

/* =======================================================================
*/

/* READ all the data contained in one ray and expand the data into float arrays
 * to pass beck to the. Code  is written to be Fortran 90 callable
 */

void read_iris_tdr_ray( cave_ptr, swapped, dump_stuff, vel_nyq, idh, rpbh, rh, 
ext_hdr, dbz, vel, wid, data_sel_flags, num_fields, nrem, tot_read,io_error)
	struct cave *cave_ptr;
	int *swapped;
	int *dump_stuff;
	float *vel_nyq;
	struct ingest_data_hdr *idh;
	struct raw_prod_bhdr *rpbh;
	struct ray_hdr *rh;
	struct TDR_hdr *ext_hdr;
	float dbz[MAX_TDR_DATA];
	float vel[MAX_TDR_DATA];
	float wid[MAX_TDR_DATA];
	int data_sel_flags[3];
	int *num_fields;
	int *nrem;
	int *tot_read;
	int *io_error;

{
	int i, ii;
	FILE *infile;
	int print_it, byte_swapped;
	int ray_error_status;
	int n_wds_in_ray, exp_error;
	int short ray_word[MAX_WDS];	
	float ray_data[MAX_DATA];
	float scaling;
	float data_min, data_max;
	int  get_ray( );

	infile = cave_ptr->fp;
	byte_swapped = *swapped;
	print_it = *dump_stuff;

	if(print_it == 1) {
	  printf("in read_iris_tdr_ray. num_fields %d \n", *num_fields);
	  fflush( stdout );
	}

	 for(i=0; i < *num_fields; i++)
	 {
	   if(print_it == 1) {
	  	printf("calling get_ray. fiel # %d \n", i);
	  	fflush( stdout );
	   }
	   ray_error_status = get_ray(infile, rh,  rpbh, ray_word,
			byte_swapped, print_it,
			nrem, tot_read);
	   if(ray_error_status == -1) {
/* Empty ray. In this case ray header was not loaded so set 
 * numner of bins to 0 so following logic workls
 */
 		rh->num_bins_in_ray = 0;
	   	}
	   else if(ray_error_status != 1) {
/* some bad sh** happened whil reading ray.. so bail out of here */
	   	  printf("Crap! get_ray error %d for field %d \n",
	   		ray_error_status, i);
	   	  *io_error = -1;
	   	  return;
	   	}
	   if(idh->data_type == DB_XHDR) {
		if (rh->num_bins_in_ray == 1 ) {
	   if(print_it == 1) {
	  	printf("Loading TDR hdr \n");
	  	fflush( stdout );
	   }

			load_TDR_hdr(ray_word, ext_hdr, 
				byte_swapped, print_it);
			}
		}
	   else {
	        if( idh->bits_per_bin == 8)
	   		n_wds_in_ray = (rh->num_bins_in_ray + 1)/2;
	   	else
	   		n_wds_in_ray = rh->num_bins_in_ray;

/* 8 bit Doppler  is svaled by Nyquist vel, 16 bit is not. 8 vit SW are 
 * similatly sclaed 
  */
		if(idh->data_type == DB_VEL) scaling = *vel_nyq;
		else scaling = 1.0;
	   expand_ray( ray_word, ray_data, n_wds_in_ray, 
	   	rh->num_bins_in_ray,
	   	idh->bits_per_bin, idh->data_type, scaling, &exp_error);


/* Now load the real data into the apropriate array
 * Use the desired data types storied in data_sel_flags,
 * where the first flag indicates hat
 * to load into the dBZ array, second flad the velocity buffer, and
 * the thirs flag iidicates what to load in width buffer.
 * This mod added 27 Oct 2011
 */

	    if(idh->data_type == data_sel_flags[0] ) {

		for(ii = 0; ii<rh->num_bins_in_ray; ii++) {
		   if(ray_data[ii] > -999.0) {
			dbz[ii] = ray_data[ii];
		   }
		   else
			dbz[ii] = BAD_VAL;
		}
		for(ii = rh->num_bins_in_ray; ii<MAX_TDR_DATA; ii++) {
			dbz[ii] = BAD_VAL;
		}
	   }
	   else if(idh->data_type == data_sel_flags[1] ) {

		for(ii = 0; ii<rh->num_bins_in_ray; ii++) {
		   if(ray_data[ii] > -999.0) {
			vel[ii] = ray_data[ii];
		   }
		   else
			vel[ii] = BAD_VAL;
		}
		for(ii = rh->num_bins_in_ray; ii<MAX_TDR_DATA; ii++) {
			vel[ii] = BAD_VAL;
		}
	   }
	   else if(idh->data_type == data_sel_flags[2] ) {

		for(ii = 0; ii<rh->num_bins_in_ray; ii++) {
		   if(ray_data[ii] > -999.0) {
			wid[ii] = ray_data[ii];
		   }
		   else
			wid[ii] = BAD_VAL;
		}
		for(ii = rh->num_bins_in_ray; ii<MAX_TDR_DATA; ii++) {
			wid[ii] = BAD_VAL;
		}
	   }

/* get min and max data val, print in grep-able string
 */
		data_max = -9999.9;
		data_min = -data_max;
		for(ii = 0; ii<rh->num_bins_in_ray; ii++) {
		   if(ray_data[ii] > -999.0) {
			if(ray_data[ii] < data_min) data_min = ray_data[ii];
			if(ray_data[ii] > data_max) data_max = ray_data[ii];
		   }
		}
		if(print_it) {
		   if(rh->num_bins_in_ray > 0 )
			printf("Ray data type %d min: %f max: %f \n",
			idh->data_type, data_min, data_max);
		   else printf("Ray is empty \n");
		}
	} /* extended header vs other data type block */
/* inc ptr to idh structures */
	idh++;
	 } /* Fields loop*/
	 fflush(stdout);
/* well, if we got here we successfully, so set
 io_error = 1
 */
 *io_error = 1;
 
return;
}


