      PROGRAM SWEEP_TESTER
c This is a routine modified from Peter Dodge's radar_rvp8_read that is
c designed specifically to examine whether there are enough good rays in a
c sweep that have enough data to produce a ray with enough flight-level,
c reflectivity, and velocity data to indicate there is at least a sea-surface
c reflection.  For this reason, the present threshold is set at 50 rays.
	implicit none 
	integer lu,KINDRADAR,IHEADERFLAG,IDATAFLAG,lflt
	integer IERR,LU_ERRORS,kl,n_good_rays,igoodray,luout,isum
        integer igoodvel,igooddbz,igoodwid,igoodflight
        integer igoodvels,igooddbzs,igoodwids,igoodflights
        integer enough_good_rays
	include "iris_f90_structures.h"
	include "TDR_hdr_f90.h"
	include "sigmet_dsp_data_types_f90.h"
	include "hrd_radar_common_blocks.f"

	integer max_rays, max_gates

	parameter(max_rays = 500, max_gates = max_hrd_dim)

C IRiS files probalby only hold 5 or less but  I keep it  big just in case...


	integer*4 swapped, read_stuff
	character*132 sweep_fn, outputlisting, ctimelist*6
C pointers are 8 byte on 64 bit machines
	integer*8 swp_lu
	integer*4 iostat
	integer*4 nrem, tot_read
        integer*4 j
        character*80 radarfile
					
	type (struct_hdr) str_hdr
	type (product_config) prod_conf
	type (product_end) prod_end
	type (ingest_configuration) i_config
	type (task_sched_info) t_si
	type (task_dsp_info) t_dsp
	type (task_calib_info) t_calib
	type (task_range_info) t_range
	type (task_scan_info) t_scan

	type (ymds_time) start_time_str
	type (ymds_time) end_time_str
	type (ymds_time) date_time
	
	type (task_misc_info) t_misc
	type (task_end_info) t_end

	type (task_rhi_scan_info) t_rhi
	type (task_ppi_scan_info) t_ppi
	
	type (ingest_data_hdr) idh(MAX_FIELDS) !)* should be more general! */
	type (raw_prod_bhdr) rpbh
cout.	type (ray_hdr) rh
cout	type (TDR_hdr) air_hdr
	type (ray_hdr) rh(max_rays)
	type (TDR_hdr) air_hdr(max_rays)

C and here are the arrays for the pther data types:
cout	real dbz(max_gates), dop(max_gates), wid(max_gates)
C instead use the arrats contained in the radardata common block

C HRD radar tape/file data structures
C Radar tape/file stuff
C 

c note the read_* suntoutines will fill the varaibles intse
C common blocks
	logical tail_fore, tail_aft
	logical french_antenna
	character*1 antenna_type
C Here is the common blick that holks
C file pointer, file status, and file neme
	common/rvp8_files/sweep_open,
     *		current_fptr,
     +		current_fn
C
	logical*8 sweep_open
C 64 bit machines use 8 byte pointers
	integer*8 current_fptr
	character*132 current_fn
C Added this to remember whether ine sweep arrays have been filled
	logical sweep_filled
C and na array with times for eaxh ray. Depinding on whether
C is rotating clockwise or counter
	real ray_time(max_rays)
	integer irot_dir
	integer ray_table(max_rays)
c Here are the arrays
	real dBZ_sweep(max_gates, max_rays)
	real vel_sweep(max_gates, max_rays)
	real wid_sweep(max_gates, max_rays)
C for flexibility, added flags for what types of data
C are stored in ref, vel and width arrays. Note that these
C flags are set in the first sub in this set
	common /rvp8_data_flags/data_sel_flags,
     +		num_data_types, sweep_data_types
	integer*4 data_sel_flags(3)
	integer*4 num_data_types, sweep_data_types(10)

C and save in a common block
c lets change to save instead of common for ray_table
c	common/ stash /ray_table,
Cout     +		rh, air_hdr,
c     +		dBZ_sweep, vel_sweep, wid_sweep
C
	real bam16_TO_deg
	real bad_val
	integer iray, isweep, ifirst_ray, last_ray
	integer num_bins, num_good_rays,io_error
	integer num_rays, num_fields, num_sweeps
	integer i, ii, itemp
	real vel_nyq, wavelength
	real sweep_start, time_start, time_end, azm_m
C save th rh and air_hdr arrays... hp f90 woiln not
C let me put them in common , althoigh it woild when
C they were declared using the record syntac. ke garne...
	save rh, air_hdr
C and save these variables between calls
	save num_rays, num_sweeps,iray, isweep, swapped
	save rpbh, idh, num_fields, nrem, tot_read
	save sweep_start
	save sweep_filled
	save ray_table
	save ray_time
	save dBZ_sweep, vel_sweep, wid_sweep
C added to keep track of midnight crossing for 
c 48 h clock...
C
	COMMON /midnight/crossed_midnight,flight_jday
	integer*4 jday, flight_jday
	logical*8 crossed_midnight
C

	bad_val = -999.0

        call getarg(1,sweep_fn)
        enough_good_rays = 50
	luout=23
c        open(23,file='/dev/null')
        open(23,file='outputlisting')
        lflt=24
        open(24,file='flight_level_output',position='append')
	read_stuff = 0 ! set to  1 to get massive dump of info
c	read_stuff = 1
C set ierr to succesful read initially
	ierr = 0
c Set legacy rvp5 code ised by taycor subroitine
	icode = 0
        kindradar = 2
	icode = ibset(icode,15) ! dBZ
	icode = ibset(icode,14) ! vel
	icode = ibset(icode,13) ! spec edth
	if(kindradar .eq. 1)then
		icode = ibset(icode,11)
	else if(kindradar .eq. 2) then
		icode = ibset(icode,12)
	end if
C
C I had to ass a way to loop back here
C when I read an empty ray (nbins = 0). Previously
C I woild return an ampty ray with ierr= -4, boy other
C HRD code did not check those, and emtyrays had bad times and lat,lons
C so now I will kiip readin intil I get a giid ray) What a tangled web this
C code had become... 29 July 2010
C
C        WRITE(6,*)'ENTER SWEEP DIRECTORY NAME WITH TRAILING SLASH'
C        READ(5,'(A)')RADARFILE
C        LU_ERRORS=6
C
c You need to call substitute_open_rvp8_file to set up for the sweep read
        SWP_LU=87
        CALL SET_UP_SWEEP_ARRAYS(SWP_LU,LU_ERRORS,IERR)
c        WRITE(luout,*)'IERR = ',IERR
c        WRITE(6,*)'ENTER SWEEP FILE NAME'
c        READ(5,'(A)')SWEEP_FN
c        write(luout,*)'one'
c        write(luout,*)'two'
        CALL OPEN_IRIS_FILE(SWP_LU,SWEEP_FN,IOSTAT)
c        write(luout,*)'three'
c        write(luout,*)'four'
c        WRITE(luout,*)'IOSTAT = ',IOSTAT
c	   sweep_fn = current_fn
c           WRITE(luout,*)'CALLING OPEN_IRIS_FILE'
c           WRITE(6,*)'CALLING OPEN_IRIS_FILE'
	   call open_iris_file(swp_lu, sweep_fn, iostat)
c           WRITE(6,*)'RETURNED FROM OPEN IRIS FILE'
c           WRITE(luout,*)'RETURNED FROM OPEN IRIS FILE'
C	write(6,*)iostat,' iostat opening ', sweep_fn
C	write(6,*)' returned file pointer ', swp_lu
	if(iostat .ne. 1) then
		stop ' Coild not open file. adios '
	else
		write(luout,*) "Opened sweep file", sweep_fn
		write(luout,*)'swp_lu (ptr to file desc) ',swp_lu
	end if
	   current_fptr = swp_lu
	   sweep_open = .true.

C	call flush(6)
c comment out to see if it  fucckig up
	swapped = 0 ! bytes not swapped   
Cout	call check_byte_swapping(swp_lu, swapped)
C Following for HP Unix big endian machines
Cout	swapped = 1 ! bytes  swapped
C
c        WRITE(6,*)'CALLING READ_IRIS_RECORD'
	call read_iris_record_1(swp_lu, swapped, read_stuff,
     +		prod_conf, prod_end )
c        WRITE(6,*)'RETURNED FROM READ_IRIS_RECORD'
C	write(6,*)' read first record'
C	call flush(6)
C note i donot trust sweep number in raw_psi so i use my own
	itemp = ntasweep
c        write(6,*)'calling read_product_hdr'
	call read_product_hdr(0, prod_conf, prod_end)
c        write(6,*)'returned from read_product_hdr'
C restore sweeop number
	ntasweep = itemp
	call read_iris_record_2(swp_lu, swapped, read_stuff, 
     +		 i_config, t_si, 
     +		t_dsp, t_calib, t_range, t_scan,  t_misc, t_end,
     +		t_rhi)
C	write(6,*)' Read record 2'
C load tot_read, whick is updated by subsequent
C calls to read the sweep file
	tot_read = 2 * BLK_LENGTH
C
c        write(6,*)'calling read_task_hdr'
	call read_task_hdr(0, t_si, t_dsp, t_calib,
     +		t_range, t_scan, t_misc, t_end, 
     +		t_rhi)
c        write(6,*)'returned from read_task_hdr'
c	write(6,*)'in radar_rvp8_read and t_dsp%xmt_phase_sec = ',
c     +  t_dsp%xmt_phase_seq
C	call flush(6)

C load up bin length in common clock, in km
C rvp5 supportes 3 diff ht laengrhs, so need here
C for legaxy
	if( kindradar .eq. 1 ) then
	  gtlnlf = t_range%output_step * 0.00001
	  rdellf = t_range%first_bin_range * 0.00001
	  rmaxlf = t_range%last_bin_range * 0.00001
	  ivrangelf = 0
	  idradar = 1
	else
	  do ii = 1, 3
	     gtlnta(ii) = t_range%output_step *0.00001
	  end do
	  rdelta = t_range%first_bin_range * 0.00001
	  rmaxta = t_range%last_bin_range * 0.00001
	  ivrangeta = 0
	  idradar = 2
	end if
C get Nyquist vel from stuff stored in tasd header structures in m/x
cout	vel_nyq = t_misc%wavelength * 0.0001 * t_dsp%prf * 0.25
	wavelength= t_misc%wavelength * 0.0001
	call get_nyq_vel(t_dsp%prf_mode, t_dsp%prf,wavelength,vel_nyq )


c	write(6, *)"Nyquist velocity ",vel_nyq," m/s"
	if( kindradar .eq. 1 ) then
		xniqlf = vel_nyq
	else
		xniqta = vel_nyq
	end if

C There  may be multiple sweeps per file (although I hpe not ) so
C I need a do loop here.
C
	num_sweeps = t_scan%num_sweeps
C num_assoc_files is ALL files used to make this file
C and so holds num_fileds x num_
C No that is wrong, evidently, so i took out the fivide by num_sweeps.
C 16 June 2015
C
	num_fields = i_config%num_assoc_files
C	write(6,*)'Number fields, sweeps ',num_fields, num_sweeps
C End of iniital file records block
C prime pumps
        ntasweep=0
	isweep = 1
	iray = 1
	sweep_filled = .false.
C save sweep_start time to use in getting ray time
	    sweep_start = time
C which ray is actually the first ray, in tume.
c	if( .not.sweep_filled) then
C If moltiplesweeps per file, we can't read them all in at
C read thrm all in at the same time, would be a qaste of space
C instead isweep and num_sweeps are caved and checked
cout	do isweep = 1, num_sweeps !  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
cout	   write(6,*)" *** Sweep # ",isweep," of file ",current_fn
C Now we need to get the ingest darta structures that
C describe each parameter stored in the rays. These are
C sotired in data blocks, so first read the raw product
C block header, then the ingest structures.
C also increment ntasweep here
Cout	if(iray .eq. 1) then
	   ntasweep = ntasweep + 1
c           write(6,*)'calling read_iris_sweep_start'
	   call read_iris_sweep_start(swp_lu, swapped, read_stuff,
     +		rpbh, idh(1), num_fields, nrem, tot_read)
	    num_rays = idh(num_fields)%expected_num_rays
c            write(6,*)'returned from read_iris_sweep_start'
C Need to updat sweep start time from ingest data header,
C especially for files with multiple sweeps. mod 13 july 2012
	date_time = idh(1)%date
c        write(6,*)'calling read_time_structure'
	call read_time_structure(0, iyear, month, iday,
     +		 ih, im, is, is100, date_time )
c        write(6,*)'returned from read_time_structure'
	time = date_time%seconds + is100 * 0.01

C get mod julian day to check for midnight crossing
	call cal_to_mjd(iyear,month,iday, jday)
	if(jday .gt. flight_jday) then
	  time = time + 86400.0
cout	  crossed_midnight = .true.
	else if(crossed_midnight) then
	  time = time + 86400.0
	end if
	sweep_start = time
C added stuff to keep the data types so
	     num_data_types = num_fields
	     do i = 1, num_fields
		sweep_data_types(i) = idh(i)%data_type
	     end do
C
Cout	end if

C finally read the rays and expand the data, including the extended headers
C note that if there is an error in this loop, probably 
C an i/o error caused by a truncated fiel. then we
C break lut and reset num_rays to the numver of rays read before the errpr
	  num_good_rays = 0
	  do i = 1, num_rays
C	   write( 6, '("ray # ", i3, 58("=") )'), i
cout           write(6,*)'calling read_iris_tdr_ray'
	   call read_iris_tdr_ray( swp_lu, swapped, read_stuff,
     +		vel_nyq, idh(1), rpbh, rh(i), 
     +		air_hdr(i), dBZ_sweep(1,i), 
     +		vel_sweep(1,i), wid_sweep(1,i), 
     +		data_sel_flags,num_fields, nrem, 
     +		tot_read,io_error)
cout            write(6,*)'io_error = ',io_error
c            write(6,*)'i got here 1'
	    if(io_error .ne. 1) then
		write(luout,*)'err in reading ray ',i,io_error
		go to 333
	    else
		num_good_rays = num_good_rays + 1
c             write(6,*)(wid_sweep(j,i),j=1,100)
	    end if
c            write(6,*)'i got here 2'
	    if( rh(i)%num_bins_in_ray .gt. 0 ) then
	      call  read_TDR_hdr(0, air_hdr(i) )
	      num_bins = rh(i)%num_bins_in_ray
C update time
	      ray_time(i) = sweep_start + 
     +		air_hdr(i)%time_since_sweep_start * 0.001
	   else
	     ray_time(i) = -1.0
	   end if
C	write(6,*)'Ray time ',i,ray_time(i)
	 end do
c        write(6,*)'Inside ray and dbz = '
c        write(6,6296)(dbz_sweep(j,i),j=1,num_bins)
c	write(6,*)'Inside ray and vel = '
c        write(6,6296)(vel_sweep(j,i),j=1,num_bins)
c	write(6,*)'Inside ray and width = '
c        write(6,6296)(wid_sweep(j,i),j=1,num_bins)
c 6296	format(10f8.2)
	if(nrem .gt. 0) then
	 call skip_iris_words(swp_lu, nrem)
	 nrem = 0
	end if
C veware thtat thiscould blow up if code skipped to 333 before sweep was finished@@@
333	 num_rays = num_good_rays
	  sweep_filled = .true.
c find start ray number
	time_start = 1440000.0
	time_end = -time_start
	  do i = 1, num_rays
	     if( ray_time(i) .ge. 0.0) then
		if(ray_time(i).lt.time_start) then
			time_start = ray_time(i)
			ifirst_ray = i
		end if
		if(ray_time(i).gt.time_end) then
			time_end = ray_time(i)
			last_ray = i
		end if
	     end if
	 end do
cc	write(6,*)'First and last ray ',ifirst_ray, last_ray
C now use first and last ray to figure out totation and load
	if( ifirst_ray .gt. last_ray)then
C widdershins (counter-clockwise)
	  iray = 1
	  do i = ifirst_ray, num_rays
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  do i = 1, last_ray
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  do i = last_ray+1, ifirst_ray, 1
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  iray = 1 ! reset to first ray
C 
	else if( ifirst_ray .lt. last_ray)then
C clockwise
	  iray = 1
	  do i = ifirst_ray, 1, -1
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  do i = num_rays, last_ray, -1
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  do i = last_ray-1, ifirst_ray, -1
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  iray = 1 ! reset to first ray
C
	end if
c set the accumulators of number of rays with good flight-level data,
c velocities, dbzs, and widths
        igoodflights=0
        igoodvels=0
        igooddbzs=0
        igoodwids=0
        n_good_rays=0
c this is a modification of Peter Dodge's code so we just do one sweep
c for each invocation of this program
        do iray=1,num_rays
	if( rh(ray_table(iray))%num_bins_in_ray .gt. 0 ) then
	     call  read_TDR_hdr(0, air_hdr(ray_table(iray)) )
	     num_bins = rh(ray_table(iray))%num_bins_in_ray
c update common block
	      nbins = num_bins
	  time = sweep_start + 
     +		air_hdr(ray_table(iray))%time_since_sweep_start * 0.001
C the following code fucks up if the next sweep file
C after this one also starts before midnigt...so comment out
C setting ceossed_midnight to true
C 16 oct 2912
cout	  if(time .ge. 86400.0)then
cout	    if(.not.crossed_midnight) then ! we just crossed
cout		crossed_midnight = .true.
cout	     end if
cout	  end if
C note that if crossed midnight,ih will now be  > 24. Is that what we want?
	  call convert_time(time, ih, im, is)
	      is100 = (time - ih*3600.0 - im * 60.0 -is) * 100
C note that i swap az and el, so first angle is the rotation, 2nd is the tilt
	     if(kindradar .eq. 1) then ! LF
	        nbinlf = num_bins
C I assume kf like a ppi. may need to change
C az ffom math to nav angles
	        elev = bam16_TO_deg(rh(ray_table(iray))%el_beg )
	        azm = bam16_TO_deg( rh(ray_table(iray))%az_beg )
	     else ! Tail radar
		nbinta = num_bins
C At least on the GIV the tail rotation
C angle is a math angle, with 0 deg starboard, 90 deg
C up , 189 deg port and 270 def down.
C Here i convert to nav angel for HRD software.
	      elev = bam16_TO_deg( rh(ray_table(iray))%az_beg )
	       azm_m = bam16_TO_deg(rh(ray_table(iray))%el_beg )
	      azm = 90.0 - azm_m
	      if(azm .lt. 0.0)azm = azm +360.0
	    end if
            write(luout,*)'xniqta = ',xniqta
            write(luout,*)'num_rays = ',num_rays
c set indicators for whether is ray is good or not
            igoodray=0
            igoodvel=0
            igooddbz=0
            igoodflight=0
            if(wd.gt.-400..and.ws.gt.-400.and.vws.gt.-400.)go to 901
            write(luout,*)'iray problem with wd, ws or vws',iray
            go to 906
 901        if(elev.gt.-400..and.azm.gt.-400)go to 902
            write(luout,*)'iray problem with elev or azm',iray
            go to 906
 902        if(pitch.gt.-400..and.roll.gt.-400.)go to 903
            write(luout,*)'iray problem with pitch or roll',iray
            go to 906
 903        if(heading.gt.-400.and.drift.gt.-400.)go to 904
            write(luout,*)'iray problem with heading or drift',iray
            go to 906
 904        if(ra.gt.0..and.rlat.gt.-200..and.rlon.gt.-200.)go to 905
            write(luout,*)'iray problem with ra, lat, or lon',iray
            go to 906
 905        igoodflights=igoodflights+1
            igoodflight=1
 906        isum=0
            do j=35,600
               if(vel_sweep(j,iray).gt.-200.) then
c                  write(luout,*)'j,iray,vel = ',j,iray,vel_sweep(j,iray)
c                  write(luout,*)'isum = ',isum
                  isum=isum+1
                  if(isum.gt.2)then
c                     write(luout,*)'isum must equal 3'
                     go to 911
                  endif
               else
                  isum=0
               endif
            enddo
c            write(luout,*)'iray problem with vel ',iray
            go to 921
 911        igoodvels=igoodvels+1
            igoodvel=1
 921        isum=0
            do j=35,600
               if(dBZ_sweep(j,iray).gt.-200.) then
c                  write(luout,*)'j,iray,dBZ = ',j,iray,dBZ_sweep(j,iray)
c                  write(luout,*)'isum = ',isum
                  isum=isum+1
                  if(isum.gt.2)then
                     write(luout,*)'isum must equal 3'
                     go to 912
                  endif
               else
                  isum=0
               endif
            enddo
            write(luout,*)'iray problem with dbz',iray
            go to 922
 912        igooddbzs=igooddbzs+1
            igooddbz=1
 922        isum=0
            do j=35,600
               if(wid_sweep(j,iray).gt.-200.) then
c                  write(luout,*)'j,iray,wid = ',j,iray,wid_sweep(j,iray)
c                  write(luout,*)'isum = ',isum
                  isum=isum+1
                  if(isum.gt.2)then
                     write(luout,*)'isum must equal 3'
                     go to 913
                  endif
               else
                  isum=0
               endif
            enddo
            write(luout,*)'iray problem with width',iray
            go to 920
            write(luout,*)'setting igoodray to 1'
 913        igoodwids=igoodwids+1
            igoodwid=1
            if(igoodflight.eq.1.and.igoodvel.eq.1.and.igooddbz.eq.1)
     +        igoodray=1
 920        write(luout,*)'igoodray = ',igoodray
            if(igoodray.eq.1)n_good_rays=n_good_rays+1
c            write(luout,*)'igoodray,n_good_rays = ',igoodray,n_good_rays
c            write(luout,*)'velocity = ',(vel_sweep(kl,iray),kl=1,600)
c            write(luout,*)'dbz = ',(dBZ_sweep(kl,iray),kl=1,600)
c            write(luout,*)'width = ',(wid_sweep(kl,iray),kl=1,600)
c            write(luout,*)'iray,nbins = ',iray,nbins
c            write(6,*)'luout = ',luout
            write(ctimelist,'(3i2.2)')ih,im,is
            write(lflt,*)
     +   'time,rlat,rlon,wd,ws,vws,ircu,elev,azm,pitch,roll,heading =',
     +                   ctimelist,rlat,rlon,
     +         wd,ws,vws,ircu,elev,azm,pitch,roll,heading
            write(lflt,*)'time,gs,gse,gsn,ra = ',ctimelist,gs,gse,gsn,ra
        endif
        enddo
c        write(6,*)'n_good_rays = ',n_good_rays
c        write(6,*)'igoodflights,igoodvels,igooddbzs,igoodwids = ',
c     +             igoodflights,igoodvels,igooddbzs,igoodwids
        if(igoodflights.lt.enough_good_rays)then
           write(6,401)
 401       format('failed flight-level')
        else
           write(6,402)
 402       format('passed flight-level')
        endif
        if(igooddbzs.lt.enough_good_rays)then
           write(6,403)
 403       format('failed reflectivity')
        else
           write(6,404)
 404       format('passed reflectivity')
        endif
        if(igoodvels.lt.enough_good_rays)then
           write(6,405)
 405       format('failed velocity')
        else
           write(6,406)
 406       format('passed velocity')
        endif
c        if(n_good_rays.lt.50)then
c           write(6,*)sweep_fn,'failed'
c        else
c           write(6,*)sweep_fn,'passed'
c        endif
        stop
        end
