	subroutine substitute_open_rvp8_file
     +    (directory, lu, lu_errors, ierr)
C this does not open individula rvp8 files, rather it 
C opens a list of those files, su radar_rvp8_read
C and rvp8_search can fine correct weep to open.
C
C	directory (sharacter): path to sweep files directory
C	lu = logical unit number for file list file
C	lu_errors(it): logical unit for error messages
C	ierr *integera): error status
C		= p meand no errors
C		= -1  means list file is empty
C		>0 open error number fron fortran

	implicit none

	character directory*(*)
	integer*4 lu, lu_errors, ierr
C need HRD common blocks to set sweep counters
	include "hrd_radar_common_blocks.f"
 
C Hide first sweep name here, so you
C so not have to call rvp8_search to prime the pump.
	common /rvp8_files/sweep_open,
     +		current_fptr,
     +		current_fn
	logical*8 sweep_open
C 64 bit machines have 8 byte pointers
	integer*8 current_fptr
	character*132 current_fn, sweep_fn
	character command*132
	integer ibeg,iend,nc,i
	integer year,day
	character skip_string*8

C header flags:
	integer*4 nav_flag, alt_flag, attitude_flag,
     +	   gdspd_flag, wind_flag
C added a common to pass data type flags. These are used
C to determine which data type gets written in eacd array.
C in this subtoutine we set defaults...these can be changed
C after calling this subroutine.
	include "sigmet_dsp_data_types_f90.h"
	common /rvp8_data_flags/data_sel_flags,
     +		num_data_types, sweep_data_types
	integer*4 data_sel_flags(3)
	integer*4 num_data_types, sweep_data_types(10)

C More stuff, to deal with midnight crossing
C and whether or not to use 48 h clock...
C in this routine , set crossed_midnight false and
C flight_jday to date of first file. then user
C can reset if she knows filightid is less ghtn currect day...
C
	COMMON /midnight/crossed_midnight,flight_jday
	integer*4 jday, flight_jday
	logical*8 crossed_midnight
        include "nav_fix_common.f"
        character*132 corrections_fn
        logical exists
C data type defaults:
	data_sel_flags(1) = DB_DBZ2
	data_sel_flags(2) = DB_VEL2
	data_sel_flags(3) = DB_SQI2
C set num data types to zero until we have
C actually read a file to know what is in the rays.
        write(6,*)'entered substitute_open_rvp8_file'
c        pause
        time_saver = 0.
	num_data_types = 0
	do i = 1, 10
	  sweep_data_types(i) = -1
	end do


	command = " "
C note modified command string to sort
C list...so that master (nrm*.RA@) and slave
C (nrs*.RAW) will be properly interleaved in the
C list
	nc = len(trim(directory)) + 4
	skip_string = ' '
	if(nc .lt. 10) then
	   write(skip_string,"(' -k 1.',i1,1x)")nc
	else
	   write(skip_string,"(' -k 1.',i2,1x)")nc
	end if
c	command = 'ls ' // trim(directory)
c     +	   //'*RAW* | sort'//skip_string//'  > sweeps_list'
cout	print command
c	call system(command)
C get number of lines
C

	open(lu, file = 'sweeps_list',form='formatted',
     +		iostat = ierr)

	read(lu, '(a)')current_fn
	rewind( lu )
	sweep_open = .false.
C
C initialize sweep cointers in hrd common blocks
C set to zero because will be incremented
C in radar_rvp8_read
	nlfsweep = 0
	ntasweep = 0
c added stuff here to set flags that determin whick
C extended headers values are used to load HRD common
C blocks.  17 Aug 2011
C For each flaf,
C	1: use inertial values ( airs )
C	2: use GPS values
C	3: use AAMPS values
C
	nav_flag = 2
	alt_flag = 2
	attitude_flag = 1
	gdspd_flag = 1
	wind_flag = 3

	call set_hdr_flags(nav_flag, alt_flag, attitude_flag,
     +	   gdspd_flag, wind_flag)
C set current jday from current_fn:
C code snipped from search (below)
c figure out wnere sweep time stats.
C full path coild be something like
C /hrd/dat/giv_radar/nov_30_test/nrm091130220905.RAWJUBV
C and the sweep files name 
C nrm091130220905.RAWJUBV
C or radyrmodahrmnsc.RAWabcd
	sweep_fn = current_fn
	i = 1
100	do while(sweep_fn(i:i) .ne. '.')
		i = i + 1
	end do
C parh may contain other "." we need to
C skip over
	if(sweep_fn(i+1:i+3).ne.'RAW')then
	  if(i.lt.132)then
		go to 100
	   else
		ierr = -6
		return
	   end if
	end if
	ibeg = i -  12 ! YEARMIDAHHMMSS 6
	iend = ibeg + 11
	read(sweep_fn(ibeg:iend), '(6i2)')year,month,day,ih,im,is
CD	write(6,*)'First file: ',sweep_fn
	time = ih*3600.0 + im * 60.0 + is

C this will fail 988 years hence..
	year = 2000 + year
	call cal_to_mjd(year,month, day,jday)
	flight_jday = jday
	crossed_midnight = .false.
C
C
C before we leave we need to see if we are applying Paul Reasors corrections:
	apply_corrections = .false.
C that is the default..now check for the magic key
	 inquire(file='corrections.txt',exist=exists)
	if(exists)then
		apply_corrections = .true.
	end if
 	if(apply_corrections)then
          write(6,*)'will open corrections.txt'
c          pause
	  open(27,file="corrections.txt",form='formatted',status='old')
	  read(27,'(a)')corrections_fn
	 	close(27)
          write(6,*)'opening ',corrections_fn
c          pause
	  open(corr_lu,file=corrections_fn,form='formatted',status='old')
          write(6,*)'opened'
c          pause
	read(corr_lu,*)
	end if
	return
	end
